<?php
/**
 * Community Polls SEF extension for Joomla!
 *
 * @author      $Author: CoreJoomla $
 * @copyright   http://www.corejoomla.com
 * @package     JoomSEF
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access.');

class SefExt_com_communitypolls extends SefExt
{
    
    function beforeCreate(&$uri) {
        // Remove the part after ':' from variables
        if( !is_null($uri->getVar('id')) )       SEFTools::fixVariable($uri, 'id');

        return;
    }
    
    function create(&$uri) {
        $sefConfig =& SEFConfig::getConfig();
        $database =& JFactory::getDBO();
        
        $vars = $uri->getQuery(true);
        extract($vars);

        $title = array();
        $jfTranslate = $sefConfig->translateNames ? ', `id`' : '';
        
        if(isset($controller)){
	        $title[] = JoomSEF::_getMenuTitle($option, $controller);
        }else if(isset($view)){
	        $title[] = JoomSEF::_getMenuTitle($option, $view);
        }
        if(isset($catid)){
        	$title[] = $catid;
        }
        if (isset($task)){
	        $title[] = $task;
        }

        if( !empty($id) || !empty($cid)) {
            $field = 'title';
            if( SEFTools::UseAlias($this->params, 'poll_alias') ) {
                $field = 'alias';
            }
            
            if(empty($id) && !empty($cid)){
	            $id = $cid;
            }
            
            $database->setQuery("SELECT `$field` AS `title`, `description` $jfTranslate FROM `#__jcp_polls` WHERE `id` = '$id'");
            $rows = $database->loadObjectList();

            if ($database->getErrorNum()) die( $database->stderr());
            elseif (@count($rows) > 0 && !empty($rows[0]->title)) {
                $name = $rows[0]->title;
		    $name = $id . '-' . $name;
                $title[] = $name;
                $this->metatitle = $rows[0]->title;
                if(isset($rows[0]->description)){
	                $this->metadesc = $rows[0]->description;
                }
            }
        }
        

        // Handle nonSef variables
        $nonSefVars = array();
        if ($sefConfig->appendNonSef && ($this->params->get('pagination', '0') != '0')) {
	        if (isset($limit))       $nonSefVars['limit'] = $limit;
	        if (isset($limitstart))  $nonSefVars['limitstart'] = $limitstart;
        }
        if( isset($filter) )    $nonSefVars['filter'] = $filter;
        if (isset($dir))         $nonSefVars['dir'] = $dir;
        if (isset($order))       $nonSefVars['order'] = $order;
		
        $newUri = $uri;
        
        if (count($title) > 0){
            $metatags = $this->getMetaTags();
            if (isset($this->metatitle)) {
                $metatags['metatitle'] = $this->metatitle;
            }
        	$newUri = JoomSEF::_sefGetLocation($uri, $title, null, null, null, @$lang, $nonSefVars, null, $metatags, null, true);
    	}

        return $newUri;
    }
}
?>
