<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: categories.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerApproval extends JController {

	function __construct() {
		parent::__construct();
		$this->registerDefaultTask('getPolls');
		$this->registerTask( 'publish','publish' );
		$this->registerTask( 'unpublish','unPublish' );
	}

	function getPolls() {
		$view = & $this->getView('approval', 'html');
		$model = & $this->getModel('polls');
		$view->setModel($model, true);
		$view->setLayout('list');
		$view->display();
	}

	function publish() {
		global $option;
		$cids = JRequest::getVar( 'cid', null, '', Array() );
		$cid = implode(',', $cids);
		if (count($cids) < 1) {
			$message =  JText::_('Select an item.');
			$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
		}
		$model = $this->getModel('polls');
		if ($model->stateChange(STATE_PUBLISH, $cid)) {
			$app = JFactory::getApplication();
			$jcp_config = &$app->getUserState(SESSION_JCP_CONFIG);
			foreach($cids as $tid){
				$poll =& $model->getPollData($tid);
				$user = new stdClass();
				$user->id = $poll->created_by;
				PollsHelper::do3rdPartyTask("POLL", $poll, $user);
			}
			if($jcp_config[NOTIFY_POLL_APPROVAL] == '1'){
				$polls = &$model->get_user_emails($cid);
				foreach ($polls as $poll){
					$link = substr(JURI::root(false, ""),0,-1).JRoute::_("index.php?option=".$option."&controller=polls&task=viewpoll&id=".$poll->id.":".$poll->alias);
					$body = str_replace("\n", "<br/>", $body);
					$body = str_replace("{link}", $link, $jcp_config[APPROVAL_EMAIL_BODY]);
					PollsHelper::sendMail($jcp_config[APPROVAL_EMAIL_SENDER], $jcp_config[APPROVAL_EMAIL_SENDER_NAME],$poll->email,$jcp_config[APPROVAL_EMAIL_TITLE],$body, 1);
				}
			}
			$message = JText::_('MSG_PUBLISH_SUCCESS');
		}else {
			$message = JText::_('MSG_PUBLISH_FAILURE') . $model->getError();
		}

		$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
	}

	function unPublish() {
		$cids = JRequest::getVar( 'cid', null, '', Array() );
		$cid = implode(',', $cids);
		if (count($cids) < 1) {
			$message =  JText::_('Select an item.');
			$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
		}

		$model = $this->getModel('polls');
		if ($model->stateChange(STATE_UNPUBLISH, $cid)) {
			$app = JFactory::getApplication();
			$jcp_config = &$app->getUserState(SESSION_JCP_CONFIG);
			if($jcp_config[NOTIFY_POLL_APPROVAL] == '1'){
				$polls = &$model->get_user_emails($cid);
				foreach ($polls as $poll){
					$link = substr(JURI::root(false, ""),0,-1).JRoute::_("index.php?option=".$option."&controller=polls&task=viewpoll&id=".$poll->id.":".$poll->alias);
					$body = str_replace("\n", "<br/>", $body);
					$body = str_replace("{link}", $link, $jcp_config[DISAPPROVAL_EMAIL_BODY]);
					PollsHelper::sendMail($jcp_config[APPROVAL_EMAIL_SENDER], $jcp_config[APPROVAL_EMAIL_SENDER_NAME],$poll->email,$jcp_config[DISAPPROVAL_EMAIL_TITLE],$body, 1);
				}
							}
			$message = JText::_('MSG_UNPUBLISH_SUCCESS');
		}else {
			$message = JText::_('MSG_UNPUBLISH_FAILURE') . $model->getError();
		}

		$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
	}

	function remove() {
		$cids = JRequest::getVar( 'cid', null, '', Array() );

		if (count($cids) < 1) {
			$message =  JText::_('Select an item.');
			$this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
		}

		$model = $this->getModel('polls');
		$count = $model->remove();
		if ($count) {
			$message = JText::_('MSG_REMOVED') . ' ' . $count . ' polls';
		}else {
			$message = $model->getError();
		}

		$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
	}

	function cancel(){
		$message = JText::_('MSG_CANCEL');
		$this->setRedirect('index.php?option=com_communitypolls&controller=approval', $message);
	}
}
?>
