<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: categories.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerCategories extends JController {

    function __construct() {
        parent::__construct();
        $this->registerDefaultTask('getCategories');
        $this->registerTask( 'add','edit' );
        $this->registerTask( 'edit','edit' );
        $this->registerTask( 'publish','publish' );
        $this->registerTask( 'unpublish','unPublish' );
        $this->registerTask( 'lock','lock' );
        $this->registerTask( 'unlock','unlock' );
        $this->registerTask( 'saveorder','saveOrder' );
        $this->registerTask( 'orderup','orderUp' );
        $this->registerTask( 'orderdown','orderDown' );
    }

    function getCategories() {
        $view = & $this->getView('categories', 'html');
        $model = & $this->getModel('categories');
        $view->setModel($model, true);
        $view->setLayout('list');
        $view->display();
    }

    function edit() {
        $view = & $this->getView('categories', 'html');
        $model = & $this->getModel('categories');
        $view->setModel($model, true);
        $view->setLayout('form');
        $view->display();
    }

    function save() {
        $model =& $this->getModel('categories');
        if ($model->addOrUpdate()) {
            $message = JText::_('MSG_CATEGORY_ADDED');
        }else {
            $message = $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories&task=list', $message);
    }

    function remove() {
        $cids = JRequest::getVar( 'cid', null, '', Array() );

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=categories&task=list', $message);
        }

        $model = $this->getModel('categories');
        if ($model->remove()) {
            $message = JText::_('MSG_VOTE_SUCCESS');
        }else {
            $message = $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories&task=list', $message);
    }

    function publish() {
        $model = $this->getModel('categories');
        if ($model->stateChange(STATE_PUBLISH)) {
            $message = JText::_('MSG_PUBLISH_SUCCESS');
        }else {
            $message = JText::_('MSG_PUBLISH_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories&task=list', $message);
    }

    function unPublish() {
        $model = $this->getModel('categories');
        if ($model->stateChange(STATE_UNPUBLISH)) {
            $message = JText::_('MSG_UNPUBLISH_SUCCESS');
        }else {
            $message = JText::_('MSG_UNPUBLISH_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories&task=list', $message);
    }

    function cancel() {
        $msg = JText::_( 'Operation Cancelled' );
        $this->setRedirect( 'index.php?option=com_communitypolls&controller=categories', $msg );
    }

    function lock() {
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=categories', $message);
        }

        $model = $this->getModel('categories');
        if ($model->locked(STATE_PUBLISH, $cid)) {
            $message = JText::_('MSG_LOCK_SUCCESS');
        }else {
            $message = JText::_('MSG_LOCK_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories', $message);
    }

    function unlock() {
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=categories', $message);
        }

        $model = $this->getModel('categories');
        if ($model->locked(STATE_UNPUBLISH, $cid)) {
            $message = JText::_('MSG_UNLOCK_SUCCESS');
        }else {
            $message = JText::_('MSG_UNLOCK_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=categories', $message);
    }

    function saveOrder() {
    // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );
        $cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
        $model = $this->getModel('categories');
        if($model->saveOrder($cid)) {
            $message 	= JText::_( 'New ordering saved' );
            $this->setRedirect( 'index.php?option=com_communitypolls&controller=categories', $message );
        }else {
            JError::raiseError(500, $model->getError() );
        }
    }

    function orderUp( ) {
    // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
        $model = $this->getModel('categories');
        if($model->orderCategrory($cid[0], -1)) {
            $message 	= JText::_( 'New ordering saved' );
        //            $this->setRedirect( 'index.php?option=com_communitypolls&controller=categories', $message );
        }else {
            JError::raiseError(500, $model->getError() );
        }

        $view = & $this->getView('categories', 'html');
        $view->setModel($model, true);
        $view->setLayout('list');
        $view->display();
    }

    function orderDown( ) {
    // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );

        $cid 		= JRequest::getVar( 'cid', array(0), '', 'array' );
        $model = $this->getModel('categories');
        if($model->orderCategrory($cid[0], 1)) {
            $message 	= JText::_( 'New ordering saved' );
        //            $this->setRedirect( 'index.php?option=com_communitypolls&controller=categories', $message );
        }else {
            JError::raiseError(500, $model->getError() );
        }

        $view = & $this->getView('categories', 'html');
        $view->setModel($model, true);
        $view->setLayout('list');
        $view->display();
    }
}
?>
