<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: categories.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerPolls extends JController {

    function __construct() {
        parent::__construct();
        $this->registerDefaultTask('getPolls');
        $this->registerTask( 'edit','edit' );
        $this->registerTask( 'save','save' );
        $this->registerTask( 'publish','publish' );
        $this->registerTask( 'unpublish','unPublish' );
        $this->registerTask( 'state','updateState' );
        $this->registerTask( 'details','details' );
        $this->registerTask( 'sync','sync' );
    }

    function sync(){
        $model = & $this->getModel('polls');
        if($model->syncCategories()){
            $message="Categories sync success.";
        }else{
            $message="Categories sync failed.";
        }
        $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
    }

    function getPolls() {
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('polls');
        $view->setModel($model, true);
        $view->setLayout('list');
        $view->display();
    }

    function edit(){
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('polls');
        $view->setModel($model, true);
        $view->setLayout('edit');
        $view->display();
    }

    function save() {
        $cid = JRequest::getVar( 'cid', null, '', 'INT' );
        $options = JRequest::getVar( 'polloption', null, 'post', 'ARRAY' );
        $title = JRequest::getVar( 'polltitle', null, 'post', 'STRING' );
        $description = JRequest::getVar( 'description', null, 'post', 'STRING' );
        $category = JRequest::getVar( 'category', null, 'post', 'INT' );
        
        if(!$title || !$category || count($options) < 2){
            $message =  JText::_('Please select/fill the required items.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=edit&cid=' .
                $cid, $message);
        }else if($jcp_config[IS_DESC_REQUIRED] == "1" && $description == null) {
            $message =  JText::_('Please select/fill the required items.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=edit&cid=' .
                $cid, $message);
        }else if ($cid < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }else{
            $model = $this->getModel('polls');
            if ($model->save($cid)) {
                $message = JText::_('MSG_SAVE_SUCCESS');
            }else {
                $message = $model->getError();
            }

            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }
    }
    
    function remove() {
        $cids = JRequest::getVar( 'cid', null, '', 'ARRAY' );

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }

        $model = $this->getModel('polls');
        if ($model->remove()) {
            $message = JText::_('MSG_REMOVED');
        }else {
            $message = $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
    }

    function updateState() {
        $app = &JFactory::getApplication();
        $cid=JRequest::getVar( 'cid');
        $state=JRequest::getVar( 'state');
        $model = $this->getModel('polls');

        $return = "<?xml version=\"1.0\" encoding=\"utf8\" ?>";
        $return .= "<options>";
        if ($model->stateChange($state)) {
            $return .= "<option id='0'>1</option>";
        }else {
            $return .= "<option id='0'>0</option>";
        }
        $return .= "</options>";
        echo $return;
        $app->close();
    }

    function publish() {
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }

        $model = $this->getModel('polls');
        if ($model->stateChange(STATE_PUBLISH, $cid)) {
            $message = JText::_('MSG_PUBLISH_SUCCESS');
        }else {
            $message = JText::_('MSG_PUBLISH_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
    }

    function unPublish() {
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }

        $model = $this->getModel('polls');
        if ($model->stateChange(STATE_UNPUBLISH, $cid)) {
            $message = JText::_('MSG_UNPUBLISH_SUCCESS');
        }else {
            $message = JText::_('MSG_UNPUBLISH_FAILURE') . $model->getError();
        }

        $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
    }

    function details(){
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);
        if (count($cids) < 1) {
            $message =  JText::_('Select an item.');
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
        }else{
            $view = & $this->getView('polls', 'html');
            $model = $this->getModel('polls');
            $view->setModel($model, true);
            $view->setLayout('details');
            $view->display();
        }
    }

    function cancel(){
        $message = JText::_('MSG_CANCEL');
        $this->setRedirect('index.php?option=com_communitypolls&controller=polls', $message);
    }
}
?>
