<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: communitypolls.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class CommunityPollsModelCategories extends JModel {

    var $_id            = 0;
    var $_published     = 0;
    var $_locked        = 0;
    var $_categories    = null;

    function __construct() {
		parent::__construct();
		$array = JRequest::getVar('cid',  0, '', 'array');
        $cid = implode(',', $array);
		$this->setId($cid);
    }

	function setId($id){
		$this->_id          = $id;
		$this->_published	= 0;
        $this->_locked      = 0;
	}

    function getCategories(){
        $db =& $this->getDBO();
        $query = 'SELECT id,title, alias, published, locked, ordering, ' .
            ' num_polls AS polls, num_votes AS votes FROM ' . TABLE_JCP_CATEGORIES .
            ' ORDER BY ordering';
        $db->setQuery($query);
        $list = $db->loadObjectList();
        return $list;
    }

    function getCategory(){
        $db =& $this->getDBO();
        $cid = JRequest::getVar( 'cid', null, '', Array() );
        
        if($cid && $cid[0]){
            $query = 'SELECT id,title, alias, published, locked, ordering FROM ' .
                TABLE_JCP_CATEGORIES . ' WHERE id=' . $cid[0];
            $db->setQuery($query);
            $cat = $db->loadObject();
            return $cat;
        }else{
            $category->id = 0;
            return $category;
        }

    }
    
    function addOrUpdate(){

        $db         =& $this->getDBO();
        $name       = JRequest::getString('category', '');
        $published  = JRequest::getInt('published', 0);
        $locked     = JRequest::getInt('catlocked', 0);
        $parent     = JRequest::getInt('parentid', 0);
        $image      = JRequest::getString('cat_image', '');
        
        $alias = JFilterOutput::stringURLSafe($name);
        $query = '';

        if(!$this->_id){
            $query = 'INSERT INTO ' . TABLE_JCP_CATEGORIES . '(title, alias, published, locked)' .
                ' VALUES(' . $db->quote($name) . ',' . $db->quote($alias) . ',' . $published .
                ',' . $locked . ')';
            var_dump($query);
        }else{
            $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET title=' . $db->quote($name) .
                ', alias=' . $db->quote($alias) . ', published=' . $published . ', locked=' . $locked .
                ' WHERE id=' . $this->_id;
        }
        $this->_errors[] = $query;
        $db->setQuery($query);
        if($db->query()){
            return true;
        }else{
            return false;
        }
    }

    function remove(){
        $db         =& $this->getDBO();
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        $query = 'DELETE FROM ' . TABLE_JCP_CATEGORIES . ' WHERE id IN(' . $cid . ')';
        $db->setQuery($query);
        if($db->query()){
            return true;
        }else{
            return false;
        }
    }

    function stateChange($state){
        $db         =& $this->getDBO();
        $cids       = JRequest::getVar( 'cid', null, '', Array() );
        $cid        = implode(',', $cids);

        $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET published=' . $state . ' WHERE id IN(' . $cid . ')';
        $db->setQuery($query);
        if($db->query()){
            return true;
        }else{
            return false;
        }
    }

    function locked($state, $cid){
        $db         =& $this->getDBO();

        $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET locked=' . $db->getEscaped($state) .
            ' WHERE id IN(' . $db->getEscaped($cid) . ')';
        $db->setQuery($query);
        if($db->query()){
            return true;
        }else{
            return false;
        }
    }
    
    function saveOrder( &$cid ){
        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );
        $db			=& JFactory::getDBO();
        $total		= count( $cid );
        $order		= JRequest::getVar( 'order', array(0), 'post', 'array' );
        JArrayHelper::toInteger($order, array(0));

        // update ordering values
        for( $i=0; $i < $total; $i++ ){
            $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET ordering=' .
                $order[$i] . ' WHERE id=' . $cid[$i];
            $db->setQuery($query);
            if(!$db->query()){
                $this->setError($db->getErrorMsg());
                return false;
            }
        }
        $this->_reOrderCatageries();
        return true;
    }

    function orderCategrory( $cid, $order ){
        // Check for request forgeries
        JRequest::checkToken() or jexit( 'Invalid Token' );
        $db			=& JFactory::getDBO();
        $query = '';
        if($order == -1){
            $query = 'SELECT id, ordering FROM ' . TABLE_JCP_CATEGORIES . ' WHERE ordering <' .
                '(SELECT ordering FROM ' . TABLE_JCP_CATEGORIES .' WHERE id=' . $cid .')' .
                ' ORDER BY ordering DESC LIMIT 1';
        }else if($order == 1){
            $query = 'SELECT id, ordering FROM ' . TABLE_JCP_CATEGORIES . ' WHERE ordering >' .
                '(SELECT ordering FROM ' . TABLE_JCP_CATEGORIES .' WHERE id=' . $cid .')' .
                ' ORDER BY ordering LIMIT 1';
        }else{
            return false;
        }
        $db->setQuery($query);
        $cat = $db->loadObject();
        if($cat){
            $query = 'SELECT ordering FROM ' . TABLE_JCP_CATEGORIES . ' WHERE id=' . $cid;
            $db->setQuery($query);
            $currOrder = $db->loadResult();
            
            $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET ordering=' . $currOrder .
                ' WHERE id=' . $cat->id;
            $db->setQuery($query);
            if(!$db->query()){
                $this->setError($db->getErrorMsg());
                return false;
            }
            
            $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET ordering=' . $cat->ordering .
                ' WHERE id=' . $cid;
            $db->setQuery($query);
            if(!$db->query()){
                $this->setError($db->getErrorMsg());
                return false;
            }
        }
        return true;
    }

    function _reOrderCatageries(){
        $db			=& JFactory::getDBO();
        $query = 'SELECT id, ordering FROM ' . TABLE_JCP_CATEGORIES . ' ORDER BY ordering';
        $db->setQuery($query);
        $categories = $db->loadObjectList();
        $i = 1;
        foreach($categories as $cat){
            $query = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET ordering=' . $i .
                ' WHERE id=' . $cat->id;
            $db->setQuery($query);
            $db->query();
            $i++;
        }
    }
}
?>