<?php
/**
 * Joomla! 1.5 component communitypolls
 *
 * @version $Id: config.php 2009-05-10 01:47:01 svn $
 * @author Maverick
 * @package communitypolls
 * @subpackage models
 * @license GNU/GPL
 * Website: http://www.boddunan.com
 *
 * Review and approve the articles and assign points and cash rewards.
 * Users can see their articles and the points/cash rewards assigned in the front-end module.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class CommunityPollsModelConfig extends JModel {

    function __construct() {
        parent::__construct();
    }

    function &getConfiguration() {
        $db =& JFactory::getDBO();
        $query = 'SELECT config_name, config_value FROM '. TABLE_JCP_CONFIG;
        $db->setQuery($query);
        $rows = $db->loadObjectList();
        return $rows;
    }

    function save() {
        $db     =& JFactory::getDBO();

        $show_categories            = JRequest::getInt(SHOW_CATEGORIES, 0);
        $show_related_polls         = JRequest::getInt(SHOW_RELATED_POLLS, 0);
        $latest_polls_count         = JRequest::getInt(LATEST_POLLS_COUNT, 0);
        $featured_polls_count       = JRequest::getInt(FEATURED_POLLS_COUNT, 0);
        $author_polls_count         = JRequest::getInt(AUTHOR_POLLS_COUNT, 0);
        $mostvoted_polls_count      = JRequest::getInt(MOSTVOTED_POLLS_COUNT, 0);
        $related_polls_count        = JRequest::getInt(RELATED_POLLS_COUNT, 5);
        $related_key_len            = JRequest::getInt(RELATED_KEY_LEN, 3);
        $cookie_time_to_live        = JRequest::getInt(COOKIE_TIME_TO_LIVE, 30);
        $points_system              = JRequest::getVar(CONFIG_POINTS_SYSTEM, '', 'post','CMD');
        $points_for_polls           = JRequest::getInt(POLL_POINTS, 0);
        $points_for_votes           = JRequest::getInt(VOTES_POINTS, 0);
        $user_avtar                 = JRequest::getVar(USER_AVTAR, 'none', 'post','CMD');
        $comment_system             = JRequest::getVar(COMMENT_SYSTEM, 'none', 'post','CMD');
        $limit_polls                = JRequest::getVar(LIMIT_POLLS, 0, 'post','INT');
        $polls_moderation           = JRequest::getVar(IS_MODERATED, 0, 'post','INT');
        $date_format                = JRequest::getVar(DATE_FORMAT, '%m-%d-%Y %H&#58;%M', 'post','STRING');
        $list_comments              = JRequest::getVar(LIST_COMMENTS, 0, 'post','INT');
        $chart_type                 = JRequest::getVar(CHART_TYPE, CHART_DEFAULT, 'post','CMD');
        $chart_colors               = JRequest::getVar(CHART_COLORS, 'B2DBF9|F7C01B|90BD0C|D45049|089191|FFEBCC|5FD8A5|E72D29|0957B7|FEFECC', 'post','STRING');
        $pie_chart_height           = JRequest::getVar(PIE_CHART_HEIGHT, 450, 'post','INT');
        $user_name                  = JRequest::getVar(USER_NAME, 'username', 'post','CMD');
        $default_template           = JRequest::getVar(DEFAULT_TEMPLATE, 'polls', 'post','CMD');
        $is_desc_reqired            = JRequest::getVar(IS_DESC_REQUIRED, 0, 'post','INT');
        $desc_min_length            = JRequest::getVar(DESC_MIN_LENGTH, 0, 'post','INT');
        $show_author                = JRequest::getVar(SHOW_AUTHOR, 1, 'post','INT');
        $show_avatar                = JRequest::getVar(SHOW_AVATAR, 0, 'post','INT');
        $is_user_unpublish_allowed  = JRequest::getVar(IS_USER_PUBLISH_ALLOWED, 0, 'post','INT');
        $js_poll_activity           = JRequest::getVar(JS_POLL_ACTIVITY_ENABLED, 0, 'post','INT');
        $js_vote_activity           = JRequest::getVar(JS_VOTE_ACTIVITY_ENABLED, 0, 'post','INT');
        $related_excludes           = JRequest::getVar(RELATED_EXCLUDED_WORDS, 0, 'post','STRING');
        $notify_admin				= JRequest::getVar(NOTIFY_ADMIN, 0, 'post', 'INT');
        $notify_admin_email			= JRequest::getVar(NOTIFY_ADMIN_EMAIL, '', 'post','STRING');
        $notify_poll_approval       = JRequest::getVar(NOTIFY_POLL_APPROVAL, 0, 'post','INT');
        $approval_mail_sender       = JRequest::getVar(APPROVAL_EMAIL_SENDER, '', 'post','STRING');
        $approval_mail_sender_name  = JRequest::getVar(APPROVAL_EMAIL_SENDER_NAME, '', 'post','STRING');
        $approval_mail_title        = JRequest::getVar(APPROVAL_EMAIL_TITLE, '', 'post','STRING');
        $approval_mail_body         = JRequest::getVar(APPROVAL_EMAIL_BODY, '', 'post','STRING');
        $disapproval_mail_title     = JRequest::getVar(DISAPPROVAL_EMAIL_TITLE, '', 'post','STRING');
        $disapproval_mail_body      = JRequest::getVar(DISAPPROVAL_EMAIL_BODY, '', 'post','STRING');
        $allow_preview              = JRequest::getVar(ALLOW_PREVIEW, 0, 'post','INT');
        $poll_suggestions_order     = JRequest::getVar(POLL_SUGGESTIONS_ORDER, 'A,F,R,L,M', 'post','STRING');
        $list_length                = JRequest::getVar(LIST_LENGTH, 20, 'post','INT');
        $enable_twitter             = JRequest::getVar(ENABLE_TWITTER, 0, 'post','INT');
        $twitter_user_name          = JRequest::getVar(TWITTER_USER_NAME, '', 'post','STRING');
        $twitter_password           = JRequest::getVar(TWITTER_PASSWORD, '', 'post','STRING');
        $short_url_service          = JRequest::getVar(SHORT_URL_SERVICE, 'none', 'post','STRING');
        $bit_ly_login               = JRequest::getVar(BIT_LY_LOGIN, '', 'post','STRING');
        $bit_ly_apikey              = JRequest::getVar(BIT_LY_API_KEY, '', 'post','STRING');
        $permission_create          = JRequest::getVar(PERMISSION_CREATION, '', 'post','ARRAY');
        $permission_vote            = JRequest::getVar(PERMISSION_VOTING, '', 'post','ARRAY');
        $permission_manage          = JRequest::getVar(PERMISSION_MANAGING, '', 'post','ARRAY');
        $permission_wysiwyg         = JRequest::getVar(PERMISSION_WYSIWYG, '', 'post','ARRAY');
        $permission_view_results	= JRequest::getVar(PERMISSION_VIEW_RESULTS, '', 'post','ARRAY');
        $allow_images               = JRequest::getVar(ALLOW_IMAGES, '', 'post','INT');
        $maximum_image_size         = JRequest::getVar(MAX_IMAGE_SIZE, '', 'post','INT');
        $guest_vote_restriction     = JRequest::getVar(VOTE_RESTRICTION_METHOD, array(), 'post','ARRAY');
        $enable_credits             = JRequest::getVar(ENABLE_POWERED_BY, '1', 'post','INT');
        $allowed_poll_types         = JRequest::getVar(ALLOWED_POLL_TYPES, 'radio', 'post','ARRAY');
        $share_this_widget          = JRequest::getVar(SHARE_THIS_PUBID, '', 'post', 'STRING');
        $enable_polls_anywhere      = JRequest::getVar(ENABLE_POLLS_ANYWHERE, '0', 'post', 'INT');
        $process_content_plugins	= JRequest::getVar(PROCESS_CONTENT_PLUGINS, '0', 'post', 'INT');
        $enable_pa_by_default		= JRequest::getVar(ENABLE_PA_BY_DEFAULT, '0', 'post', 'INT');
        
        $permission_create = implode(',', $permission_create);
        $permission_vote = implode(',', $permission_vote);
        $permission_manage = implode(',', $permission_manage);
        $permission_wysiwyg = implode(',', $permission_wysiwyg);
        $permission_view_results = implode(',', $permission_view_results);
        $allowed_poll_types = implode(',', $allowed_poll_types);
        $vote_restriction = implode(',',$guest_vote_restriction);
        
        if($related_excludes){
            $related_excludes = "," . $related_excludes . ",";
            $related_excludes = preg_replace("/^[\,]*$/", "", $related_excludes);
        }
        //$show_categories            = JRequest::getInt()
        /*Default Configuration Properties */
        $query = 'INSERT INTO `#__jcp_config` (`config_name`, `config_value`) VALUES' .
            '("' . SHOW_CATEGORIES . '",' . $db->quote($show_categories) . '),' .
            '("' . AUTHOR_POLLS_COUNT . '",' . $db->quote($author_polls_count) . '),' .
            '("' . FEATURED_POLLS_COUNT . '",' . $db->quote($featured_polls_count) . '),' .
            '("' . LATEST_POLLS_COUNT . '",' . $db->quote($latest_polls_count) . '),' .
            '("' . MOSTVOTED_POLLS_COUNT . '",' . $db->quote($mostvoted_polls_count) . '),' .
            '("' . SHOW_RELATED_POLLS . '",' . $db->quote($show_related_polls) . '),' .
            '("' . RELATED_POLLS_COUNT . '",' . $db->quote($related_polls_count) . '),' .
            '("' . RELATED_KEY_LEN . '",' . $db->quote($related_key_len) . '),' .
            '("' . COOKIE_TIME_TO_LIVE . '",' . $db->quote($cookie_time_to_live) . '),' .
//            '("' . ALLOW_GUEST_VOTING . '",' . $db->quote($allow_guest_voting) . '),' .
//            '("' . ALLOW_GUEST_POLLS . '",' . $db->quote($allow_guest_polls) . '),' .
            '("' . CONFIG_POINTS_SYSTEM . '",' . $db->quote($points_system) . '),' .
            '("' . POLL_POINTS . '",' . $db->quote($points_for_polls) . '),' .
            '("' . VOTES_POINTS . '",' . $db->quote($points_for_votes) . '),' .
            '("' . COMMENT_SYSTEM . '",' . $db->quote($comment_system) . '),' .
            '("' . LIMIT_POLLS . '",' . $db->quote($limit_polls) . '),' .
            '("' . IS_MODERATED . '",' . $db->quote($polls_moderation) . '),' .
            '("' . DATE_FORMAT . '",' . $db->quote($date_format) . '),' .
            '("' . LIST_COMMENTS . '",' . $db->quote($list_comments) . '),' .
            '("' . USER_AVTAR . '",' . $db->quote($user_avtar) . '),' .
            '("' . CHART_COLORS . '",' . $db->quote($chart_colors) . '),' .
            '("' . PIE_CHART_HEIGHT . '",' . $db->quote($pie_chart_height) . '),' .
            '("' . ALLOW_PREVIEW . '",' . $db->quote($allow_preview) . '),' .
            '("' . POLL_SUGGESTIONS_ORDER . '",' . $db->quote($poll_suggestions_order) . '),' .
            '("' . USER_NAME . '",' . $db->quote($user_name) . '),' .
            '("' . IS_DESC_REQUIRED . '",' . $db->quote($is_desc_reqired) . '),' .
            '("' . DESC_MIN_LENGTH . '",' . $db->quote($desc_min_length) . '),' .
            '("' . DEFAULT_TEMPLATE . '",' . $db->quote($default_template) . '),' .
            '("' . CHART_TYPE . '",' . $db->quote($chart_type) . '),' .
            '("' . SHOW_AUTHOR . '",' . $db->quote($show_author) . '),' .
            '("' . SHOW_AVATAR . '",' . $db->quote($show_avatar) . '),' .
            '("' . LIST_LENGTH . '",' . $db->quote($list_length) . '),' .
            '("' . IS_USER_PUBLISH_ALLOWED . '",' . $db->quote($is_user_unpublish_allowed) . '),' .
            '("' . JS_POLL_ACTIVITY_ENABLED . '",' . $db->quote($js_poll_activity) . '),' .
            '("' . JS_VOTE_ACTIVITY_ENABLED . '",' . $db->quote($js_vote_activity) . '),' .
            '("' . RELATED_EXCLUDED_WORDS . '",' . $db->quote($related_excludes) . '),' .
			'("' . NOTIFY_ADMIN . '",' . $db->quote($notify_admin) . '),' .
			'("' . NOTIFY_ADMIN_EMAIL . '",' . $db->quote($notify_admin_email) . '),' .
            '("' . NOTIFY_POLL_APPROVAL . '",' . $db->quote($notify_poll_approval) . '),' .
            '("' . APPROVAL_EMAIL_SENDER . '",' . $db->quote($approval_mail_sender) . '),' .
            '("' . APPROVAL_EMAIL_SENDER_NAME . '",' . $db->quote($approval_mail_sender_name) . '),' .
            '("' . APPROVAL_EMAIL_TITLE . '",' . $db->quote($approval_mail_title) . '),' .
            '("' . APPROVAL_EMAIL_BODY . '",' . $db->quote($approval_mail_body) . '),' .
            '("' . DISAPPROVAL_EMAIL_TITLE . '",' . $db->quote($disapproval_mail_title) . '),' .
            '("' . DISAPPROVAL_EMAIL_BODY . '",' . $db->quote($disapproval_mail_body) . '),' .
            '("' . ENABLE_TWITTER . '",' . $db->quote($enable_twitter) . '),' .
            '("' . TWITTER_USER_NAME . '",' . $db->quote($twitter_user_name) . '),' .
            '("' . TWITTER_PASSWORD . '",' . $db->quote($twitter_password) . '),' .
            '("' . SHORT_URL_SERVICE . '",' . $db->quote($short_url_service) . '),' .
            '("' . BIT_LY_LOGIN . '",' . $db->quote($bit_ly_login) . '),' .
            '("' . BIT_LY_API_KEY . '",' . $db->quote($bit_ly_apikey) . '),' .
            '("' . PERMISSION_CREATION . '",' . $db->quote($permission_create) . '),' .
            '("' . PERMISSION_VOTING . '",' . $db->quote($permission_vote) . '),' .
            '("' . PERMISSION_MANAGING . '",' . $db->quote($permission_manage) . '),' .
            '("' . PERMISSION_WYSIWYG . '",' . $db->quote($permission_wysiwyg) . '),' .
            '("' . PERMISSION_VIEW_RESULTS . '",' . $db->quote($permission_view_results) . '),' .
        	'("' . ALLOW_IMAGES . '",' . $db->quote($allow_images) . '),' .
            '("' . MAX_IMAGE_SIZE . '",' . $db->quote($maximum_image_size) . '),' .
            '("' . SHARE_THIS_PUBID . '",' . $db->quote($share_this_widget) . '),' .
            '("' . VOTE_RESTRICTION_METHOD . '",' . $db->quote($vote_restriction) . '),' .
            '("' . ENABLE_POWERED_BY . '",' . $db->quote($enable_credits) . '),' .
            '("' . ALLOWED_POLL_TYPES . '",' . $db->quote($allowed_poll_types) . '),' .
            '("' . ENABLE_POLLS_ANYWHERE . '",' . $db->quote($enable_polls_anywhere) . '),' .
            '("' . PROCESS_CONTENT_PLUGINS . '",' . $db->quote($process_content_plugins) . '),' .
            '("' . ENABLE_PA_BY_DEFAULT . '",' . $db->quote($enable_pa_by_default) . '),' .
        	'("' . CONFIG_MODIF_TIME . '", NOW())' .
            ' ON DUPLICATE KEY UPDATE config_value=VALUES(config_value)';

        $db->setQuery( $query );

        if(!$db->query()) {
            return false;
            $this->setError($query);
        }

        return true;
    }
}
?>