<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: polls.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package administrator.components.com_communitypolls.models
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class CommunityPollsModelPolls extends JModel {

    var $_total;

    function __construct() {
        parent::__construct();
    }

    function &getPolls($status=3,$userid=0) {
        $app = &JFactory::getApplication();
        $db =& JFactory::getDBO();
        $sessionvar = JRequest::getWord('sessionvar','polls_list');
        $filter_order       = $app->getUserStateFromRequest( "$sessionvar.filter_order",'filter_order','p.id',	'cmd' );
        $filter_order_Dir   = $app->getUserStateFromRequest( "$sessionvar.filter_order_Dir",'filter_order_Dir','DESC','word' );
        $filter_state       = $app->getUserStateFromRequest( "$sessionvar.filter_state",'filter_state','','word' );
        $search             = $app->getUserStateFromRequest( "$sessionvar.search",'search','','string' );
        $category           = $app->getUserStateFromRequest( "$sessionvar.category",'category','','string' );
        $userid             = $app->getUserStateFromRequest( "$sessionvar.userid",'userid','','string' );
        $limitstart         = $app->getUserStateFromRequest( "$sessionvar.limitstart",'limitstart','','int' );

        if(!in_array($filter_order, array('p.title','p.published','p.category','p.created_by','p.votes','p.created','p.last_voted'))) {
            $filter_order = 'p.id';
        }
        // Get pagination request variables
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        $where = array();
        if($userid) {
            $where[] = 'p.created_by='.$userid;
        }
        if($category) {
            $where[] = 'p.category='.$category;
        }

        // We are asking results from approval page?
        if($status < 3 && $status >=0 ) {
            $where[] = 'p.published = ' . $status;
        }else {
            // Request from polls list page
            if ( $filter_state ) {
                if ( $filter_state == 'P' ) {
                    $where[] = 'p.published = 1';
                }else if ($filter_state == 'U' ) {
                    $where[] = 'p.published = 0';
                }
            }
        }
        if ($search) {
            $where[] = 'LOWER(p.title) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
        }

        if($userid > 0) {
            $where[] = 'p.created_by=' . $userid;
        }
        $condition 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
        $orderby    = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;

        $query = 'SELECT COUNT(*) FROM ' . TABLE_JCP_POLLS . ' p' . $condition;
        $db->setQuery( $query );
        $total = $db->loadResult();
        jimport('joomla.html.pagination');
        $pagination = new JPagination( $total, $limitstart, $limit );

        $query = 'SELECT p.id, p.title, p.votes, c.title as category, p.created,' .
                ' u.username, p.published, p.last_voted, p.ip_address FROM ' . TABLE_JCP_POLLS .
                ' p LEFT JOIN ' . TABLE_JCP_CATEGORIES . ' c ON p.category=c.id' .
                ' LEFT JOIN #__users u ON p.created_by=u.id' . $condition . $orderby;

        $db->setQuery($query, $pagination->limitstart, $pagination->limit);
        $polls = $db->loadObjectList('id');
        $this->_total = count($polls);

        $pollIds = Array();
        if($polls) {
            foreach($polls as $poll) {
                $pollIds[] = $poll->id;
            }

            $pollcsv = implode(',', $pollIds);
            $options = $this->_getOptions($pollcsv);

            if($options) {
                foreach($options as $opt) {
                    $polls["$opt->poll_id"]->options[] = $opt;
                }
            }
        }
        $categories = $this->_getCategories();
        $users      = $this->_getUsers();

        $lists['state']     = JHTML::_('grid.state',  $filter_state );
        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order']     = $filter_order;
        $lists['search']    = $search;
        $lists['category']  = $category;
        $lists['userid']    = $userid;

        $result->lists      = $lists;
        $result->data       = $polls;
        $result->pagination = $pagination;
        $result->categories = $categories;
        $result->users      = $users;
        $result->sessionvar = $sessionvar;
        return $result;
    }

    function &getPollData($poll_id=null) {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );

        $db =& JFactory::getDBO();
        $user =& JFactory::getUser();
        if(!$poll_id) {
            $poll_id = JRequest::getVar('cid',0,'','INTEGER');
        }

        $query = 'SELECT p.id, p.title, p.description, p.alias, p.votes, p.published, p.type,' .
                ' p.created, u.' . $jcp_config[USER_NAME] . ' AS username, p.close_date, p.created_by,' .
                ' p.category as catid, jc.title AS category, p.ip_address, p.anywhere FROM ' . TABLE_JCP_POLLS .
                ' p LEFT JOIN ' . TABLE_JCP_CATEGORIES . ' jc ON p.category=jc.id' .
                ' LEFT JOIN #__users u ON p.created_by=u.id WHERE p.id=' . $poll_id;
        $db->setQuery($query);
        $poll = $db->loadObject();

        if(isset($poll)) {
            $query = 'SELECT id, title, votes FROM ' . TABLE_JCP_OPTIONS . ' WHERE poll_id=' . $poll_id;
            $db->setQuery($query);
            $options = $db->loadObjectList();
            if(!isset($options)) {
                $this->_error = JText::_('MSG_NO_OPTIONS');
                return false;
            }
            $poll->options = $options;
        }else {
            $this->_error = JText::_('MSG_POLL_NOT_EXIST');
            return false;
        }

        return $poll;
    }

    function _getOptions($pollcsv) {
        $db =& $this->getDBO();
        $query = 'SELECT id, poll_id, title, votes FROM ' . TABLE_JCP_OPTIONS .
                ' WHERE poll_id IN (' . $pollcsv . ')';
        $db->setQuery($query);
        $options = $db->loadObjectList();
        return $options;
    }

    function _getCategories() {
        $db =& $this->getDBO();
        $query = 'SELECT id, title FROM ' . TABLE_JCP_CATEGORIES;
        $db->setQuery($query);
        $categories = $db->loadObjectList();
        return $categories;
    }

    function _getUsers() {
        $db =& $this->getDBO();
        $query = 'SELECT distinct(p.created_by) AS id, u.name AS name, u.username AS username ' .
                ' FROM ' . TABLE_JCP_POLLS . ' p LEFT JOIN #__users u ON p.created_by=u.id';
        $db->setQuery($query);
        $users = $db->loadObjectList();
        return $users;
    }

    function remove() {
        $db =& $this->getDBO();
        $cids = JRequest::getVar( 'cid', null, '', 'ARRAY' );
        $cid = implode(',', $cids);
        $test = str_replace(',', '', $cid);
        if(!is_numeric($test)){
            $this->setError(JText::_('MSG_INVALID_REQ_DATA'));
            return false;
        }
        
        $query = array();
        $result = array();
        $query[] = 'DELETE FROM ' . TABLE_JCP_VOTES . ' WHERE poll_id IN (' . $cid . ')';
        $query[] = 'DELETE FROM ' . TABLE_JCP_GUEST_VOTES . ' WHERE poll_id IN (' . $cid . ')';
        $query[] = 'DELETE FROM ' . TABLE_JCP_OPTIONS . ' WHERE poll_id IN (' . $cid . ')';
        $query[] = 'DELETE FROM ' . TABLE_JCP_POLLS . ' WHERE id IN(' . $cid . ')';
        foreach($query as $qry){
            $db->setQuery($qry);
            if($db->query()){
                $result[] = $db->getAffectedRows();
            }else{
                $this->setError(JText::_('MSG_ERROR_PROCESSING'));
            }
        }
        $update = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET num_votes=num_votes-'.($result[0]+$result[1]);
        $db->setQuery($update);
        if(!$db->query()){
            $this->setError(JText::_('MSG_ERROR_PROCESSING'));
        }
        $cats = "SELECT category, COUNT(*) AS polls FROM " . TABLE_JCP_POLLS . " WHERE published=1 OR published=2 GROUP BY category";
        $db->setQuery($cats);
        $counts = $db->loadObjectList();
        var_dump($counts);

        foreach($counts as $c){
            $update = 'UPDATE ' . TABLE_JCP_CATEGORIES . ' SET num_polls='.$c->polls.' WHERE id='.$c->category;
            $db->setQuery($update);
            $this->setError($update);
            if(!$db->query()){
                $this->setError(JText::_('MSG_ERROR_PROCESSING'));
            }
        }
        $query = 'SELECT ' . $db->nameQuote('id') . ',' . $db->nameQuote('value') .
                    ' FROM ' . TABLE_JCP_RESOURCES .
                    ' WHERE ' . $db->nameQuote('type') . '=' . $db->quote('image') .
                    ' AND poll_id IN (' . $cid . ')';
        $db->setQuery($query);
        $resources = $db->loadObjectList();

        $ids = '';
        jimport('joomla.filesystem.file');
        foreach ($resources as $resource){
            JFile::delete(CP_IMAGES_UPLOAD_DIR.DS.$resource->value);
            $ids.=$resource->id;
            $ids.=',';
        }

        $ids = substr($ids, 0, (strlen($ids) - 1) );
        $query = "DELETE FROM " . TABLE_JCP_RESOURCES . " WHERE " .
            $db->nameQuote('id') . " IN (" . $ids . ")";
        $db->setQuery($query);
        $db->query();

        return true;
    }

    function syncCategories(){
        $db = &JFactory::getDBO();

        $query = "UPDATE ".TABLE_JCP_OPTIONS." SET votes=(select count(*) FROM ".TABLE_JCP_VOTES." WHERE ".TABLE_JCP_VOTES.".option_id=".TABLE_JCP_OPTIONS.".id)";
        $db->setQuery($query);
        if(!$db->query()){
            return false;
        }

        $query = "UPDATE ".TABLE_JCP_POLLS." SET votes=(SELECT SUM(o.votes) FROM ".TABLE_JCP_OPTIONS." o WHERE o.poll_id=".TABLE_JCP_POLLS.".id)";
        $db->setQuery($query);
        if(!$db->query()){
            return false;
        }

        $query = "SELECT id,published FROM " . TABLE_JCP_CATEGORIES;
        $db->setQuery($query);
        $categories = $db->loadObjectList();
        if($categories){
            foreach($categories as $c){
                $query = "UPDATE " . TABLE_JCP_CATEGORIES . " SET num_polls=(SELECT COUNT(*) FROM " . TABLE_JCP_POLLS .
                    " p WHERE (p.published=1 OR p.published=2) AND p.category=" . $c->id . ") WHERE id=".$c->id;
                $db->setQuery($query);
                if(!$db->query()){
                    return false;
                }
                $query = "UPDATE " . TABLE_JCP_CATEGORIES . " SET num_votes=(SELECT SUM(p.votes) FROM " . TABLE_JCP_POLLS .
                   " p WHERE (p.published=1 OR p.published=2) AND p.category=" . $c->id . ") WHERE id=".$c->id;
                $db->setQuery($query);
                if(!$db->query()){
                    return false;
                }
            }
        }
        
        return true;
    }

    function stateChange($state, $cid) {
        $db =& $this->getDBO();

        $query = 'UPDATE ' . TABLE_JCP_POLLS . ' SET published=' . $db->getEscaped($state) .
                ' WHERE id IN(' . $cid . ')';
        $db->setQuery($query);
        if($db->query()) {
            if($jcp_config[NOTIFY_POLL_APPROVAL] == '1') {
                $this->notifyUsers($cid,$state);
            }
            return true;
        }else {
            return false;
        }
    }

    function notifyUsers($cid, $state) {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $db         =& $this->getDBO();

        $query = 'SELECT name,username,email FROM ' . TABLE_JCP_POLLS .
                ' p LEFT JOIN #__users u ON p.created_by=u.id WHERE p.id=' . $cid;
        $db->setQuery($query);
        $result = $db->loadObject();
        if($result) {
            $body = '';
            $title = '';
            if($state) {
                $body = $jcp_config[APPROVAL_EMAIL_BODY];
                $title = $jcp_config[APPROVAL_EMAIL_TITLE];
            }else {
                $body = $jcp_config[DISAPPROVAL_EMAIL_BODY];
                $title = $jcp_config[DISAPPROVAL_EMAIL_TITLE];
            }
            $body = str_replace("{username}", $result->username, $body);
            $body = str_replace("{name}", $result->name, $body);

            CommunityPollsHelper::sendEmail(
                    $jcp_config[APPROVAL_EMAIL_SENDER],
                    $jcp_config[APPROVAL_EMAIL_SENDER_NAME],
                    $result->email,
                    $title,
                    $body );
        }
    }

    function save($cid) {
        $title = JRequest::getVar( 'polltitle', null, 'post', 'STRING' );
        $category = JRequest::getVar( 'category', null, 'post', 'INT' );
        $options = JRequest::getVar( 'polloption', null, 'post', 'ARRAY' );
        $optionids = JRequest::getVar( 'optionids', null, 'post', 'STRING' );
        $poll_type = JRequest::getVar('poll_type','radio','post','WORD');
        $closingdate = JRequest::getVar('closingdate',null,'post','STRING');
        $polls_anywhere = JRequest::getVar('polls_anywhere',0,'post','INT');
        $description = JRequest::getVar( 'description', null, 'post', 'STRING', JREQUEST_ALLOWRAW );
        $description = $this->filterData($description);
        if($polls_anywhere){
        	$polls_anywhere = 1;
        }else{
        	$polls_anywhere = 0;
        }
        
        if(!in_array($poll_type, array('radio','checkbox','grid'))){
            $poll_type = 'radio';
        }

        $db =& $this->getDBO();
        $optionids = substr($optionids, 0, strlen($optionids) - 1);
        $oids = explode(",", $optionids);

        if($closingdate) {
            $todays_date = date("Y-m-d");
            $today = strtotime($todays_date);
            $close_date = strtotime($closingdate);
            $closingdate = $db->Quote($closingdate);
        }else {
            $closingdate = 'null';
        }

        $query = 'UPDATE ' . TABLE_JCP_POLLS . ' SET ' . 
        			' title=' . $db->quote($title) . ',' .
        			' description=' . $db->quote($description) . ',' .
        			' category=' . $db->getEscaped($category) . ',' . 
        			' close_date=' . $closingdate . ',' .
        			' type=' . $db->quote($poll_type) . ',' .
        			' anywhere=' . $polls_anywhere .
        		' WHERE id=' . $db->getEscaped($cid);
        $db->setQuery($query);
        $db->query();

        $i = 0;
        foreach($oids as $oid) {
            $query = "UPDATE " . TABLE_JCP_OPTIONS . " SET title=" . $db->quote($options[$i++]) .
                    " WHERE poll_id=" . $db->getEscaped($cid) . " AND id=" . $oid;
            $db->setQuery($query);
            $db->query();
        }

        $optionQuery = null;
        for ($i=$i;$i<count($options); $i++) {
            if($options[$i]) {
                $optionQuery[] = "(" . $db->getEscaped($cid) . "," .
                        $db->quote($options[$i++]) . ")";
            }
        }
        if($optionQuery) {
            $query = "INSERT INTO " . TABLE_JCP_OPTIONS . "(poll_id, title) VALUES ";
            $query .= implode(",", $optionQuery);
        }
        $db->setQuery($query);
        if($db->query()) {
            return true;
        }else {
            return false;
        }
    }

    function filterData($data) {
        // Filter settings
        jimport('joomla.application.component.helper');
        $config = JComponentHelper::getParams('com_content');
        $user = &JFactory::getUser();
        $gid = $user->get('gid');

        $filterGroups = $config->get('filter_groups');

        // convert to array if one group selected
        if ((!is_array($filterGroups) && (int) $filterGroups > 0)) {
            $filterGroups = array($filterGroups);
        }

        if (is_array($filterGroups) && in_array($gid, $filterGroups)) {
            $filterType = $config->get('filter_type');
            $filterTags = preg_split('#[,\s]+#', trim($config->get('filter_tags')));
            $filterAttrs = preg_split('#[,\s]+#', trim($config->get('filter_attritbutes')));
            switch ($filterType) {
                case 'NH':
                    $filter = new JFilterInput();
                    break;
                case 'WL':
                    $filter = new JFilterInput($filterTags, $filterAttrs, 0, 0);
                    break;
                case 'BL':
                default:
                    $filter = new JFilterInput($filterTags, $filterAttrs, 1, 1);
                    break;
            }
            $data = $filter->clean($data);
        } elseif (empty($filterGroups)) {
            $filter = new JFilterInput(array(), array(), 1, 1);
            $data = $filter->clean($data);
        }
        return $data;
    }
    
    function getPollDetails($cid) {

        $poll = $this->getPollData($cid);
        $db = &JFactory::getDBO();
        $query = 'SELECT v.voter_id, v.ip_address, v.voted_on, v.option_id, v.column_id, u.username, u.name, '.
                'o1.title AS poll_option, o2.title AS column_name ' .
                'FROM ' . TABLE_JCP_VOTES . ' v ' .
                'LEFT JOIN #__users u ON v.voter_id=u.id ' .
                'LEFT JOIN ' . TABLE_JCP_OPTIONS . ' o1 ON v.option_id=o1.id ' .
                'LEFT JOIN ' . TABLE_JCP_OPTIONS . ' o2 ON v.column_id=o2.id ' .
                'WHERE v.poll_id IN (' . $cid . ') ' .
                'ORDER BY v.voted_on DESC';
        $db->setQuery($query);
        $results = $db->loadObjectList();
        $poll->results = $results;
        return $poll;
    }
    
    function &get_user_emails($cid){
    	$db = &JFactory::getDBO();
    	$query = "select p.id, p.alias, p.title, u.email from ".TABLE_JCP_POLLS." p left join #__users u on p.created_by=u.id where p.id in (".$cid.")";
    	$db->setQuery($query);
    	return $db->loadObjectList();
    }
}
?>