<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: statistics.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class CommunityPollsModelStatistics extends JModel {

    function __construct() {
        parent::__construct();
    }

    function &getStatistics(){
        $statistics = null;
        $statistics->monthlyPolls =& $this->_getPollsCount(12,'m');
        $statistics->weeklyPolls =& $this->_getPollsCount(10,'w');
        $statistics->monthlyVotes =& $this->_getVoteCount(12,'m');
        $statistics->weeklyVotes =& $this->_getVoteCount(10,'w');
        $statistics->mostPollCreators =& $this->_getTopUsers(10,'p');
        $statistics->topVoters =& $this->_getTopUsers(10,'v');
        return $statistics;
    }

    function &_getTopUsers($count,$action){
        $db =& JFactory::getDBO();
        $query = '';
        switch ($action){
            case 'p':
                $query = 'SELECT u.id,u.name,u.username,count(*) as count,u.registerDate,u.lastvisitDate ' .
                    'FROM ' . TABLE_JCP_POLLS . ' p LEFT JOIN #__users u' .
                    ' ON p.created_by=u.id GROUP BY p.created_by ORDER BY count DESC';
                break;
            case 'v':
                $query = 'SELECT u.id,u.name,u.username,count(*) as count,u.registerDate,u.lastvisitDate ' .
                    'FROM ' . TABLE_JCP_VOTES . ' v LEFT JOIN #__users u' .
                    ' ON v.voter_id=u.id GROUP BY v.voter_id ORDER BY count DESC';
                break;
        }
        $db->setQuery($query,0,$count);
        $users = $db->loadObjectList();
        return $users;
    }

    function &_getPollsCount($count,$frequency){
        $db =& JFactory::getDBO();
        $query = '';
        switch($frequency){
            case 'm':
                $query = "SELECT count(*) AS count, DATE_FORMAT(created,'%M %Y') name " .
                    "FROM " . TABLE_JCP_POLLS . " GROUP BY DATE_FORMAT(created, '%M%Y') " .
                    "ORDER BY created DESC";
                break;
            case 'w':
                $query = "SELECT count(*) AS count, DATE_FORMAT(created,'%v of %x') name " .
                    "FROM " . TABLE_JCP_POLLS . " GROUP BY DATE_FORMAT(created, '%v%x') " .
                    "ORDER BY created DESC";
                break;
        }
        $db->setQuery($query,0,$count);
        $polls = $db->loadObjectList();
        return $polls;
    }

    function &_getVoteCount($count,$frequency){
        $db =& JFactory::getDBO();
        $query = '';
        switch($frequency){
            case 'm':
                $query = "SELECT count(*) AS count, DATE_FORMAT(voted_on,'%M %Y') name " .
                    "FROM " . TABLE_JCP_VOTES . " GROUP BY DATE_FORMAT(voted_on, '%M%Y') " .
                    "ORDER BY voted_on DESC";
                break;
            case 'w':
                $query = "SELECT count(*) AS count, DATE_FORMAT(voted_on,'%v week of %x') name " .
                    "FROM " . TABLE_JCP_VOTES . " GROUP BY DATE_FORMAT(voted_on, '%v%x') " .
                    "ORDER BY voted_on DESC";
                break;
        }
        $db->setQuery($query,0,$count);
        $polls = $db->loadObjectList();
        return $polls;
    }
}
?>