<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: polls.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package administrator.components.com_communitypolls.models
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport('joomla.application.component.model');

class CommunityPollsModelUsers extends JModel {
    function __construct() {
        parent::__construct();
    }

    function &getUsers() {
        $app = &JFactory::getApplication();
        $db =& JFactory::getDBO();
        $sessionvar = JRequest::getWord('sessionvar','users_list');
        $filter_order       = $app->getUserStateFromRequest( "$sessionvar.filter_order", 'filter_order', 'ju.id', 'cmd' );
        $filter_order_Dir   = $app->getUserStateFromRequest( "$sessionvar.filter_order_Dir", 'filter_order_Dir', 'DESC', 'word' );
        $search             = $app->getUserStateFromRequest( "$sessionvar.search", 'search', '', 'string' );
        if(!in_array($filter_order, array('ju.id', 'u.name', 'u.username', 'ju.polls', 'ju.votes', 'ju.last_poll', 'ju.last_voted'))){
            $filter_order = 'ju.id';
        }
        // Get pagination request variables
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

        if ($search) {
            $where[] = 'LOWER(u.username) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
            $where[] = 'LOWER(u.name) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
        }

        $where = array();
        $where[] = 'u.id > 0';
        $where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );
        $orderby    = ' ORDER BY '.$filter_order.' '.$filter_order_Dir;

        $query = 'SELECT COUNT(*) FROM ' . TABLE_JCP_USERS . ' ju LEFT JOIN #__users u ON ju.id=u.id' . $where;
        $db->setQuery( $query );
        $total = $db->loadResult();
        
        jimport('joomla.html.pagination');
        $pagination = new JPagination( $total, $limitstart, $limit );

        $query = 'SELECT ju.id, ju.polls, ju.votes, u.username, u.name, ju.last_poll, ju.last_voted ' .
                    'FROM ' . TABLE_JCP_USERS . ' ju ' .
                    'LEFT JOIN #__users u ON ju.id=u.id' .
            $where . $orderby;
        $db->setQuery($query, $pagination->limitstart, $pagination->limit);
        $users = $db->loadObjectList();

        $lists['order_Dir'] = $filter_order_Dir;
        $lists['order']     = $filter_order;
        $lists['search']    = $search;

        $result->lists      = $lists;
        $result->data       = $users;
        $result->pagination = $pagination;
        $result->sessionvar = $sessionvar;
        return $result;
    }

    function synchronize(){
        $db = &JFactory::getDBO();
       
        $query = "INSERT INTO " . TABLE_JCP_USERS . "(id,polls,votes)
                  SELECT
                    u.id,
                    (SELECT count(*) FROM " . TABLE_JCP_POLLS . " p WHERE p.created_by=u.id) AS polls,
                    (select count(*) FROM " . TABLE_JCP_VOTES . " v WHERE v.voter_id=u.id) AS votes
                  FROM #__users u
                  ON DUPLICATE KEY UPDATE polls=VALUES(polls), votes=VALUES(votes)";
        $db->setQuery($query);
        $db->query();

        $query = "INSERT INTO " . TABLE_JCP_USERS . "(id,last_poll) 
                    SELECT created_by, max(created) FROM " . TABLE_JCP_POLLS . " 
                    WHERE created_by <> 0 GROUP BY created_by
                    ON DUPLICATE KEY UPDATE last_poll=VALUES(last_poll)";
        $db->setQuery($query);
        $db->query();

        $query = "INSERT INTO " . TABLE_JCP_USERS . "(id,last_voted)
                    SELECT voter_id, max(voted_on) FROM " . TABLE_JCP_VOTES . "
                    WHERE voter_id <> 0 GROUP BY voter_id
                    ON DUPLICATE KEY UPDATE last_voted=VALUES(last_voted)";
        $db->setQuery($query);
        $db->query();
    }
}
?>