<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: view.html.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

// Import Joomla! libraries
jimport( 'joomla.application.component.view');
class CommunityPollsViewCategories extends JView {

    function display($tpl = null) {
        JToolBarHelper::title( JText::_('TITLE_COMMUNITY_POLLS').': <small><small>[ ' . JText::_('CATEGORIES') .' ]</small></small>', 'polls.png');

        if($this->getLayout() == 'list') {
            JToolBarHelper::deleteList();
            JToolBarHelper::publish();
            JToolBarHelper::Unpublish();
            JToolBarHelper::custom( 'lock', 'lock.png', 'lock.png', 'Lock', true, false );
            JToolBarHelper::custom( 'unlock', 'unlock.png', 'unlock.png', 'Unlock', true, false );
            JToolBarHelper::editListX();
            JToolBarHelper::addNewX();

            $items = $this->get('categories');
            jimport('joomla.html.pagination');
            $pageNav = new JPagination( count($items), 0, 0 );
            $this->assignRef( 'categories', $items );
            $this->assignRef( 'pagination', $pageNav );
        }else if($this->getLayout() == 'form') {
            $category = $this->get('category');
            $categories = $this->get('categories');

            $isNew = ($category->id < 1);
            $text = $isNew ? JText::_( 'New' ) : JText::_( 'Edit' );
            JToolBarHelper::title(   JText::_( 'Community Polls' ).': <small><small>[ ' . $text.' ]</small></small>' );

            JToolBarHelper::save();
            if ($isNew) {
                JToolBarHelper::cancel();
            } else {
                JToolBarHelper::cancel( 'cancel', 'Close' );
            }

            if($isNew){
                $category->title = '';
                $category->published = true;
                $category->locked = false;
            }

            $this->assignRef( 'category', $category );
            $this->assignRef( 'categories', $categories );
        }
        parent::display($tpl);
    }
}
?>