(function(window) {
    var PollsAnywhere = function(options){
        return PollsAnywhere.fn.load(options);
    };
    PollsAnywhere.fn = PollsAnywhere.prototype = {
        options: null,
        voted : false,
        wait: function(){
            if(typeof jQuery != 'function'){
                setTimeout(function () {
                    PollsAnywhere.fn.wait();
                },50);
            }else{
                this.request();
            }
        },
        loadjscssfile: function(sScriptSrc, type) {
            var oHead = document.getElementsByTagName('head')[0];
            if(type == 'js'){
                var oScript = document.createElement('script');
                oScript.type = 'text/javascript';
                oScript.src = sScriptSrc;
                oHead.appendChild(oScript);
                this.wait();
            }else if(type=='css'){
                var oStyle=document.createElement("link");
                oStyle.setAttribute("rel", "stylesheet");
                oStyle.setAttribute("type", "text/css");
                oStyle.setAttribute("href", sScriptSrc);
                oHead.appendChild(oStyle);
            }
        },
        load: function(options) {
            var messages = new Array();
            var poll = {};
            var default_args = {
                id : 0,
                container_name : 'pa-container',
                language : 'en-GB',
                loading: 'loading_sb.gif',
                css: 'pollsanywhere.css',
                colors:['#B2DBF9','#F7C01B','#90BD0C','#D45049','#089191','#FFEBCC','#5FD8A5','#E72D29','#0957B7','#FEFECC'],
                url: 'YOUR_WEBSITE_END_WITH_SLASH'
            };
            for ( var i in default_args) {
                if (typeof options[i] == 'undefined') {
                    options[i] = default_args[i];
                }
            }
            if (options.url == null) {
                return false;
            }
            this.options = options;
            //this.loadjscssfile("", "css");
            var loading = document.createElement("img");
            loading.id = "pa-loading";
            loading.src = options.url+"components/com_communitypolls/assets/images/"+options.loading;
            document.getElementById(options.container_name).appendChild(loading);
            this.loadjscssfile(options.url+"components/com_communitypolls/assets/css/"+options.css,"css");
            if(typeof jQuery !== 'function'){
                this.loadjscssfile("http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js","js");
            }else{
                this.request();
            }
            return true;
        },
        request: function(){
            jQuery.noConflict();
            jQuery.ajax({
                url: this.options.url + "index.php?option=com_communitypolls&controller=polls&task=ajxgetpoll" + '&id=' + this.options.id,
                type: "get",
                jsonp : "jsonp",
                jsonpCallback: "PollsAnywhere.fn.callback",
                dataType: "jsonp"
            });
        },
        callback : function(poll) {
            if(typeof poll.error !== 'undefined'){
                alert(poll.error);
            }else{
                jQuery("#"+this.options.container_name).append(
                    jQuery("<div>",{"class":"pa-title"}).html(poll.title),
                    jQuery("<hr>",{"class":"pa-ruler"}),
                    jQuery("<div>",{"class":"pa-description"}).html(poll.description),
                    this.buildAnswers(poll),
                    this.buildMetadata(poll),
                    this.buildButtons(poll)
                );
                if(this.voted || this.checkCookie("cpvote_"+poll.id)){
                    this.showResult(poll);
                }
                var website = this.options.url.substr(this.options.url.indexOf("//")+2);
                website = website.substr(0, website.length-1);
                var website_home = '<a class="pa-credits" href="'+ this.options.url + 'index.php?option=com_communitypolls">Powered by '+website+'</a>';
                jQuery("#"+this.options.container_name).append(jQuery("<div>",{"style":"text-align: center"}).html(website_home));
                jQuery("#pa-loading").hide();
            }
        },
        buildAnswers : function(poll) {
            var table = jQuery("<table>",{
                "class":"pa-answers",
                "cellpadding":"2px",
                "cellspacing":"0"
            });
            if(!this.voted || !this.checkCookie("cpvote_"+poll.id)){
                jQuery.each(poll.answers, function(index, answer){
                    table.append(
                        jQuery("<tr>",{"class":"pa-answer"+(index%2==0?"":" pa-alt")}).append(
                            jQuery("<td>",{"class":"pa-choice"}).append(
                        		jQuery('<input type="'+poll.type+'" name="answer[]" id="pa-answer-'+answer.id+'" value="'+answer.id+'">')
                    		),
                            jQuery("<td>",{"class":"pa-choicetext"}).append(
                        		jQuery("<label>",{"for":"pa-answer-"+answer.id}).html(answer.title)
                    		)
                        )
                    );
                });
            }
            return table;
        },
        buildMetadata : function(poll) {
            return jQuery("<div>",{"class":"pa-metadata"}).append(
                jQuery("<div>",{"class":"pa-avatar"}).html(poll.avatar),
                jQuery("<div>",{"class":"pa-details"}).append(jQuery("<div>",{"id":"pa-meta-username"}).html(poll.username),
                jQuery("<div>",{"id":"pa-meta-votes"}).html(poll.votes)),
                jQuery("<div>",{"class":"pa-clear"})
            );
        },
        buildButtons : function(poll){
            return jQuery("<div>",{id:"pa-buttons"}).append(
                jQuery("<input>",{type:"button",value:"Submit"}).bind("click", function(){PollsAnywhere.fn.submitAnswer(poll);})
            );
        },
        submitAnswer: function(poll){
            if(this.voted || this.checkCookie("cpvote_"+poll.id)){
                return false;
            }
            var selections = jQuery("#"+this.options.container_name).find("input[name='answer[]']:checked");
            if(selections.length == 0){
                alert("No selections made.");
            }else{
                var sIndex = '';
                selections.each(function(index, element){
                    sIndex = sIndex + this.value + "_";
                });
                sIndex = sIndex.substr(0, sIndex.length-1);
                jQuery.ajax({
                    url: this.options.url + "index.php?option=com_communitypolls&controller=polls&task=ajxpavote" + "&id=" + this.options.id + "&votes=" + sIndex,
                    type: "get",
                    jsonp : "jsonp",
                    jsonpCallback: "PollsAnywhere.fn.showResult",
                    dataType: "jsonp"
                });
                PollsAnywhere.fn.voted = true;
            }
            return true;
        },
        showResult : function(poll){
            if(typeof poll.error !== 'undefined'){
                alert(poll.error);
            }else{
                jQuery(".pa-answers").replaceWith(jQuery("<div>",{"id":"pa-result"}));
                var total_votes = 0;
                jQuery.each(poll.answers, function(index, element){
                    total_votes += parseInt(element.votes);
                });
                jQuery.each(poll.answers, function(index, element){
                    var value = element.votes;
                    var num = new Number((100*value)/total_votes,2);
                    var percent = num.toFixed(2) + "%";
                    jQuery("#pa-result").append(
                        jQuery("<div>",{"class":"pa-optiontext"}).html(element.title),
                        jQuery("<div>",{"class":"pa-chart"}).append(jQuery("<span>",{"class":"pa-votes"}).html(poll.votesTxt + value),
                        jQuery("<div>",{"class":"pa-percent","style": "width:"+percent+";background-color:"+PollsAnywhere.fn.options.colors[index%10]})),
                        jQuery("<div>",{"class":"pa-clear"})
                    );
                });
                jQuery("#pa-meta-votes").html(poll.votesTxt + total_votes);
                jQuery("#pa-buttons").remove();
                this.setCookie("cpvote_"+poll.id, 1, 365);
            }
        },
        getCookie: function(c_name){
            if (document.cookie.length>0){
                c_start=document.cookie.indexOf(c_name + "=");
                if (c_start!=-1){
                    c_start=c_start + c_name.length+1;
                    c_end=document.cookie.indexOf(";",c_start);
                    if (c_end==-1) c_end=document.cookie.length;
                    return unescape(document.cookie.substring(c_start,c_end));
                }
            }
            return "";
        },

        setCookie:function(c_name,value,expiredays){
            var exdate=new Date();
            exdate.setDate(exdate.getDate()+expiredays);
            document.cookie=c_name+ "=" +escape(value)+
            ((expiredays==null) ? "" : ";expires="+exdate.toUTCString());
        },

        checkCookie: function(name){
            ck=this.getCookie(name);
            if (ck!=null && ck!=""){
                return true;
            }else{
                return false;
            }
        }
    };
    window.PollsAnywhere = PollsAnywhere;
})(window);