<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: controller.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerPolls extends JController {
    function __construct() {
        parent::__construct();
        $this->registerDefaultTask('getPollsList');
        $this->registerTask( 'list','getPollsList' );
        $this->registerTask( 'viewpoll','viewPoll' );
        $this->registerTask( 'castvote','castVote' );
        $this->registerTask( 'newpoll','newPoll' );
        $this->registerTask( 'savepoll','savePoll' );
        $this->registerTask( 'cancel','getPollsList' );
        $this->registerTask( 'publish','publish' );
        $this->registerTask( 'unpublish','unPublish' );
        $this->registerTask( 'ajxvote','doAjxVote' );
        $this->registerTask( 'ajxgvote','ajxGridVote' );
        $this->registerTask( 'ajxgetpoll','ajxGetPollData' );
        $this->registerTask( 'ajxpavote','ajxAnywhereVote' );
        $this->registerTask( 'fbit','markFeatured' );
        $this->registerTask( 'ufbit','unMarkFeatured' );
        $this->registerTask( 'userpolls','userPolls' );
        $this->registerTask( 'votedusers','votedUsers' );
        $this->registerTask( 'preview','ajxPreview' );
        $this->registerTask( 'papreview','paPreview' );
    }

    function paPreview(){
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $view = & $this->getView('polls', 'html');
        $view->setLayout('polls_anywhere');
        $view->display();
    }

    function getPollsList() {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('polls');
        $view->setModel($model, true);
        $view->setLayout('list');
        $view->display();
    }

    function userPolls() {
    	$user = &JFactory::getUser();
    	if($user->guest){
    		$redirectUrl = base64_encode("index.php?option=com_communitypolls&view=polls&task=newpoll".$this->getItemId());
			$link = "index.php?option=com_user&view=login";
			$msg = JText::_('MSG_USER_LOGIN');
			$this->setRedirect($link."&return=".$redirectUrl, $msg);
    	}
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('user');
        $view->setModel($model, true);
        $view->setLayout('userpolls');
        $view->display();
    }

    function votedUsers() {
    	$user = &JFactory::getUser();
    	if($user->guest){
    		$redirectUrl = base64_encode("index.php?option=com_communitypolls&view=polls&task=newpoll".$this->getItemId());
			$link = "index.php?option=com_user&view=login";
			$msg = JText::_('MSG_USER_LOGIN');
			$this->setRedirect($link."&return=".$redirectUrl, $msg);
    	}
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('polls');
        $view->setModel($model, true);
        $view->setLayout('votedusers');
        $view->display();
    }

    function viewPoll() {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $view = & $this->getView('polls', 'html');
        $model = & $this->getModel('polls');
        $view->setModel($model, true);
        $view->setLayout('viewpoll');
        $view->display();
    }

    function ajxGetPollData(){
        $model = & $this->getModel('polls');
        $id = JRequest::getInt('id',0);
        $poll = $model->getAjxPollData($id);
        $callback = JRequest::getCmd('jsonp','callback');
        if($poll){
            $poll->votes = JText::_("LBL_VOTES") . ": " . $poll->votes;
            $poll->votesTxt = JText::_("LBL_VOTES") . ": ";
            $poll->avatar = PollsHelper::getPAUserAvtar($poll->created_by,48);
            $poll->username = JText::_("TXT_BY") . " " . PollsHelper::getUserProfileUrl($poll->created_by, $poll->username);
            $poll->description = JHTML::_('content.prepare', $poll->description );
            echo $callback . '(' . json_encode($poll) . ')';
        }else{
            echo $callback . '({error:"'.JText::_('MSG_POLL_NOT_EXIST').'"})';
        }
        jexit();
    }

    function ajxAnywhereVote(){
        $model = & $this->getModel('polls');
        $id = JRequest::getInt('id',0);
        $votes = JRequest::getVar("votes",array(),"","cmd");
        $votes = explode("_",$votes);
        JArrayHelper::toInteger($votes);
        $poll = $model->doAjxVoteAnywhere($id, $votes);
        $callback = JRequest::getCmd('jsonp','callback');
        if(!empty($poll->answers)){
            $poll->votesTxt = JText::_("LBL_VOTES") . ": ";
            echo $callback . '(' . json_encode($poll) . ')';
        }else{
            echo $callback . '({error:"'.$model->getError().JText::_('MSG_ERROR_ON_VOTE').'"})';
        }
        jexit();
    }

    function doAjxVote() {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $poll_id = JRequest::getInt('id',0);
        $option_id = JRequest::getVar('option_id',array(),"post","array");

        if(!$poll_id || (count($option_id) <= 0)) {
        	echo json_encode(array('error'=>JText::_("MSG_ERROR_NO_SELECTION")));
        }else {
            if(!CPAuthorization::authorize('com_communitypolls','vote','polls','all')) {
            	echo json_encode(array('error'=>JText::_("POLL_VOTE_REGISTER")));
            }else {
                $model = $this->getModel('polls');
                if ($model->castVote($poll_id, $option_id)) {
                	if(strpos($jcp_config[VOTE_RESTRICTION_METHOD],'cookie') !== FALSE){
                    	$cookieName	= JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll_id );
                    	$expire=time()+60*60*24*((int)$jcp_config[COOKIE_TIME_TO_LIVE]);
                    	setcookie($cookieName, 1, $expire, '/');
                	}

                    $poll = $model->getPollData($poll_id, true);
                    PollsHelper::do3rdPartyTask("VOTE", $poll);
                    PollsHelper::getChartData($poll);

                    if(!CPAuthorization::authorize('com_communitypolls','viewing','polls','all')){
                    	echo json_encode(array('info'=>JText::_('MSG_RESULTS_HIDDEN2')));
                    }else{
                    	echo json_encode(array('poll'=>$poll));
                    }
                }else {
                	echo json_encode(array('error'=>$model->getError()));
                }
            }
        }
        jexit();
    }

    function ajxGridVote(){
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $poll_id = JRequest::getInt('id',0);
        $svotes = JRequest::getVar('votes',"",'post',"string");
        $votes = explode(",", $svotes);
        if(!$poll_id || (count($votes)) < 1) {
        	echo json_encode(array('error'=>JText::_("MSG_ERROR_NO_SELECTION")));
        }elseif(!CPAuthorization::authorize('com_communitypolls','vote','polls','all')) {
        	echo json_encode(array('error'=>JText::_("POLL_VOTE_REGISTER")));
        }else {
            $model = $this->getModel('polls');
            if ($model->castGridVote($poll_id, $votes)) {
            	if(strpos($jcp_config[VOTE_RESTRICTION_METHOD],'cookie') !== FALSE){
                	$cookieName = JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll_id );
                	$expire=time()+60*60*24*((int)$jcp_config[COOKIE_TIME_TO_LIVE]);
                	setcookie($cookieName, 1, $expire, '/');
            	}

                $poll = $model->getPollData($poll_id, true);
                PollsHelper::do3rdPartyTask("VOTE", $poll);
				echo json_encode(array('poll'=>$poll));
            }else {
            	echo json_encode(array('error'=>$model->getError()));
            }
        }
        jexit();
    }

    function castVote() {
        //not used
        jexit();
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $user =& JFactory::getUser();
        $poll_id = JRequest::getVar('id',0,'post','INTEGER');
        $option_id = JRequest::getVar('option_id',0,'post','INTEGER');

        $itemid = $this->getItemId();
        $message = '';

        if(!$option_id) {
            $this->_error = JText::_('MSG_ERROR_NO_SELECTION');
            $this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=viewpoll'.$itemid),
                    $message);
        }else {
            if(!CPAuthorization::authorize('com_communitypolls','vote','polls','all')) {
                $message = JText::_('POLL_VOTE_REGISTER');
                $this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=viewpoll&id=' .
                        $poll_id.$itemid), $message);
            }else {
                $params = $app->getParams();
                $params =& $this->setPathway(JText::_('TITLE_POLLS'));

                $model = $this->getModel('polls');
                if ($model->castVote()) {
                    if($poll_id) {
                        $cookieName	= JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll_id );
                        $expire=time()+60*60*24*((int)$jcp_config[COOKIE_TIME_TO_LIVE]); //180 days
                        setcookie($cookieName, 1, $expire, '/');
                    }

                    $poll = $model->getPollData($poll_id);
                    PollsHelper::do3rdPartyTask("VOTE", $poll);

                    $message = JText::_('MSG_VOTE_SUCCESS');
                }else {
                    $message = $model->getError();
                }
                $poll_id = JRequest::getVar('id',0,'post','INTEGER');
                $this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=viewpoll&id=' .
                        $poll_id.$itemid), $message);
            }
        }
    }

    function savePoll() {
		global $option;
		$app = &JFactory::getApplication();
		$jcp_config = $app->getUserState( SESSION_JCP_CONFIG );

		$user =& JFactory::getUser();
		$itemid = $this->getItemId();;
		$model = $this->getModel('polls');

		$title = JRequest::getVar('polltitle',null,'post','STRING');
		$options = JRequest::getVar('pollOptions',null,'post','ARRAY');
		$category = JRequest::getVar('catid',0,'post','INT');
		$description = JRequest::getVar('description',null,'post','STRING');

		if($title == null || $category == null || (count($options) < 2)) {
			$message = JText::_('MSG_ERROR_REQ_FIELD');
			$this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid),
			$message);
		}else if($jcp_config[IS_DESC_REQUIRED] == "1" && $description == null) {
			$message = JText::_('MSG_ERROR_REQ_FIELD');
			$this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid),
			$message);
		}else if(!CPAuthorization::authorize('com_communitypolls','create','polls','all')) {
			$message = JText::_('POLL_SUBMIT_REGISTER');
			$this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid),
			$message);
		}else {
			if(!$model->isAllowedToCreatePoll($jcp_config[LIMIT_POLLS])) {
				$message = JText::_('POLL_LIMIT_REACHED');
				$this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid),
				$message);
			}else {
				$params = $app->getParams();
				$params =& $this->setPathway(JText::_('TITLE_POLLS'));

				$poll =& $model->addNewPoll();
				if ($poll->id) {

					if($jcp_config[IS_MODERATED] == '1' || ($jcp_config[IS_MODERATED] == '2' && $user->guest)) {
						$message = JText::_('MSG_SENT_FOR_APPROVAL');
					}else {
						PollsHelper::do3rdPartyTask("POLL", $poll);
						$message = JText::_('MSG_SAVE_SUCCESS');
					}
					if($jcp_config[NOTIFY_ADMIN] == '1'){
						$link = substr(JURI::root(false, ""),0,-1).JRoute::_("index.php?option=".$option."&controller=polls&task=viewpoll&id=".$poll->id.":".$poll->alias.$this->getItemId());
						$body = '<p>Dear Administrator,</p><p>A new poll is submitted by '.$user->username.'. Please follow the below link to view the poll.</p>';
						$body = $body . '<a href ="'.$link.'">'.$link.'</a>';
						$body = $body . "<p>- Community Polls Notification</p>";
						PollsHelper::sendMail($jcp_config[APPROVAL_EMAIL_SENDER], $jcp_config[APPROVAL_EMAIL_SENDER_NAME],$jcp_config[NOTIFY_ADMIN_EMAIL],"A new poll is submitted",$body, 1);
					}
				}else {
					$message = $model->getError();
				}
//				        $view = & $this->getView('polls', 'html');
//				        $view->setLayout('newpoll');
//				        $view->display();
				$this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid), $message);
			}
		}
    }

    function newPoll() {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $user =& JFactory::getUser();
        $itemid = $this->getItemId();
//        if($user->guest && !$jsp_config[ALLOW_GUEST_POLLS]){
//            $redirectUrl = base64_encode("index.php?option=com_communitypolls&controller=polls&task=newpoll".$itemid);
//            $link = "index.php?option=com_user&view=login";
//            $msg = JText::_('MSG_USER_LOGIN');
//            $this->setRedirect($link."&return=".$redirectUrl, $msg);
//        }
        if(!CPAuthorization::authorize('com_communitypolls','create','polls','all')) {
            $message = JText::_('POLL_SUBMIT_REGISTER');
            $this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid), $message);
        }else {
            $model = & $this->getModel('polls');
            if(!$model->isAllowedToCreatePoll((int)$jcp_config[LIMIT_POLLS])) {
                $message = JText::_('POLL_LIMIT_REACHED');
                $this->setRedirect(JRoute::_('index.php?option=com_communitypolls&controller=polls&task=list'.$itemid),
                        $message);
            }else {
                $view = & $this->getView('polls', 'html');
                $view->setLayout('newpoll');
                $view->setModel($model, true);
                $view->display();
            }
        }
    }

    function publish() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid       = JRequest::getVar( 'cid', null, '', 'INTEGER' );
            if (!$cid) {
                $message =  JText::_('Select an item.');
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }else {
                $model = $this->getModel('polls');
                if ($model->publish(STATE_PUBLISH, $cid)) {
                    $message = JText::_('MSG_PUBLISH_SUCCESS');
                }else {
                    $message = JText::_('MSG_PUBLISH_FAILURE') . $model->getError();
                }
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }
        }
    }

    function unPublish() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid       = JRequest::getVar( 'cid', null, '', 'INTEGER' );
            if (!$cid) {
                $message =  JText::_('Select an item.');
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            } else {
                $model = $this->getModel('polls');
                if ($model->publish(STATE_UNPUBLISH, $cid)) {
                    $message = JText::_('MSG_UNPUBLISH_SUCCESS');
                }else {
                    $message = JText::_('MSG_UNPUBLISH_FAILURE') . $model->getError();
                }
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }
        }
    }

    function lock() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid       = JRequest::getVar( 'cid', null, '', 'INTEGER' );
            if (!$cid) {
                $message =  JText::_('Select an item.');
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }else {
                $model = $this->getModel('polls');
                if ($model->locked(STATE_PUBLISH, $cid)) {
                    $message = JText::_('MSG_LOCK_SUCCESS');
                }else {
                    $message = JText::_('MSG_LOCK_FAILURE') . $model->getError();
                }
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }
        }
    }

    function unlock() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid       = JRequest::getVar( 'cid', null, '', 'INTEGER' );
            if (!$cid) {
                $message =  JText::_('Select an item.');
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }else {
                $model = $this->getModel('polls');
                if ($model->locked(STATE_UNPUBLISH, $cid)) {
                    $message = JText::_('MSG_UNLOCK_SUCCESS');
                }else {
                    $message = JText::_('MSG_UNLOCK_FAILURE') . $model->getError();
                }
                $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=list', $message);
            }
        }
    }

    function markFeatured() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid = JRequest::getVar('id',0,'','INTEGER');
            $message = '';
            if (!$cid) {
                $message =  JText::_('MSG_FEATURED_BIT_FAIL');
            }else {

                $model = $this->getModel('polls');
                if ($model->setFeaturedBit(STATE_PUBLISH, $cid)) {
                    $message = JText::_('MSG_FEATURED_BIT_SUCEESS');
                }else {
                    $message = JText::_('MSG_FEATURED_BIT_FAIL') . $model->getError();
                }
            }
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=viewpoll&id=' . $cid, $message);
        }
    }


    function unMarkFeatured() {
        if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
            JError::raiseError( 500, 'Unauthorised usage.' );
        }else {
            $cid = JRequest::getVar('id',0,'','INTEGER');
            $message = '';
            if (!$cid) {
                $message =  JText::_('MSG_FEATURED_BIT_FAIL');
            }else {
                $model = $this->getModel('polls');
                if ($model->setFeaturedBit(STATE_UNPUBLISH, $cid)) {
                    $message = JText::_('MSG_FEATURED_BIT_SUCEESS');
                }else {
                    $message = JText::_('MSG_FEATURED_BIT_FAIL') . $model->getError();
                }
            }
            $this->setRedirect('index.php?option=com_communitypolls&controller=polls&task=viewpoll&id=' . $cid, $message);
        }
    }

    function setPathway($title) {
        $app = &JFactory::getApplication();
        $document =& JFactory::getDocument();
        $params = $app->getParams();
        $menus	= &JSite::getMenu();
        $menu	= $menus->getActive();
        $pathway  =& $app->getPathway();

        if (is_object( $menu )) {
            $menu_params = new JParameter( $menu->params );
            if (!$menu_params->get( 'page_title')) {
                $params->set('page_title',	$title);
            }
        } else {
            $params->set('page_title',	$title);
        }
        $document->setTitle( $params->get( 'page_title' ) );
        $pathway->addItem($title, '');
        $params->def( 'show_page_title', 1 );
        $params->def( 'page_title', $title );

        return $params;
    }

    function getItemId(){
        $menu = &JSite::getMenu();
        $mnuitems	= $menu->getItems('link', 'index.php?option=com_communitypolls&view=polls&layout=home');
        if(!$mnuitems[0]){
            $mnuitems	= $menu->getItems('link', 'index.php?option=com_communitypolls&view=polls');
        }
        return isset($mnuitems[0]) ? '&Itemid='.$mnuitems[0]->id : '';
    }
}
?>
