<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: upload.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerUpload extends JController {
    function __construct() {
        parent::__construct();
        $this->registerDefaultTask('uploadFile');
        $this->registerTask( 'upload','uploadFile' );
    }

    function uploadFile() {
        $app = &JFactory::getApplication();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        $fieldName = 'uploadFile';
        $error = '';
        $output = '';

        if(!$jcp_config[ALLOW_IMAGES] || $jcp_config[ALLOW_IMAGES] == '0'){
            $error = JText::_('UPLOAD_IMAGES_DISABLED');
        }else{

            jimport('joomla.filesystem.file');
            $fileError = $_FILES[$fieldName]['error'];
            if ($fileError > 0)
            {
                switch ($fileError){
                    case 1:
                        $error = JText::_( 'FILE_TOO_LARGE_THAN_PHP_INI_ALLOWS' );
                        break;
                    case 2:
                        $error = JText::_( 'FILE_TOO_LARGE_THAN_HTML_FORM_ALLOWS' );
                        break;
                    case 3:
                        $error = JText::_( 'ERROR_PARTIAL_UPLOAD' );
                        break;
                    case 4:
                        $error = JText::_( 'ERROR_NO_FILE' );
                        break;
                }
            }else{
                $fileSize = $_FILES[$fieldName]['size'];
                if($fileSize > (int)($jcp_config[MAX_IMAGE_SIZE] * 1024)){
                    $error = JText::_( 'FILE_BIGGER_THAN_ALLOWED' );
                }else{
                    $fileName = $_FILES[$fieldName]['name'];
                    $uploadedFileNameParts = explode('.',$fileName);
                    $uploadedFileExtension = array_pop($uploadedFileNameParts);
                    $validFileExts = explode(',', $jcp_config[ALLOWED_IMAGE_EXTENSIONS]);
                    $extOk = false;

                    foreach($validFileExts as $key => $value){
                        if( preg_match("/$value/i", $uploadedFileExtension ) ){
                                $extOk = true;
                        }
                    }

                    if ($extOk == false){
                        $error = JText::_( 'INVALID_EXTENSION' );
                    }else{
                        $fileTemp = $_FILES[$fieldName]['tmp_name'];
                        if(!$fileTemp){
                        	jexit;
                        }else{
	                        $imageinfo = getimagesize($fileTemp);
	                        $okMIMETypes = 'image/jpeg,image/pjpeg,image/png,image/x-png,image/gif';
	                        $validFileTypes = explode(",", $okMIMETypes);
	
	                        if( !is_int($imageinfo[0]) || !is_int($imageinfo[1]) ||  !in_array($imageinfo['mime'], $validFileTypes) ){
	                            $error = JText::_( 'INVALID_FILETYPE' );
	                        }else{
	                            $fileName = preg_replace("[^A-Za-z0-9.]", "-", $fileName);
	                            $fileName = date('YmdHis') . '-' . $fileName;
	                            $uploadPath = CP_IMAGES_UPLOAD_DIR . DS . $fileName;
	                            if(!JFile::upload($fileTemp, $uploadPath)){
	                                $error = JText::_( 'ERROR_MOVING_FILE' );
	                            }else{
	                                $output = $fileName;
	                            }
	                        }
                        }
                    }
                }
            }
        }
        $xml = '<?xml version="1.0" encoding="utf-8" ?>';
        $xml .= '<root>';
        $xml .= '<errormsg>' . htmlspecialchars($error) . '</errormsg>';
        $xml .= '<uploadname>' . $output . '</uploadname>';
        $xml .= '</root>';

        echo $xml;
        $app->close();
        exit(0);
    }
}
?>
