<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: controller.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.controller');

/**
 * Description of communitypollsControllerPolls
 *
 * @author maverick
 */
class CommunityPollsControllerUser extends JController {
    function __construct() {
        parent::__construct();
        $this->registerDefaultTask('getPollsCreatedByUser');
        $this->registerTask( 'polls','getPollsCreatedByUser' );
        $this->registerTask( 'votes','getPollsVotedByUser' );
    }

    function getPollsCreatedByUser() {
        $user =& JFactory::getUser();
        if($user->guest){
            JError::raiseError( 403, JText::_('Access Forbidden') );
            return;
        }
        $view = & $this->getView('user', 'html');
        $model = & $this->getModel('user');
        $view->setModel($model, true);
        $view->setLayout('polls');
        $view->display();
    }

    function getPollsVotedByUser() {
        $user =& JFactory::getUser();
        if($user->guest){
            JError::raiseError( 403, JText::_('Access Forbidden') );
            return;
        }
        $view = & $this->getView('user', 'html');
        $model = & $this->getModel('user');
        $view->setModel($model, true);
        $view->setLayout('votes');
        $view->display();
    }

    function getPollsList() {
        $user =& JFactory::getUser();
        if($user->guest){
            JError::raiseError( 403, JText::_('Access Forbidden') );
            return;
        }
        $view = & $this->getView('user', 'html');
        $model = & $this->getModel('user');
        $view->setModel($model, true);
        $view->setLayout('polls');
        $view->display();
    }

    function setPathway($title) {
        $user =& JFactory::getUser();
        if($user->guest){
            JError::raiseError( 403, JText::_('Access Forbidden') );
            return;
        }
        $app = &JFactory::getApplication();
        $document =& JFactory::getDocument();
        $params = $app->getParams();
        $menus	= &JSite::getMenu();
        $menu	= $menus->getActive();
        $pathway  =& $app->getPathway();

        if (is_object( $menu )) {
            $menu_params = new JParameter( $menu->params );
            if (!$menu_params->get( 'page_title')) {
                $params->set('page_title',	$title);
            }
        } else {
            $params->set('page_title',	$title);
        }
        $document->setTitle( $params->get( 'page_title' ) );
        $pathway->addItem($title, '');
        $params->def( 'show_page_title', 1 );
        $params->def( 'page_title', $title );

        return $params;
    }
}
?>
