<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: CPAuthorization.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class CPAuthorization {

    function CPAuthorization() {
        $auth =& JFactory::getACL();
        $app = &JFactory::getApplication();
        $jcp_config = &$app->getUserState( SESSION_JCP_CONFIG );
        
        $permission_creation = explode(',', $jcp_config[PERMISSION_CREATION]);
        $permission_voting = explode(',',$jcp_config[PERMISSION_VOTING]);
        $permission_managing = explode(',', $jcp_config[PERMISSION_MANAGING]);
        $permission_wysiwyg = explode(',', $jcp_config[PERMISSION_WYSIWYG]);
        $permission_view_results = explode(',', $jcp_config[PERMISSION_VIEW_RESULTS]);
        
        $auth->addACL( 'com_communitypolls', 'create', 'users', 'super administrator', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'vote', 'users', 'super administrator', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'manage', 'users', 'super administrator', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'wysiwyg', 'users', 'super administrator', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'viewing', 'users', 'super administrator', 'polls', 'all' );
        
        $auth->addACL( 'com_communitypolls', 'create', 'users', 'administrator', 'polls', 'all');
        $auth->addACL( 'com_communitypolls', 'vote', 'users', 'administrator', 'polls', 'all');
        $auth->addACL( 'com_communitypolls', 'manage', 'users', 'administrator', 'polls', 'all');
        $auth->addACL( 'com_communitypolls', 'wysiwyg', 'users', 'administrator', 'polls', 'all');
        $auth->addACL( 'com_communitypolls', 'viewing', 'users', 'administrator', 'polls', 'all');

        $auth->addACL( 'com_communitypolls', 'create', 'users', 'manager', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'vote', 'users', 'manager', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'manage', 'users', 'manager', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'wysiwyg', 'users', 'manager', 'polls', 'all' );
        $auth->addACL( 'com_communitypolls', 'viewing', 'users', 'manager', 'polls', 'all' );

        foreach($permission_creation as $usertype){
            $auth->addACL( 'com_communitypolls', 'create', 'users', $usertype, 'polls', 'all' );
        }

        foreach($permission_voting as $usertype){
            $auth->addACL( 'com_communitypolls', 'vote', 'users', $usertype, 'polls', 'all' );
        }

        foreach($permission_managing as $usertype){
            $auth->addACL( 'com_communitypolls', 'manage', 'users', $usertype, 'polls', 'own' );
        }

        foreach($permission_wysiwyg as $usertype){
            $auth->addACL( 'com_communitypolls', 'wysiwyg', 'users', $usertype, 'polls', 'all' );
        }

        foreach($permission_view_results as $usertype){
            $auth->addACL( 'com_communitypolls', 'viewing', 'users', $usertype, 'polls', 'all' );
        }
    }

    function authorize($component,$action,$section,$scope){
        $app = &JFactory::getApplication();
        $user =& JFactory::getUser();
        $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
        if($user->guest == 1){
            switch ($action){
                case 'create':
                    if(strpos($jcp_config[PERMISSION_CREATION], 'public frontend') !== false){
                        return true;
                    }
                    break;
                case 'vote':
                    if(strpos($jcp_config[PERMISSION_VOTING], 'public frontend') !== false){
                        return true;
                    }
                    break;
                case 'wysiwyg':
                    if(strpos($jcp_config[PERMISSION_WYSIWYG], 'public frontend') !== false){
                        return true;
                    }
                    break;
                case 'viewing':
                    if(strpos($jcp_config[PERMISSION_VIEW_RESULTS], 'public frontend') !== false){
                        return true;
                    }
                    break;
				default:
					return false;
            }
        }else{
            return $user->authorize($component,$action,$section,$scope);
        }
    }
}