<?php
/**
 * Joomla! 1.5 component Community Crosswords
 *
 * @version $Id: helper.php 2010-10-02 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Surveys
 * @license GNU/GPL
 *
 * Crosswords is a Joomla component to generate crosswords with Community touch.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

class CPTemplateManager {

    function getLayoutPath($template, $layout) {
        if(strlen($layout) <= 0) {
            return false;
        }
        $file = $layout . '.php';
        $templatePath = CPTemplateManager::getTemplatePath($template, $file);
        if(JFile::exists($templatePath . $file)){
            return $templatePath . $file;
        }else{
            return false;
        }
    }

    function getTemplatePath($template, $file){
    	$templatePath = null;
        if(strlen($template) <= 0) {
            $templatePath =  DEFAULT_TEMPLATE_PATH . DS . "default" . DS;
        }else if(JFile::exists( TEMPLATE_OVERRIDES_PATH . DS . $template . DS . $file )) {
            $templatePath =  TEMPLATE_OVERRIDES_PATH . DS . $template . DS;
        }else if(JFile::exists(DEFAULT_TEMPLATE_PATH . DS . $template . DS . $file)) {
            $templatePath =  DEFAULT_TEMPLATE_PATH . DS . $template . DS;
        }else {
            $templatePath =  DEFAULT_TEMPLATE_PATH . DS . "default" . DS;
        }

        return $templatePath;
    }

    function getTemplateUrlPath($template, $file){
    	$file = $file . '.php';
        if(strlen($template) <= 0) {
            $templatePath =  DEFAULT_TEMPLATE_URL . "default";
        }else if(JFile::exists(TEMPLATE_OVERRIDES_PATH . DS . $template . DS . $file )) {
            $templatePath =  TEMPLATE_OVERRIDES_URL . $template;
        }else if(JFile::exists(DEFAULT_TEMPLATE_PATH . DS . $template . DS . $file)) {
            $templatePath =  DEFAULT_TEMPLATE_URL . $template;
        }else {
            $templatePath =  DEFAULT_TEMPLATE_URL . "default";
        }

        return $templatePath;
    }

    function renderModules($position, $attribs = array()) {
        jimport( 'joomla.application.module.helper' );
        $modules = JModuleHelper::getModules( $position );
        $modulehtml = '';

        foreach($modules as $module) {
            $params = new JParameter( $module->params );
            $moduleClassSuffix 	= $params->get('moduleclass_sfx', '');

            $modulehtml .= '<div class="moduletable'.$moduleClassSuffix.'">';
            $modulehtml .= JModuleHelper::renderModule($module, $attribs);
            $modulehtml .= '</div>';
        }

        echo $modulehtml;
    }
}