var requestSent = false;
var resultsShown = false;
form_submitted = false;
function drawInteractivePie(container, chartWidth, chartHeight, optionsArray, votesArray, colorsArray){
    if(null == container || null == optionsArray || optionsArray.length == 0 || null == votesArray || votesArray.length == 0){
        return false;
    }
    var data = new google.visualization.DataTable();
    data.addColumn('string', 'Option');
    data.addColumn('number', 'Votes');
    var rowElements = new Array();;
    var elementsCount = optionsArray.length;
    for(i=0;i<elementsCount;i++){
        if(votesArray[i] <= 0){
            votesArray[i] = 0.001;
        }
        rowElements[i]=[optionsArray[i],{v:parseFloat(votesArray[i]),f:votesArray[i]+' votes'}];
    }
    data.addRows(rowElements);
    if(colorsArray.length > elementsCount){
        var tempArray = new Array();
        for(i=0;i<elementsCount;i++){
            tempArray[i]=colorsArray[i];
        }
        colorsArray = tempArray;
    }
    var _pieChart = new google.visualization.PieChart(container);
    _pieChart.draw(data,{
        width:              chartWidth,
        height:             chartHeight,
        is3D:               true,
        legend:             'none',
        colors:             colorsArray,
        pieJoinAngle:       0.00
    });
    return true;
}

function getElementsByName_iefix(tag, name) {
	var elem = document.getElementsByTagName(tag);
	var arr = new Array();
	for (i = 0, iarr = 0; i < elem.length; i++) {
		att = elem[i].getAttribute("name");
		if (att == name) {
			arr[iarr] = elem[i];
			iarr++;
		}
	}
	return arr;
}

function checkPollFields(desc_required, desc_min_length){
    if(form_submitted){
        return false;
    }
    var title = document.getElementById('polltitle');
    var option1 = document.getElementById('text-0');
    var option2 = document.getElementById('text-1');
    var category = document.getElementById('catid');
    var description = document.getElementById('description');

    if(category.value == '' || category.value == '0'){
        alert(document.getElementById('msg_alert_category').innerHTML);
        return false;
    }
    if(title.value == '' || title.value == null){
        alert(document.getElementById('msg_alert_title').innerHTML);
        return false;
    }

    if(option1.value == '' || option1.value == null || option2.value == '' || option2.value == null){
        alert(document.getElementById('msg_alert_option').innerHTML);
        return false;
    }

    if(desc_required && (desc_min_length != 0)){
    	if((typeof tinyMCE != 'undefined') && tinyMCE.getInstanceById('description')){
    		tinyMCE.triggerSave();
    		var ed = tinyMCE.get('description');
    		description.value = ed.getContent();
    	}
        if(description.value == '' || description.value == null){
            alert(document.getElementById('msg_alert_desc').innerHTML);
            return false;
        }else if(description.value.length < desc_min_length){
            alert(document.getElementById('msg_alert_desc_min_length').innerHTML);
            return false;
        }
    }
    var polloptions = getElementsByName_iefix('input','polloption[]');
    if(typeof(polloptions) != 'undefined' && polloptions){
        for(var i=0; i<polloptions.length; i++){
            option_value = polloptions[i].value.replace(/^\s\s*/, '').replace(/\s\s*$/, '');
            if(option_value != '' && option_value != null){
                hiddenOption = document.createElement('input');
                hiddenOption.name = 'pollOptions[]';
                hiddenOption.type = 'hidden';
                hiddenOption.id = 'hiddenOption-'+i;
                option_id = polloptions[i].id;
                hiddenOption.value = option_id.substr(option_id.indexOf('-')+1) + '|' + option_value;
                document.forms.newPoll.appendChild(hiddenOption);
            }
        }
    }
    form_submitted = true;
    document.forms.newPoll.submit();
}
function doAjaxUpload(file, response){
    var xmlDoc = getXmlDoc(response);
    var rootNode = fleegix.xml.parse(xmlDoc).root;
    if(typeof(rootNode.errormsg) != 'undefined' && rootNode.errormsg != 0){
        alert(rootNode.errormsg);
    }else{
        upload_div = document.getElementById('cp_media');
        option_textbox_id = upload_div.parentNode.getElementsByTagName('input')[0].id;
        var current_id = option_textbox_id.substr(option_textbox_id.indexOf('-')+1);
        var hiddenFlds = upload_div.parentNode.getElementsByTagName('hidden');
        var hiddenFld = null;
        if(hiddenFlds != null && ((typeof hiddenFld) != 'undefined')){
            for(var i=0; i< hiddenFlds.length; i++){
                if(hiddenFlds[i].id == 'image-' + current_id){
                    hiddenFld = hiddenFlds[i];
                    break;
                }
            }
        }
        if(hiddenFld != null){
            hiddenFld.setAttribute('value', rootNode.uploadname);

            upload_file_label = upload_div.parentNode.getElementById('uploaded_image');
            upload_file_label.innerHTML = "<strong>Image:</strong> " + rootNode.uploadname;
        }else{
            hiddenFld = document.createElement('input');
            hiddenFld.setAttribute('type', 'hidden');
            hiddenFld.setAttribute('name', 'imageAttachment[]');
            hiddenFld.setAttribute('id', 'image-' + current_id);
            hiddenFld.setAttribute('value', current_id + '|' + rootNode.uploadname);
            upload_div.parentNode.appendChild(hiddenFld);

            var upload_file_label = document.createElement('div');
            upload_file_label.setAttribute('id', 'uploaded_image');
            upload_file_label.innerHTML = "<strong>Image:</strong> " + rootNode.uploadname + '&nbsp;';

            upload_div.parentNode.appendChild(upload_file_label);
        }

        upload_div.style.display = 'none';
    }
}
function checkExtension(extension){
    if (!(extension && /^(jpg|png|jpeg|gif)$/i.test(extension))){
        alert('Error: invalid file extension');
        return false;
    }
    return true;
}
function toggleGrid(selectBox){
    var gridColumnForm = document.getElementById('grid_columns');
    if(selectBox.value != 'grid'){
        gridColumnForm.style.display = 'none';
    }else{
        gridColumnForm.style.display = '';
    }
}

function addNewColumn(){
    var gridColumnForm = document.getElementById('grid_columns');
    var columnNumber = gridColumnForm.getElementsByTagName('input').length + 1;

    if(columnNumber > 10){
        alert(document.getElementById('msg_column_count_exceeded').innerHTML);
        return false;
    }

    var tr = document.createElement("tr");
    var th = document.createElement("th");
    var td = document.createElement("td");

    th.innerHTML = document.getElementById('lbl_column').innerHTML + ' ' + columnNumber;

    var input = document.createElement('input');
    input.type = 'text';
    input.size = '50';
    input.name = 'pollColumn[]';
    input.id = 'column-' + columnNumber;
    input.className = 'forminput';

    tr.appendChild(th);
    tr.appendChild(td);
    td.appendChild(input);

    var tbody = gridColumnForm.getElementsByTagName('table')[0].getElementsByTagName('tbody')[0];
    tbody.appendChild(tr);
    return true;
}

function updateBarChart(options,LBL_VOTES){
    for (i=0; i < options.length; i++){
        var percent = options[i].percent+'%';
        var votes = ' (' + options[i].votes + ' ' + LBL_VOTES + ')';
        jQuery("#option" + (i+1)).css("width",percent);
        jQuery("#vote" + (i+1)).html(votes);
        jQuery("#percent" + (i+1)).html(percent);
    }
}

function updatePieChart(options,alt){
    var piearcs = '';
    var titles = '';
    for (i=0; i < options.length; i++){
        jQuery("#pie-bar-" + i).css("width", options[i].percent + "%");
        jQuery("#pie-votes-" + i).html(options[i].votes);
        jQuery("#pie-percent-" + i).html(options[i].percent + "%");
        piearcs = piearcs + Math.round(parseFloat(options[i].percent)) + ',';
        titles = titles + options[i].percent + '%|';
    }
    piearcs = piearcs.substr(0, piearcs.length - 1);
    titles = titles.substr(0, titles.length - 1);
    var piesrcold = jQuery('#pieimg').attr("src");
    colors = piesrcold.substr(piesrcold.indexOf('chco=') + 5);
    dimensions = piesrcold.substr(piesrcold.indexOf('chs=') + 4);
    var date = new Date();
    piesrc = 'http://chart.apis.google.com/chart?chs=' + dimensions + '&amp;chd=t:' + piearcs + '&amp;cht=p3&amp;chl=' + titles +  '&amp;chco=' + colors;
    piesrc = piesrc + '&amp;v=' + date.getTime();
    html = '<img src="' + piesrc + '" alt="' + alt + '"/>';
    jQuery('#pieimgwrap').html(html);
}

function updateInteractivePieChart(options, colorsArray, width, height){
    var optionsArray = new Array();
    var votesArray = new Array();
    for (i=0; i < options.length; i++){
        jQuery("#pie-bar-" + i).css("width", options[i].percent + '%');
        jQuery("#pie-votes-" + i).html(options[i].votes);
        jQuery("#pie-percent-" + i).html(options[i].percent + '%');
        votesArray[i] = options[i].votes;
        optionsArray[i] = jQuery("#option-title-" + i).text();
    }
    drawInteractivePie(
        document.getElementById('iPieContainer'),
        width,
        height,
        optionsArray,
        votesArray,
        colorsArray
    );
}
function updateGridChart(votes){
	//option_id
	//column_id
	//votes
	var options = new Array();
	var flag = false;
    for(i=0; i<votes.length; i++){
        flag = false;
        for(j=0; j<options.length; j++){
            if(options[j].id == votes[i].option_id){
                if(options[j].columns != null){
                    column = new Object();
                    column.id = votes[i].column_id;
                    column.count = parseInt(votes[i].votes);
                    options[j].columns[options[j].columns.length] = column;
                    options[j].count += parseInt(votes[i].votes);
                }
                flag = true;
            }
        }
        if(!flag){
            var pos = options.length;
            var column = new Object();
            column.id = votes[i].column_id;
            column.count = parseInt(votes[i].votes);
            options[pos] = new Object();
            options[pos].id = votes[i].option_id;
            options[pos].columns = new Array();
            options[pos].columns[0] = column;
            options[pos].count = parseInt(votes[i].votes);
        }
    }
	if (!Number.toFixed) {
	    Number.prototype.toFixed=function(x) {
	        var temp=this;
	        temp=Math.round(temp*Math.pow(10,x))/Math.pow(10,x);
	        return temp;
	    };
	}
    for(i=0; i< options.length; i++){
        var max = 0;
        var maxElement = null;
        for(j=0; j<options[i].columns.length; j++){
            var id = options[i].id + '_' + options[i].columns[j].id;
            var element = document.getElementById(id);
            if(element != null){
                var span = document.createElement('span');
                var percent = (options[i].columns[j].count * 100 / options[i].count).toFixed(2);
                var span = document.createElement('span');
                if(options[i].columns[j].count > max){
                    maxElement = span;
                    max = options[i].columns[j].count;
                }
                span.innerHTML = percent + '%';
                parent = element.parentNode;
                parent.appendChild(span);
                jQuery(element).remove();
            }
        }
        if(null != maxElement){
            maxElement.className = 'highlight';
        }
    }
	jQuery(".gridtable > tbody").find("input[type='radio']").replaceWith("0%");
}
function updateCharts(data){
	var poll = data.poll; 
	if(typeof data.error != 'undefined' && data.error.length > 0){
		alert(data.error);
		jQuery('#loadingImg').hide();
	}else if(typeof data.info != 'undefined' && data.info.length > 0){
		alert(data.info);
		jQuery('#loadingImg').hide();
	}else{
		var charttpe = parseInt(jQuery("#txt_chart_type").text());
		switch(charttpe){
		case 0:
			updateBarChart(poll.options,jQuery("#lbl_votes").html());
			break;
		case 1:
			updatePieChart(poll.options, jQuery("#lbl_loading").html());
			break;
		case 2:
			var txt_colors = jQuery("#txt_colors").html();
			var colors_array = txt_colors.split("|");
			var width = parseInt(jQuery("#txt_width").html());
			var height = parseInt(jQuery("#txt_height").html());
			updateInteractivePieChart(poll.options,colors_array,width,height);
			break;
		case 3:
			updateGridChart(poll.votesEx);
			break;
		}
		if(charttpe == 0 || charttpe == 1 || charttpe == 2){
		    jQuery("#votingform").remove();
		    jQuery("#resultchart").show();
		    jQuery('#btnToggleResult').remove();
		}
	    jQuery('#loadingImg').remove();
	    jQuery('#btnVote').remove();
	}
}
function attachHandlers(){
	jQuery(".nav-links").find("a").button();
	jQuery("#btnVote").click(function(){
		jQuery('#loadingImg').show();
		jQuery("#votingform").ajaxSubmit({ 
			type			: "post", 
			dataType		: "json",
			success			: function(poll, status, xhr, form){
				updateCharts(poll);
			}
		});
		return false;
	});
	jQuery("#btnToggleResult").toggle(
		function(){
			jQuery("#btnToggleResult").button("option","label",jQuery("#lbl_hide_result").html());
			jQuery("#resultchart").slideDown(1000);
			jQuery("#votingform").slideUp(1000);
			jQuery("#btnVote").fadeOut(1000);
		},
		function(){
			jQuery("#btnToggleResult").button("option","label",jQuery("#lbl_view_result").html());
			jQuery("#resultchart").slideUp(1000);
			jQuery("#votingform").slideDown(1000);
			jQuery("#btnVote").fadeIn(1000);
		}
	);
	jQuery('#poll-suggestions').tabs();
	jQuery("#cmd_preview_poll").click(function(){
		var dialog = jQuery('<div>',{'class':'polls-anywhere-dialog'}).appendTo('body');
		var url = jQuery(this).attr("href");
		dialog.dialog({
			width : 300, 
			height: 'auto',
			modal: true,
			close: function(){
				jQuery(".polls-anywhere-dialog").remove();
			}
		});
		dialog.load(url);
		return false;
	});
	
	jQuery("#embed_pollsanywhere").toggle(
		function(){
			jQuery("#pollsanywhere_code").slideDown(1000);
		},
		function(){
			jQuery("#pollsanywhere_code").slideUp(1000);
		}
	);
	jQuery(".submenu").find("a:last").attr("style","border-right: 0pt none");
	
	jQuery(".btn_upload").click(function(){
		var current_id = jQuery(this).attr("id").substr(jQuery(this).attr("id").indexOf('-')+1);
		if(jQuery(this).parent().find("form").length > 0){
			jQuery("#uploadFormHolder").append(jQuery("#uploadform"));
		}else{
			jQuery("#uploadform").empty();
			jQuery("#uploadform").append(
				jQuery("<input>",{"type":"file","name":"uploadFile"}),
				jQuery("<input>",{"type":"submit","class":"button","style":"font-size: 10px"}).val(jQuery("#lbl_upload_file").html())
			);
			jQuery("#uploadform").ajaxForm({
				dataType : "xml",
				success: function(data, statusText, xhr, $form) {
					var error = jQuery("errormsg",data).text();
					if(typeof error != 'undefined' && error != null && error.length > 0){
		        		alert(error);
					}else{
						jQuery("#td-"+current_id).find("input[name='imageAttachment[]']").remove();
						jQuery("#td-"+current_id).find("div[class='image-attachment']").remove();
						jQuery("#td-"+current_id).append(jQuery("<div>",{"class":"image-attachment"}).append(jQuery("#lbl_image").html()+": "+jQuery("uploadname",data).text()));
						jQuery("#td-"+current_id).append(jQuery("<input>",{"type":"hidden","name":"imageAttachment[]"}).val(current_id+'|'+jQuery("uploadname",data).text()));
						jQuery("#uploadFormHolder").append(jQuery("#uploadform"));
					}
				}
			});
			jQuery(this).after(jQuery("#uploadform"));
		}
	});
	
    jQuery("#btn_new_option").bind("click", function(){
        var options_length = jQuery("#options-tbody").find("input").length;
    	if(options_length < 2){
    		alert(jQuery("#msg_alert_error_processing").html());
    	}
    	var media = (jQuery("#msg_allow_images").text() == '1') ? true : false;
    	if(jQuery("#options-tbody").append(
        	jQuery("<tr>").append(
            	jQuery("<th>").append(jQuery("#lbl_option").html()+' '+(options_length+1)),
            	jQuery("<td>",{"id":"td-"+options_length,"nowrap":"nowrap"}).append(
        			jQuery("<input>",{"type":"text","id":"text-"+options_length,"class":"forminput"}).attr("name","polloption[]")
    			)
            )
		));
		if(media){
			jQuery("#td-"+options_length).append(
				jQuery("#media-0").clone(true).attr("id","media-"+options_length)
			);
		}
    });
}