<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: view.html.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Community Polls component
 */
class CommunityPollsViewPolls extends JView {
	function display($tpl = null) {
		global $option;
		$app = &JFactory::getApplication();
		$jcp_config = $app->getUserState( SESSION_JCP_CONFIG );
		$user =& JFactory::getUser();
		$model = $this->getModel('polls');
		$params = $app->getParams();
		$menu = &JSite::getMenu();
		$mnuitems	= $menu->getItems('link', 'index.php?option=com_communitypolls&controller=polls');
		$itemid = isset($mnuitems[0]) ? '&amp;Itemid='.$mnuitems[0]->id : '';
		$pathway  = &$app->getPathway();
		$document = &JFactory::getDocument();

		switch ($this->getLayout()){
			case "list":
				$result =& $this->get('polls');
				$categories = $this->get('categories');
				$pagination =& $this->get('Pagination');
				for($i=0; $i<count($result->items); $i++) {
					$result->items[$i]->eligible = $model->traceEligibility($result->items[$i], true);
				}

				// JomComment Integration
				$polls = $result->items;
				$cids = null;
				if($polls) {
					foreach ($polls as $poll) {
						$cids[] = $poll->id;
					}
					if($cids && $jcp_config[COMMENT_SYSTEM] == "jomcomment") {
						$comments = &$model->getJomCommentCount($cids,$option);
						if($comments) {
							for($i=0; $i< count($polls); $i++) {
								foreach ($comments as $comment) {
									if($comment->contentid == $polls[$i]->id) {
										$polls[$i]->comments = $comment->comments;
										break;
									}
								}
							}
						}
					}
				}
				// End - JomComment Integration

				$this->assignRef( 'polls', $polls );
				$this->assignRef( 'categories', $categories );
				$this->assignRef( 'lists', $result->lists );
				$this->assignRef( 'pagination', $result->pagination );

				$params =& $this->setPathway(JText::_('TITLE_POLLS'));
				break;
			case "viewpoll":
				$poll =& $model->getPollData();
				$categoryPath = JRoute::_( 'index.php?option=com_communitypolls&controller=polls&task=list&catid='.
				$poll->catid . $itemid );
				$pathway->addItem($poll->category, $categoryPath);
				$params =& $this->setPathway($poll->title);

				if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
					// Do nothing.. Allow viewing the poll
				}else if(!isset($poll) || $poll->id <= 0) {
					JError::raiseError( 403, JText::_('Access Forbidden') );
					return;
				}else if($user->guest || $poll->created_by != $user->id) {
					if($poll->published != 1) {
						JError::raiseError( 403, JText::_('Access Forbidden') );
						return;
					}
				}

				PollsHelper::getChartData($poll);
				$this->assignRef('poll', $poll);
				if(strcmp($poll->type,'grid') == 0){
					$this->setLayout("viewpoll_grid");
				}
				if(!empty($jcp_config[SHARE_THIS_PUBID])){
					$document->addScript("http://w.sharethis.com/button/sharethis.js#publisher=".$jcp_config[SHARE_THIS_PUBID]."&amp;type=website&amp;post_services=email%2Cfacebook%2Ctwitter%2Cgbuzz%2Cmyspace%2Cdigg%2Csms%2Cwindows_live%2Cdelicious%2Cstumbleupon%2Creddit%2Cgoogle_bmarks%2Clinkedin%2Cbebo%2Cybuzz%2Cblogger%2Cyahoo_bmarks%2Cmixx%2Ctechnorati%2Cfriendfeed%2Cpropeller%2Cwordpress%2Cnewsvine&amp;button=false");
					$style ="body {font-family:helvetica,sans-serif;font-size:12px;}\na.stbar.chicklet img {border:0;height:16px;width:16px;margin-right:3px;vertical-align:middle;}\na.stbar.chicklet {height:16px;line-height:16px;}";
					$document->addStyleDeclaration($style, 'text/css');
				}

				if($jcp_config[PROCESS_CONTENT_PLUGINS] == '1'){
					JPluginHelper::importPlugin('content');
					$params =& $app->getParams('com_content');
					$item = new JObject();
					$item->text = $poll->description;
					$item->title = $poll->title;
					$dispatcher =& JDispatcher::getInstance();
					$id = 0;
					$dispatcher->trigger('onPrepareContent', array (& $item, & $params, &$id));
					$poll->description = $item->text;
				}
				break;
			case "newpoll":
				$categories =& $this->get( 'categories');
				$this->assignRef( 'categories', $categories );
				$params =& $this->setPathway(JText::_('TITLE_NEW_POLL'));
				break;
			case "userpolls":
				$model = $this->getModel('user');
				$userid = JRequest::getVar('uid',0,'','INT');
				$pollid = JRequest::getVar('pollid',null,'','INT');
				$result =& $model->getPollsCreatedByUser($userid);
				$uri =& JFactory::getURI();
				if($result) {
					$pagination =& $model->getPagination($userid);
					for($i=0; $i<count($result); $i++) {
						$result[$i]->eligible = $model->traceEligibility($result[$i]->id, true);
					}
					$this->assignRef( 'items', $result);
					$this->assignRef( 'lists', $this->_buildSortLists() );
					$this->assignRef( 'pagination', $pagination );
				}
				$this->assign('action', str_replace('&', '&amp;', $uri->toString()));
				$params =& $this->setPathway(JText::_('TITLE_POLLS'));
				$this->assignRef( 'pollid', $pollid);
				break;
			case "votedusers":
				$model = $this->getModel('polls');
				$pollid = JRequest::getVar('pollid',null,'','INT');
				$result =& $model->getUsersVoted($pollid);
				if(count($result) < 2) {
					echo "List is not yet available. Please try again later.";
				}else {
					jimport('joomla.html.pagination');
					$pagination = new JPagination(count($result), 0, count($result));
					$this->assignRef( 'items', $result);
					$this->assignRef( 'pagination', $pagination);
				}
				$this->assignRef( 'pollid', $pollid);
				break;
			case "polls_anywhere":
				break;
		}

		$catid = JRequest::getInt('catid', 0);
		$this->assignRef('category', $catid);
		$this->assignRef('params', $params);

		$this->assign("layoutPath", $this->getLayout());
		$this->setLayout("home");
		parent::display($tpl);
	}

	function _buildSortLists() {
		// Table ordering values
		$filter = JRequest::getString('filter');
		global $option;
		$app = &JFactory::getApplication();
		$itemid = JRequest::getInt('id',0) . ':' . JRequest::getInt('Itemid',0);
		$filter_order  = $app->getUserStateFromRequest($option . '.userpolls.' . $itemid . '.filter_order', 'filter_order', '', 'cmd');
		$filter_order_Dir = $app->getUserStateFromRequest($option . '.userpolls.list.' . $itemid . '.filter_order_Dir', 'filter_order_Dir', '', 'cmd');
		$lists['task']      = 'userpolls';
		$lists['filter']    = $filter;
		$lists['order']     = $filter_order;
		$lists['order_Dir'] = $filter_order_Dir;

		return $lists;
	}

	function setPathway($title) {
		$app = &JFactory::getApplication();
		$document =& JFactory::getDocument();
		$params = $app->getParams();
		$menus	= &JSite::getMenu();
		$menu	= $menus->getActive();
		$pathway  =& $app->getPathway();

		if (is_object( $menu )) {
			$menu_params = new JParameter( $menu->params );
			if (!$menu_params->get( 'page_title')) {
				$params->set('page_title',	$title);
			}
		} else {
			$params->set('page_title',	$title);
		}
		$document->setTitle( $params->get( 'page_title' ) );
		$pathway->addItem($title, '');
		$params->def( 'show_page_title', 1 );
		$params->def( 'page_title', $title );

		return $params;
	}
}
?>