<?php
/**
 * Joomla! 1.5 component Community Polls
 *
 * @version $Id: view.html.php 2009-08-10 03:45:15 svn $
 * @author Maverick
 * @package Joomla
 * @subpackage Community Polls
 * @license GNU/GPL
 *
 * The Community Polls allows the members of the Joomla website to create and manage polls from the front-end.
 * The administrator has the powerful tools provided in the back-end to manage the polls published by all users.
 */

// no direct access
defined('_JEXEC') or die('Restricted access');

jimport( 'joomla.application.component.view');

/**
 * HTML View class for the Community Polls component
 */
class CommunityPollsViewUser extends JView {
    function display($tpl = null) {
        $app = &JFactory::getApplication();
        $model = $this->getModel('user');
        $params = $app->getParams();
        $user =& JFactory::getUser();
        $uri =& JFactory::getURI();
        if($this->getLayout() == 'polls') {
            $result =& $model->getPollsCreatedByUser();
            $pagination =& $model->getPagination($user->id, 'POLLS');
            for($i=0; $i<count($result); $i++) {
                $result[$i]->eligible = $model->traceEligibility($result[$i]->id, true);
            }
            $this->assignRef( 'items', $result);
            $this->assignRef( 'lists', $this->_buildSortLists() );
        }else if($this->getLayout() == 'votes') {
            $result =& $model->getPollsVotedByUser();
            $pagination =& $model->getPagination($user->id, 'VOTES');
            $this->assignRef( 'items', $result);
            $this->assignRef( 'lists', $this->_buildSortLists('myvotes') );
        }
        $this->assignRef( 'pagination', $pagination );
        $this->assign('action', str_replace('&', '&amp;', $uri->toString()));
        $params =& $this->setPathway(JText::_('TITLE_POLLS'));

        $this->assignRef('params', $params);

        parent::display($tpl);
    }

    function _buildSortLists($task='mypolls') {
    // Table ordering values
        $filter				= JRequest::getString('filter');
        global $option;
        $app = &JFactory::getApplication();
        $itemid = JRequest::getInt('id',0) . ':' . JRequest::getInt('Itemid',0);
        $filter_order  = $app->getUserStateFromRequest($option . '.' . $task . '.' . $itemid . '.filter_order', 'filter_order', '', 'cmd');
        $filter_order_Dir = $app->getUserStateFromRequest($option . '.' . $task  . '.list.' . $itemid . '.filter_order_Dir', 'filter_order_Dir', '', 'cmd');
        $lists['task']      = '';
        $lists['filter']    = $filter;
        $lists['order']     = $filter_order;
        $lists['order_Dir'] = $filter_order_Dir;

        return $lists;
    }

    function setPathway($title) {
        $app = &JFactory::getApplication();
        $document =& JFactory::getDocument();
        $params = $app->getParams();
        $menus	= &JSite::getMenu();
        $menu	= $menus->getActive();
        $pathway  =& $app->getPathway();

        if (is_object( $menu )) {
            $menu_params = new JParameter( $menu->params );
            if (!$menu_params->get( 'page_title')) {
                $params->set('page_title',	$title);
            }
        } else {
            $params->set('page_title',	$title);
        }
        $document->setTitle( $params->get( 'page_title' ) );
        $pathway->addItem($title, '');
        $params->def( 'show_page_title', 1 );
        $params->def( 'page_title', $title );

        return $params;
    }
}
?>