CREATE TABLE IF NOT EXISTS `#__jcp_categories` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `published` tinyint(4) unsigned NOT NULL default '0',
  `locked` tinyint(4) unsigned NOT NULL default '0',
  `num_polls` int(10) unsigned NOT NULL default '0',
  `num_votes` int(10) unsigned NOT NULL default '0',
  `ordering` int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_polls` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `title` varchar(255) NOT NULL,
  `description` text,
  `alias` varchar(255) NOT NULL,
  `votes` int(9) unsigned NOT NULL default '0',
  `voters` int(9) unsigned NOT NULL default '0',
  `published` tinyint(3) default NULL,
  `created` datetime NOT NULL default '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL,
  `last_voted` datetime default '0000-00-00 00:00:00',
  `category` int(10) unsigned NOT NULL default '0',
  `featured` tinyint(3) unsigned NOT NULL default '0',
  `close_date` datetime default NULL,
  `ip_address` varchar(39) default NULL,
  `type` varchar(10) NOT NULL default 'radio',
  `anywhere` tinyint(3) default '0',
  PRIMARY KEY  (`id`),
  KEY `FK_JCP_POLLS` (`category`),
  CONSTRAINT `FK_JCP_POLLS` FOREIGN KEY (`category`) REFERENCES `#__jcp_categories` (`id`)
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_votes` (
  `poll_id` int(10) unsigned NOT NULL,
  `voter_id` int(10) unsigned default NULL,
  `ip_address` varchar(39) default NULL,
  `voted_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `option_id` int(10) unsigned NOT NULL default '0',
  KEY `FK_JCP_VOTES` (`poll_id`),
  CONSTRAINT `FK_JCP_VOTES` FOREIGN KEY (`poll_id`) REFERENCES `#__jcp_polls` (`id`)
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_guest_votes` (
  `poll_id` int(10) unsigned NOT NULL,
  `ip_address` varchar(39) default NULL,
  `voted_on` datetime NOT NULL default '0000-00-00 00:00:00',
  `option_id` int(10) unsigned NOT NULL default '0'
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_options` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `poll_id` int(10) unsigned NOT NULL,
  `title` varchar(255) NOT NULL,
  `votes` int(6) unsigned NOT NULL default '0',
  `order` int(10) unsigned NOT NULL,
  PRIMARY KEY  (`id`)
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_config` (
  `config_name` varchar(255) NOT NULL,
  `config_value` text NOT NULL,
  PRIMARY KEY  (`config_name`)
) TYPE=MyISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_resources` (
  `id` int(10) NOT NULL AUTO_INCREMENT,
  `type` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `poll_id` int(10) unsigned NOT NULL,
  `option_id` int(10) unsigned DEFAULT NULL,
  PRIMARY KEY (`id`)
) TYPE=MYISAM CHARACTER SET `utf8`;

CREATE TABLE IF NOT EXISTS `#__jcp_users` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `polls` int(10) unsigned NOT NULL DEFAULT '0',
  `votes` int(10) unsigned NOT NULL DEFAULT '0',
  `last_poll` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `last_voted` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`)
) TYPE=MYISAM CHARACTER SET `utf8`;