<?php
/**
* @version		$Id: helper.php 11137 2009-05-08 05:29$
* @package		Joomla Related Articles
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined('_JEXEC') or die('Restricted access');

require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');

class modRelatedArticlesHelper
{
	function getItems($params)
	{
		global $mainframe;

		$db					=& JFactory::getDBO();
		$user				=& JFactory::getUser();

        $maxlinks			= intval( $params->get('count', 5) );
		$minlength			= intval( $params->get('minlength', 2) );
		$maxlength			= intval( $params->get('maxlength', 6) );
		$username			= trim($params->get('username', 'name'));
		$filters			= trim($params->get('filterkeywords'));
		$nullDate			= $db->getNullDate();

		$date				=& JFactory::getDate();
		$now				= $date->toMySQL();

		$option				= JRequest::getCmd('option');
		$view				= JRequest::getCmd('view');

		$temp				= JRequest::getString('id');
		$temp				= explode(':', $temp);
		$id					= $temp[0];

		$items				= array();

		if ($option == 'com_content' && $view == 'article' && $id)
		{

			$query = 'SELECT title FROM #__content WHERE id = '.(int) $id;
			$db->setQuery($query);

			if ($title = trim($db->loadResult()))
			{
				$keys = explode(' ', $title);
				$count = "0";
				foreach ($keys as $key)
				{
					$key = trim($key);
					if(!stristr($filters, '^'.$key.'^')){
						if (strlen($key)>=$minlength && strlen($key)<=$maxlength) {
							if($count === "0"){
								$keywords = 'CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
							}else{
								$keywords .= ' OR CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
							}
							$count++;
						}
					}
				}

				if (count($keywords))
				{
					$query = 'SELECT a.id, a.alias, a.title, a.sectionid,'.
							' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
							' s.published AS sec_state, cc.title AS category, u.'. $username .' AS author,' .
							' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
							' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
							' FROM #__content AS a' .
							' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
							' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
							' LEFT JOIN #__users AS u ON u.id = a.created_by' .
							' WHERE a.id != '.(int) $id .
							' AND a.state = 1' .
							' AND a.access <= ' .(int) $user->get('aid', 0) .
							' AND ( '.$keywords.' )' .
							' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
							' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
//echo $query;
					$db->setQuery($query ,0 , $maxlinks);
					$temp = $db->loadObjectList();
					if (count($temp))
					{
						foreach ($temp as $row)
						{
							if (($row->cat_state == 1 || $row->cat_state == '') &&
										($row->sec_state == 1 || $row->sec_state == '') &&
										($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
										($row->sec_access <= $user->get('aid', 0) || $row->sec_access == ''))
							{
								$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
								$items[] = $row;
							}
						}
					}
					unset ($temp);
				}
			}
		}

		return $items;
	}
}
