<?php
/**
 * Helper class for ArticleSuggestions module
 *
 * @package    corejoomla.modules
 * @subpackage Suggestions
 * @link http://www.corejoomla.com
 * @license        GPL
 * Article Suggestion module display different article listings such as latest articles, most read articles, author articles, related articles in a neat tabbed interface with the support for Avatar, short intro etc.
 */
class modArticleSuggestionsHelper {
    /**
     * Retrieves the hello message
     *
     * @param array $params An object containing the module parameters
     * @access public
     */
    function getSuggestions( $params ) {
        $db =& JFactory::getDBO();
        $user =& JFactory::getUser();
        $date =& JFactory::getDate();

        $authorCount=$params->get('author_count');
        $relatedCount=$params->get('related_count');
        $latestCount=$params->get('latest_count');
        $mostReadCount=$params->get('mostread_count');
        $minChars=$params->get('min_chars');
        $showAuthorArticles=$params->get('show_author_articles');
        $showRelatedArticles=$params->get('show_related_articles');
        $showLatestArticles=$params->get('show_latest_articles');
        $showMostReadArticles=$params->get('show_mostread_articles');
        $showIntro=$params->get('show_intro');
        $charCount=$params->get('char_count');
        $showAvtar=$params->get('show_avtar');
        $showSection=$params->get('show_section');
        $showCategory=$params->get('show_category');
        $showHits=$params->get('show_hits');
        $excludes=$params->get('excludes');
        $incl_excl=intval($params->get('incl_excl'));
        $sec_cat_ids=trim($params->get('sec_cat_ids'));
        if(!$sec_cat_ids) {
            $sec_cat_ids = ',^,';
        }

        $relatedArticles=array();
        $authorArticles=array();
        $latestArticles=array();
        $mostReadArticles=array();
        $nullDate=$db->getNullDate();
        $now=$date->toMySQL();

        $where = '';
        if(preg_match('/^[0-9\^\,]*$/', $sec_cat_ids)) {
            $sec_cats = explode("^",$sec_cat_ids);
            $sections = substr($sec_cats[0], 1, strlen($sec_cats[0])-2);
            $categories = substr($sec_cats[1], 1, strlen($sec_cats[1])-2);
            $where = '';
            if(strlen($sections) > 0) {
                $where = ' AND a.sectionid ' . (($incl_excl == '0')?'NOT':'') . ' IN (' . $sections . ')';
            }
            if(strlen($categories) > 0) {
                $where = ' AND a.catid ' . (($incl_excl == '0')?'NOT':'') . ' IN (' . $categories . ')';
            }
        }
        
        
    		$option 		= JRequest::getCmd('option');
    		$view 			= JRequest::getCmd('view');
				$temp				= JRequest::getString('id');
				$temp				= explode(':', $temp);
				$id					= $temp[0];
				if ($option == 'com_content' && $view == 'article' && $id){
					$query = 'SELECT id, title, created_by, created FROM #__content WHERE id = '.(int) $id;
					$db->setQuery($query);
					$article = $db->loadObject();
			
	        if($article && $showAuthorArticles && $authorCount) {
	            $query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
	                    (($showIntro)?'a.introtext,':'') .
	                    ' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
	                    ' s.published AS sec_state, cc.title AS category, u.username AS author,' .
	                    ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
	                    ' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
	                    ' FROM #__content AS a' .
	                    ' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
	                    ' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
	                    ' LEFT JOIN #__users AS u ON u.id = a.created_by' .
	                    ' WHERE a.id != '.(int) $article->id .
	                    ' AND a.state = 1' . $where .
	                    ' AND a.created_by=' . $article->created_by .
	                    ' AND a.access <= ' .(int) $user->get('aid', 0) .
	                    ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
	                    ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
	            $db->setQuery($query ,0 , $authorCount);
	            $temp = $db->loadObjectList();
	            if (count($temp)) {
	                foreach ($temp as $row) {
	                    if (($row->cat_state == 1 || $row->cat_state == '') &&
	                            ($row->sec_state == 1 || $row->sec_state == '') &&
	                            ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
	                            ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')) {
	                        $row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
	                        if($showIntro) {
	                            $row->introtext = modArticleSuggestionsHelper::getIntroArticle($row->introtext,$charCount,'');
	                        }
	                        $authorArticles[] = $row;
	                    }
	                }
	            }
	            unset ($temp);
	        }
	
	        if($article && $showRelatedArticles && $relatedCount && $article->title) {
	            $keys = explode(' ', $article->title);
	            $count = "0";
	            foreach ($keys as $key) {
	                $key = trim($key);
	                if(!stristr($excludes, '^'.$key.'^')) {
	                    if (strlen($key)>=$minChars) {
	                        if($count === "0") {
	                            $keywords = 'CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
	                        }else {
	                            $keywords .= ' OR CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
	                        }
	                        $count++;
	                    }
	                }
	            }
	            if (count($keywords)) {
	                $query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
	                        (($showIntro)?'a.introtext,':'').
	                        ' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
	                        ' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
	                        ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
	                        ' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
	                        ' FROM #__content AS a' .
	                        ' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
	                        ' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
	                        ' LEFT JOIN #__users AS u ON u.id = a.created_by' .
	                        ' WHERE a.id != '.(int) $article->id .
	                        ' AND a.state = 1' . $where .
	                        ' AND a.access <= ' .(int) $user->get('aid', 0) .
	                        ' AND ( '.$keywords.' )' .
	                        ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
	                        ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
	
	                $db->setQuery($query ,0 , $relatedCount);
	                $temp = $db->loadObjectList();
	                if (count($temp)) {
	                    foreach ($temp as $row) {
	                        if (($row->cat_state == 1 || $row->cat_state == '') &&
	                                ($row->sec_state == 1 || $row->sec_state == '') &&
	                                ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
	                                ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')) {
	                            $row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
	                            if($showIntro) {
	                                $row->introtext = modArticleSuggestionsHelper::getIntroArticle($row->introtext,$charCount);
	                            }
	                            $relatedArticles[] = $row;
	                        }
	                    }
	                }
	                unset ($temp);
	            }
	        }
        }

        if($showLatestArticles && $latestCount) {
            $query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
                    (($showIntro)?'a.introtext,':'') .
                    ' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
                    ' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
                    ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
                    ' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
                    ' FROM #__content AS a' .
                    ' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
                    ' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
                    ' LEFT JOIN #__users AS u ON u.id = a.created_by' .
                    ' WHERE a.state = 1' . $where .
                    ' AND a.access <= ' .(int) $user->get('aid', 0) .
                    ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
                    ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'.
                    ' ORDER BY a.created DESC';
            $db->setQuery($query ,0 , $latestCount);
            $temp = $db->loadObjectList();
            if (count($temp)) {
                foreach ($temp as $row) {
                    if (($row->cat_state == 1 || $row->cat_state == '') &&
                            ($row->sec_state == 1 || $row->sec_state == '') &&
                            ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
                            ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')) {
                        $row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
                        if($showIntro) {
                            $row->introtext = modArticleSuggestionsHelper::getIntroArticle($row->introtext,$charCount,'');
                        }
                        $latestArticles[] = $row;
                    }
                }
            }
            unset ($temp);
        }

        if($showMostReadArticles && $mostReadCount) {
            $query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
                    (($showIntro)?'a.introtext,':'') .
                    ' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
                    ' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
                    ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
                    ' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
                    ' FROM #__content AS a' .
                    ' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
                    ' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
                    ' LEFT JOIN #__users AS u ON u.id = a.created_by' .
                    ' WHERE a.state = 1' . $where .
                    ' AND a.access <= ' .(int) $user->get('aid', 0) .
                    ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
                    ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'.
                    ' ORDER BY a.hits DESC';
            $db->setQuery($query ,0 , $mostReadCount);
            $temp = $db->loadObjectList();
            if (count($temp)) {
                foreach ($temp as $row) {
                    if (($row->cat_state == 1 || $row->cat_state == '') &&
                            ($row->sec_state == 1 || $row->sec_state == '') &&
                            ($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
                            ($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')) {
                        $row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
                        if($showIntro) {
                            $row->introtext = modArticleSuggestionsHelper::getIntroArticle($row->introtext,$charCount,'');
                        }
                        $mostReadArticles[] = $row;
                    }
                }
            }
            unset ($temp);
        }
        
        $suggestions->related=&$relatedArticles;
        $suggestions->author=&$authorArticles;
        $suggestions->latest=&$latestArticles;
        $suggestions->mostread=&$mostReadArticles;
        
        return $suggestions;
    }
    
    function getIntroArticle( $text, $length=150, $tags='' ) {
        $text = preg_replace( "'<script[^>]*>.*?</script>'si", "", $text );
        $text = preg_replace( '/{.+?}/', '', $text);
        $text = preg_replace( "'<(br[^/>]*?/|hr[^/>]*?/|/(div|h[1-6]|li|p|td))>'si", ' ', $text );
        $text = strip_tags($text);
        if ( strlen($text) > $length ) {
            $text = substr( $text, 0, $length );
            $blankpos = strrpos( $text, ' ' );
            $text = substr( $text, 0, $blankpos );
            $text .= "...";
        }
        return html_entity_decode( $text );
    }

    function getAvatar( $userid, $useAvatarFrom, $height='48' ) {
        $db	   =& JFactory::getDBO();
        $avatar = '';

        switch ( $useAvatarFrom ) {
            case 'jomsocial':
                $jspath = JPATH_BASE.DS.'components'.DS.'com_community';
                include_once($jspath.DS.'libraries'.DS.'core.php');

                // Get CUser object
                $jsuser =& CFactory::getUser($userid);
                $usrname = $jsuser->username;
                $avatarLoc = $jsuser->getThumbAvatar();
                $link = CRoute::_('index.php? option=com_community&view=profile&userid='.$userid.'&Itemid='.JRequest::getInt('Itemid'));
                $avatar = "<a href=\"$link\"><img class=\"hasTip\"
                        style=\"border: 1px solid #cccccc; height: " . $height . "px;\"
                        src=\"$avatarLoc\" alt=\"$usrname\"  title=\"$usrname\" /></a>";
                break;
            case 'cb':
                $strSql = "SELECT `avatar`, firstname FROM #__comprofiler WHERE `user_id`='{$userid}' AND `avatarapproved`='1'";
                $db->setQuery($strSql);
                $result = $db->loadObject();
                $link = JRoute::_( 'index.php?option=com_comprofiler&amp;task=userProfile&amp;user=' . $userid);
                if($result && !empty($result->avatar)) {
                    $avatarLoc = JURI::base(true)."/images/comprofiler/".$result->avatar;
                } else {
                    $avatarLoc = JURI::base(true)."/components/com_comprofiler/plugin/templates/default/images/avatar/nophoto_n.png";
                }
                $avatar = "<a href=\"" . $link . "\"><img src=\"" . $avatarLoc . "\"" .
                        "class=\"hasTip\" style=\"border: 1px solid #cccccc; height: " . $height . "px;\"" .
                        "alt=\"" . $result->firstname . "\" title=\"" . $result->firstname . "\"/></a>";
                break;
            case 'touch':
                $avatarLoc = JURI::base(true) . '/index2.php?option=com_community&amp;controller=profile&amp;task=avatar&amp;width=' . $height . '&amp;height=' . $height . '&amp;user_id=' . $userid . '&amp;no_ajax=1';
                $avatar = '<img src="' . $avatarLoc . '" style="border: 1px solid #cccccc; height: "' . $height . '"px;" alt=""/>';
                $link = JRoute::_("index.php?option=com_community&view=profile&user_id={$userid}&Itemid=".JRequest::getInt('Itemid'));
                $avatar = '<a href="' . $link . '">' . $avatar . '</a>';
                break;
            case 'gravatar':
                $strSql = 'SELECT email FROM #__users WHERE id=' . $userid;
                $db->setQuery($strSql);
                $email = $db->loadResult();
                $gravatar = 'http://www.gravatar.com/avatar.php?gravatar_id=';
                $gravatar .= md5( strtolower($email) );
                if ( $height ) {
                    $gravatar .= '&amp;size=$height';
                } else {
                    $gravatar .= '&amp;size=48';
                }
                $avatar = '<img src="'.$gravatar.'"/>';
                break;
            case 'kunena':
                $query = "SELECT a.avatar, b." . $username . " FROM #__fb_users as a" .
                        " LEFT JOIN #__users as b on b.id=a.userid where a.userid=".$userid;
                $db->setQuery( $query );
                $kunenaUser = $db->loadObject();
                $kunena_avtar = @$kunenaUser->avatar;
                $kunena_avtars = JURI::base(true) . '/images/fbfiles';
                if ($kunena_avtar != '') {
                    if(!file_exists( JPATH_ROOT .'/images/fbfiles/avatars/l_' . $kunena_avtar)) {
                        $avatarLoc = $kunena_avtars . '/avatars/' . $kunena_avtar;
                    }
                    else {
                        $avatarLoc = $kunena_avtars . '/avatars/l_' . $kunena_avtar;
                    }
                }
                else $avatarLoc = $kunena_avtars . '/avatars/nophoto.jpg';
                //URL
                $usrname = ($kunenaUser->$username)?$kunenaUser->$username:JText::_('GUEST');
                $link = JRoute::_( 'index.php?option=com_kunena&amp;func=fbprofile&amp;userid=' . $userid);
                $avatar = "<a href=\"" . $link . "\" title=\"" . $usrname . "\"><img src=\"" . $avatarLoc . "\"" .
                        "class=\"hasTip\" style=\"border: 1px solid #cccccc; height: " . $height . "px;\"" .
                        "alt=\"" . $usrname . "\"/></a>";
                break;
            case 'aup':
                $strSql = 'SELECT a.avatar, u.' . $username . ' AS username FROM #__alphauserpoints a' .
                        ' LEFT JOIN #__users u ON a.userid = u.id WHERE a.userid=' . $userid;
                $db->setQuery($strSql);
                $result = $db->loadObject();
                if(!$result->avatar || $result->avatar == '' ) {
                    $avatarLoc = JURI::root() . 'components/com_alphauserpoints/assets/images/avatars/generic_gravatar_grey.gif';
                }else {
                    $avatarLoc = JURI::base(true) . '/components/com_alphauserpoints/assets/images/avatars/' . $result->avatar;
                }
                $avatar = '<img src="' . $avatarLoc . '" title="' . $result->username . '">'.
                        '';
                break;
        }
        return $avatar;
    }

    /**
     * Escapes a value for output in a view script.
     *
     * If escaping mechanism is one of htmlspecialchars or htmlentities, uses
     * {@link $_encoding} setting.
     *
     * @param  mixed $var The output to escape.
     * @return mixed The escaped value.
     */
    function escape($var){
		return call_user_func('htmlspecialchars', $var, ENT_COMPAT, 'UTF-8');
    }
}
?>
