<?php
/**
 * Joomla! 1.5 module Community Polls - Random Poll
 *
 * @version $Id: helper.php 2009-05-10 01:47:01 svn $
 * @author CoreJoomla
 * @package modules
 * @subpackage mod_randompoll
 * @license GNU/GPL
 *
 * This module displays the random poll of Community Polls extension.
 */
defined('_JEXEC') or die('Direct Access to this location is not allowed.');
class modRandomPollHelper {

    function &getPoll(&$params) {
        // get a reference to the database
        $db                 =& JFactory::getDBO();
        $user               =& JFactory::getUser();
        $username           = $params->get('username', 0);
        $limitcategories    = trim($params->get('limitcategories', null));
        $custompolls        = trim($params->get('custompolls', null));
        $showclosed			= trim($params->get('showclosed',0));
        $nullDate           = $db->getNullDate();

        $date               =& JFactory::getDate();
        $now                = $date->toMySQL();
        $randnum            = '';

        $where = array();
        $where[] = 'p.published = 1 and p.type != \'grid\'';
        if($custompolls) {
            $where[] = 'p.id IN (' . $custompolls . ')';
        }
        if($limitcategories) {
            $where[] = 'p.category IN (' . $limitcategories . ')';
        }
        if(!$showclosed){
        	$where[] = '(p.close_date IS NULL OR p.close_date > now())';
        }
        if($custompolls) {
            $randnum = modRandomPollHelper::getRandomNumber($db,$custompolls);
        }else {
            $randnum = modRandomPollHelper::getRandomNumber($db,null);
        }

        $where = ( count( $where ) ?  ' AND ' . implode( ' AND ', $where ) : '' );

        $queryStub = 'SELECT p.id, p.title, p.votes, p.published, p.close_date, p.type, p.created_by, c.id as catid,' .
                ' CASE WHEN CHAR_LENGTH(p.alias) THEN CONCAT_WS(":", p.id, p.alias) ELSE p.id END as slug,' .
                ' c.title AS category, u.' . $username . ' AS username, p.description FROM '.
                ' #__jcp_polls p LEFT JOIN #__jcp_categories c ON p.category = c.id ' .
                ' LEFT JOIN #__users u ON p.created_by = u.id WHERE p.id';
        $query = $queryStub  . '>' .$randnum . $where . ' LIMIT 1';
        $db->setQuery($query);
        $poll = $db->loadObject();

        if(!$poll) {
            $query = $queryStub  . '<=' .$randnum . $where . ' LIMIT 1';
            $db->setQuery($query);
            $poll = $db->loadObject();
        }

        if($poll) {
            $query = 'SELECT id,title,votes FROM #__jcp_options WHERE poll_id=' . $poll->id;
            $db->setQuery($query);
            $options = $db->loadObjectList();
            $poll->options = $options;
        }

        return $poll;
    }

    function getRandomNumber(&$db, $custom) {

        if($custom) {
            $nums = explode(',',$custom);
            return mt_rand(min($nums), max($nums));
        }else {
            $query = "SELECT max(id) AS max_id, min(id) AS min_id FROM #__jcp_polls";
            $db->setQuery($query);
            $result = $db->loadObject();
            $random_number = mt_rand($result->min_id, $result->max_id);
            return $random_number;
        }
    }

    function traceEligibility($poll, $skipDB) {
        $app = &JFactory::getApplication();
        $user =& JFactory::getUser();
        $db =& JFactory::getDBO();
        $jcp_config = &$app->getUserState(SESSION_JCP_CONFIG);
        if(!$poll->id) {
            return false;
        }
        
        if(!CPAuthorization::authorize('com_communitypolls','vote','polls','all')) {
            return false;
        }
        
        // Check if the poll is closed for voting.
        if($poll->close_date) {
            $todays_date = date("Y-m-d");
            $today = strtotime($todays_date);
            $close_date = strtotime($poll->close_date);
            if($close_date < $today) {
                return false;
            }
        }
        
        if(strpos($jcp_config[VOTE_RESTRICTION_METHOD],'cookie') !== FALSE){
        	$cookieName	= JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll->id );
        	if(isset($_COOKIE[$cookieName])) {
        		return false;
        	}
        }
        
        if(strpos($jcp_config[VOTE_RESTRICTION_METHOD],'username') !== FALSE && !$user->guest && !$skipDB){
			$query = 'SELECT COUNT(*) FROM ' . TABLE_JCP_VOTES . ' WHERE poll_id=' .$poll->id . ' AND voter_id=' . $user->id . ' AND voter_id > 0';
			$db->setQuery($query);
			$count = $db->loadResult();
			if($count > 0) {
				return false;
			}
        }
        
        if((strpos($jcp_config[VOTE_RESTRICTION_METHOD],'ip') !== FALSE) && !$skipDB){
        	$query = "SELECT COUNT(*) FROM " . TABLE_JCP_VOTES . " WHERE poll_id=" . $poll->id . " AND ip_address=" . $db->Quote(PollsHelper::getUserIP());
        	$db->setQuery($query);
        	$db->setQuery($query);
        	$count = $db->loadResult();
        	if($count > 0) {
        		return false;
        	}
        }
        return true;
    }

    function escape($var) {
        return htmlentities($var, ENT_COMPAT, 'UTF-8');
    }

    function getUserAvtar($userid=0, $height=48, $username='username', $avatar='none') {
        $db = JFactory::getDBO();
        switch ( $avatar ) {
            case 'jomsocial':
                $jspath = JPATH_BASE.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php';
                if(file_exists($jspath)) {
                    include_once($jspath);
                }else {
                    return '';
                }

                // Get CUser object
                $jsuser =& CFactory::getUser($userid);
                $usrname = $jsuser->$username;
                $avatarLoc = $jsuser->getThumbAvatar();
                $link = CRoute::_('index.php? option=com_community&view=profile&userid='.$userid);
                $avatar = "<a href=\"$link\"><img class=\"hasTip\"
                    style=\"border: 1px solid #cccccc; height: " . $height . "px;\"
                    src=\"$avatarLoc\" alt=\"$usrname\"  title=\"$usrname\" /></a>";
                break;
            case 'cb':
                $strSql = "SELECT `avatar`, firstname FROM #__comprofiler WHERE `user_id`='{$userid}' AND `avatarapproved`='1'";
                $db->setQuery($strSql);
                $result = $db->loadObject();
                $link = JRoute::_( 'index.php?option=com_comprofiler&amp;task=userProfile&amp;user=' . $userid);
                if($result && !empty($result->avatar)) {
                    $avatarLoc = JURI::base(true)."/images/comprofiler/".$result->avatar;
                } else {
                    $avatarLoc = JURI::base(true)."/components/com_comprofiler/plugin/templates/default/images/avatar/nophoto_n.png";
                }
                $avatar = "<a href=\"" . $link . "\"><img src=\"" . $avatarLoc . "\"" .
                        "class=\"hasTip\" style=\"border: 1px solid #cccccc; height: " . $height . "px;\"" .
                        "alt=\"" . $result->firstname . "\" title=\"" . $result->firstname . "\"/></a>";
                break;
            case 'kunena':
                $query = "SELECT a.avatar, b." . $username . " FROM #__fb_users as a" .
                        " LEFT JOIN #__users as b on b.id=a.userid where a.userid=".$userid;
                $db->setQuery( $query );
                $kunenaUser = $db->loadObject();
                $kunena_avtar = @$kunenaUser->avatar;
                $kunena_avtars = JURI::base(true) . '/images/fbfiles';
                if ($kunena_avtar != '') {
                    if(!file_exists( JPATH_ROOT .'/images/fbfiles/avatars/l_' . $kunena_avtar)) {
                        $avatarLoc = $kunena_avtars . '/avatars/' . $kunena_avtar;
                    }
                    else {
                        $avatarLoc = $kunena_avtars . '/avatars/l_' . $kunena_avtar;
                    }
                }
                else $avatarLoc = $kunena_avtars . '/avatars/nophoto.jpg';
                //URL
                $usrname = ($kunenaUser->$username)?$kunenaUser->$username:JText::_('GUEST');
                $link = JRoute::_( 'index.php?option=com_kunena&amp;func=fbprofile&amp;userid=' . $userid);
                $avatar = "<a href=\"" . $link . "\" title=\"" . $usrname . "\"><img src=\"" . $avatarLoc . "\"" .
                        "class=\"hasTip\" style=\"border: 1px solid #cccccc; height: " . $height . "px;\"" .
                        "alt=\"" . $usrname . "\"/></a>";
                break;
            case 'aup':
                $strSql = 'SELECT a.avatar, u.' . $username . ' AS username FROM #__alphauserpoints a' .
                        ' LEFT JOIN #__users u ON a.userid = u.id WHERE a.userid=' . $userid;
                $db->setQuery($strSql);
                $result = $db->loadObject();
                if(!$result->avatar || $result->avatar == '' ) {
                    $avatarLoc = JURI::root() . 'components/com_alphauserpoints/assets/images/avatars/generic_gravatar_grey.gif';
                }else {
                    $avatarLoc = JURI::base(true) . '/components/com_alphauserpoints/assets/images/avatars/' . $result->avatar;
                }
                $avatar = '<img src="' . $avatarLoc . '" title="' . $result->username . '">';
                break;
            case 'touch':
                $avatarLoc = JURI::base(true) . '/index2.php?option=com_community&amp;controller=profile&amp;task=avatar&amp;width=' . $height . '&amp;height=' . $height . '&amp;user_id=' . $userid . '&amp;no_ajax=1';
                $avatar = '<img src="' . $avatarLoc . '" style="border: 1px solid #cccccc; height: "' . $height . '"px;" alt=""/>';
                //$avatar = '<a href="' .  . '"> . $avatar . '</a>'
                break;
            default:
                return '';
        }
        return $avatar;
    }

    function getUserNameLink($username, $userid=0, $avatar='none') {
        $link = '';
        switch($avatar) {
            case 'jomsocial':
                $jspath = JPATH_BASE.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php';
                if(file_exists($jspath)) {
                    include_once($jspath);
                    $link = '<a href="' . CRoute::_('index.php? option=com_community&view=profile&userid='.$userid) . '">' . $username . '</a>';
                }
                break;
            case 'cb':
                $link = '<a href="' . JRoute::_( 'index.php?option=com_comprofiler&amp;task=userProfile&amp;user=' . $userid) . '">' . $username . '</a>';
                break;
            case 'touch':
                $link = modRandomPollHelper::getTouchPopup($userid, $username);
                break;
            case 'aup':
                $api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
                if ( file_exists($api_AUP)){
                    require_once ($api_AUP);
                    $link = '<a href="' . AlphaUserPointsHelper::getAupLinkToProfil($userid) . '">' . $username . '</a>';
                }
                break;
            case 'kunena':
                $link = '<a href="' . JRoute::_( 'index.php?option=com_kunena&amp;func=fbprofile&amp;userid=' . $userid) . '">' . $username . '</a>';
                break;
            default:
                $link = '';
        }
        return $link;
    }

    function getTouchPopup($user_id, $user_name) {
        Static $capi = false;
        Static $api_enabled = true;

        if($api_enabled == false) return $user_name;

        if(!$capi) {
            $API = JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'api.php';
            if(file_exists($API)) {
                require_once $API;
                $capi = new JSCommunityApi();
            }
            else {
                $api_enabled = false;
                return $user_name;
            }
        }

        $params['width'] = 400;

        $links[0]->link = JRoute::_( 'index.php?option=com_communitypolls&controller=polls&task=userpolls&uid='.$user_id);
        $links[0]->alt = JText::_('More polls by ') . $user_name;
        $links[0]->icon = 'components/com_communitypolls/assets/images/poll_add.png';

        $user_name = $capi->getUserSlideMenu($user_id, $user_name, $links, $params);

        return $user_name;
    }

} //end
