<?php
/**
 * @version $Id: articlesuggestions.php 1.5
 * @copyright Maverick
 * @license GNU/GPLv2,
 * @author Maverick - http://www.corejoomla.com
 */
defined( '_JEXEC' ) or  die('Restricted access');
jimport( 'joomla.event.plugin' );
jimport( 'joomla.environment.browser' );

class plgContentArticleSuggestions extends JPlugin{

	function plgContentArticleSuggestions( &$subject, $params ){
		parent::__construct( $subject, $params );
	}
	function onPrepareContent( &$article, &$params ){
		$plugin =& JPluginHelper::getPlugin('content', 'articlesuggestions');
		$pluginParams = new JParameter( $plugin->params );		
		$frontpage_enabled = $pluginParams->get('frontpage_enabled');
		if(!$frontpage_enabled){
			$menu = & JSite::getMenu();
			if ($menu->getActive() == $menu->getDefault()) {
				return true;
			}
		}
		if((JRequest::getVar('view')) != 'article'){
			return true;
		}
		$db =& JFactory::getDBO();
		$user =& JFactory::getUser();
		$date =& JFactory::getDate();

		$showAuthorArticles=intval($pluginParams->get('show_author_articles'));
		$authorCount=intval($pluginParams->get('author_count'));
		
		$showRelatedArticles=intval($pluginParams->get('show_related_articles'));
		$relatedCount=intval($pluginParams->get('related_count'));
		
		$showLatestArticles=intval($pluginParams->get('show_latest_articles'));
		$latestCount=intval($pluginParams->get('latest_count'));
		
		$showMostReadArticles=intval($pluginParams->get('show_mostread_articles'));
		$mostReadCount=intval($pluginParams->get('mostread_count'));
		
		$showCategoryArticles=intval($pluginParams->get('show_category_articles'));
		$categoryArticlesCount=intval($pluginParams->get('catarticles_count'));
		
		$minChars=intval($pluginParams->get('min_chars'));
		$jquery_enabled = intval($pluginParams->get('jquery_enabled'));
		
		$showIntro=intval($pluginParams->get('show_intro'));
		$charCount=intval($pluginParams->get('char_count'));
		
		$showAvtar=trim($pluginParams->get('show_avtar','none'));
		$showSection=intval($pluginParams->get('show_section'));
		$showCategory=intval($pluginParams->get('show_category'));
		$showHits=intval($pluginParams->get('show_hits'));
		
		$exclude_keywords=$pluginParams->get('exclude_keywords');
		$include_meta_keywords=$pluginParams->get('include_meta_keywords');
		
		$tab_order = trim($pluginParams->get('tab_order', 'A,C,R,L,M'));
		$tab_order = explode(',', $tab_order);
		
		$show_in_sections=trim($pluginParams->get('show_in_sections'));
		$show_in_categories=trim($pluginParams->get('show_in_categories'));
		
		/** Display plugin only in selected sections/categories */
		if(!empty($show_in_sections)){
			$show_in_sections = explode(',', $show_in_sections);
		}
		if(!empty($show_in_categories)){
			$show_in_categories = explode(',', $show_in_categories);
		}
		
		if(!empty($show_in_sections) && !in_array($article->sectionid, $show_in_sections)){
			return true;
		}
		if(!empty($show_in_categories) && !in_array($article->catid, $show_in_categories)){
			return true;
		}
		/** end display plugin only in selected sections/categories. */
		
		$relatedArticles=array();
		$authorArticles=array();
		$latestArticles=array();
		$mostReadArticles=array();
		$categoryArticles = array();
		
		$nullDate=$db->getNullDate();
		$now=$date->toMySQL();

		if($showAuthorArticles && $authorCount){
			$where = '';
			$include_sections=trim($pluginParams->get('author_include_sections',''));
			$include_categories=trim($pluginParams->get('author_include_categories',''));
			if(strlen($include_sections) > 0){
				$include_sections = explode(',', $include_sections);
				JArrayHelper::toInteger($include_sections);
				$include_sections = implode(',', $include_sections);
				$where = ' AND a.sectionid IN (' . $include_sections . ')';
			}
			if(strlen($include_categories) > 0){
				$include_categories = explode(',', $include_categories);
				JArrayHelper::toInteger($include_categories);
				$include_categories = implode(',', $include_categories);
				$where = ' AND a.catid IN (' . $include_categories . ')';
			}
			
			$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
			(($showIntro)?'a.introtext,':'') .
								' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
								' s.published AS sec_state, cc.title AS category, u.username AS author,' .
								' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
								' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
								' FROM #__content AS a' .
								' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
								' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
								' LEFT JOIN #__users AS u ON u.id = a.created_by' .
								' WHERE a.id != '.(int) $article->id .
								' AND a.state = 1' . $where .
								' AND a.created_by=' . $article->created_by .
								' AND a.access <= ' .(int) $user->get('aid', 0) .
								' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
								' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
			$db->setQuery($query ,0 , $authorCount);
			$temp = $db->loadObjectList();
			if (count($temp)){
				foreach ($temp as $row){
					if (($row->cat_state == 1 || $row->cat_state == '') &&
					($row->sec_state == 1 || $row->sec_state == '') &&
					($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
					($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
						$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
						if($showIntro){
							$row->introtext = $this->getIntroArticle($row->introtext,$charCount,'');
						}
						$authorArticles[] = $row;
					}
				}
			}
			unset ($temp);
		}

		if($showRelatedArticles && $relatedCount && $article->title){
			$where = '';
			$include_sections=trim($pluginParams->get('related_include_sections',''));
			$include_categories=trim($pluginParams->get('related_include_categories',''));
			if(strlen($include_sections) > 0){
				$include_sections = explode(',', $include_sections);
				JArrayHelper::toInteger($include_sections);
				$include_sections = implode(',', $include_sections);
				$where = ' AND a.sectionid IN (' . $include_sections . ')';
			}
			if(strlen($include_categories) > 0){
				$include_categories = explode(',', $include_categories);
				JArrayHelper::toInteger($include_categories);
				$include_categories = implode(',', $include_categories);
				$where = ' AND a.catid IN (' . $include_categories . ')';
			}
			
			$keys = array();
			if($include_meta_keywords){
				$keys = explode(',', $article->metakey);
			}
			$title_keys = explode(' ', $article->title);
			array_merge($keys, $title_keys);
			
			$count = "0";
			foreach ($keys as $key){
				$key = trim($key);
				if(!stristr($exclude_keywords, '^'.$key.'^')){
					if (strlen($key)>=$minChars) {
						if($count === "0"){
							$keywords = 'CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
						}else{
							$keywords .= ' OR CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
						}
						$count++;
					}
				}
			}
			if (count($keywords)){
				$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
				(($showIntro)?'a.introtext,':'').
								' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
								' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
								' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
								' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
								' FROM #__content AS a' .
								' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
								' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
								' LEFT JOIN #__users AS u ON u.id = a.created_by' .
								' WHERE a.id != '.(int) $article->id .
								' AND a.state = 1' . $where .
								' AND a.access <= ' .(int) $user->get('aid', 0) .
								' AND ( '.$keywords.' )' .
								' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
								' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

				$db->setQuery($query ,0 , $relatedCount);
				$temp = $db->loadObjectList();
				if (count($temp)){
					foreach ($temp as $row){
						if (($row->cat_state == 1 || $row->cat_state == '') &&
						($row->sec_state == 1 || $row->sec_state == '') &&
						($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
						($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
							$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
							if($showIntro){
								$row->introtext = $this->getIntroArticle($row->introtext,$charCount);
							}
							$relatedArticles[] = $row;
						}
					}
				}
				unset ($temp);
			}
		}

		if($showLatestArticles && $latestCount){
			$where = '';
			$include_sections=trim($pluginParams->get('latest_include_sections',''));
			$include_categories=trim($pluginParams->get('latest_include_categories',''));
			if(strlen($include_sections) > 0){
				$include_sections = explode(',', $include_sections);
				JArrayHelper::toInteger($include_sections);
				$include_sections = implode(',', $include_sections);
				$where = ' AND a.sectionid IN (' . $include_sections . ')';
			}
			if(strlen($include_categories) > 0){
				$include_categories = explode(',', $include_categories);
				JArrayHelper::toInteger($include_categories);
				$include_categories = implode(',', $include_categories);
				$where = ' AND a.catid IN (' . $include_categories . ')';
			}
			
			$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
			(($showIntro)?'a.introtext,':'') .
								' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
								' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
								' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
								' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
								' FROM #__content AS a' .
								' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
								' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
								' LEFT JOIN #__users AS u ON u.id = a.created_by' .
								' WHERE a.id != '.(int) $article->id .
								' AND a.state = 1' . $where .
								' AND a.access <= ' .(int) $user->get('aid', 0) .
								' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
								' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'.
								' ORDER BY a.created DESC';
			$db->setQuery($query ,0 , $latestCount);
			$temp = $db->loadObjectList();
			if (count($temp)){
				foreach ($temp as $row){
					if (($row->cat_state == 1 || $row->cat_state == '') &&
					($row->sec_state == 1 || $row->sec_state == '') &&
					($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
					($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
						$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
						if($showIntro){
							$row->introtext = $this->getIntroArticle($row->introtext,$charCount,'');
						}
						$latestArticles[] = $row;
					}
				}
			}
			unset ($temp);
		}

		if($showMostReadArticles && $mostReadCount){
			$where = '';
			$include_sections=trim($pluginParams->get('mostread_include_sections',''));
			$include_categories=trim($pluginParams->get('mostread_include_categories',''));
			if(strlen($include_sections) > 0){
				$include_sections = explode(',', $include_sections);
				JArrayHelper::toInteger($include_sections);
				$include_sections = implode(',', $include_sections);
				$where = ' AND a.sectionid IN (' . $include_sections . ')';
			}
			if(strlen($include_categories) > 0){
				$include_categories = explode(',', $include_categories);
				JArrayHelper::toInteger($include_categories);
				$include_categories = implode(',', $include_categories);
				$where = ' AND a.catid IN (' . $include_categories . ')';
			}
			
			$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
			(($showIntro)?'a.introtext,':'') .
								' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
								' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
								' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
								' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
								' FROM #__content AS a' .
								' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
								' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
								' LEFT JOIN #__users AS u ON u.id = a.created_by' .
								' WHERE a.id != '.(int) $article->id .
								' AND a.state = 1' . $where .
								' AND a.access <= ' .(int) $user->get('aid', 0) .
								' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
								' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'.
								' ORDER BY a.hits DESC';
			$db->setQuery($query ,0 , $mostReadCount);
			$temp = $db->loadObjectList();
			if (count($temp)){
				foreach ($temp as $row){
					if (($row->cat_state == 1 || $row->cat_state == '') &&
					($row->sec_state == 1 || $row->sec_state == '') &&
					($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
					($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
						$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
						if($showIntro){
							$row->introtext = $this->getIntroArticle($row->introtext,$charCount,'');
						}
						$mostReadArticles[] = $row;
					}
				}
			}
			unset ($temp);
		}

		if($showCategoryArticles && $categoryArticlesCount){
			$where = ' AND a.catid = '. $article->catid;
			$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
			(($showIntro)?'a.introtext,':'') .
								' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
								' s.published AS sec_state, cc.title AS category, u.username AS author, a.created_by,' .
								' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
								' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
								' FROM #__content AS a' .
								' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
								' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
								' LEFT JOIN #__users AS u ON u.id = a.created_by' .
								' WHERE a.id != '.(int) $article->id .
								' AND a.state = 1' . $where .
								' AND a.access <= ' .(int) $user->get('aid', 0) .
								' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
								' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
			$db->setQuery($query ,0 , $categoryArticlesCount);
			$temp = $db->loadObjectList();
			if (count($temp)){
				foreach ($temp as $row){
					if (($row->cat_state == 1 || $row->cat_state == '') &&
					($row->sec_state == 1 || $row->sec_state == '') &&
					($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
					($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
						$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
						if($showIntro){
							$row->introtext = $this->getIntroArticle($row->introtext,$charCount,'');
						}
						$categoryArticles[] = $row;
					}
				}
			}
			unset ($temp);
		}
		
		$document	= & JFactory::getDocument();
		$document->addStyleSheet(JURI::base(true).'/plugins/content/asuggestions/assets/css/styles.css');

		$lang = & JFactory::getLanguage();
		$lang->load('plg_content_articlesuggestions', JPATH_ADMINISTRATOR);
		$htmlAuthor = '';
		if($showAuthorArticles && $authorArticles){
			$htmlAuthor.='<div class="asTitle">'.JText::_('TITLE_AUTHOR_ARTICLES').'</div><div class="as-wrapper">';
			$i=0;
			foreach($authorArticles as $item){
				$htmlAuthor = $htmlAuthor . (($i)?'<div class="as-content-odd">':'<div class="as-content-even">');
				$htmlAuthor = $htmlAuthor . '<div><a class="as-item-title" href="' . $item->href . '" title="' . $this->escape($item->title) .'">' . $this->escape($item->title) . '</a>';
				if($showHits){
					$htmlAuthor.='<small style="color: #8C0A00;"> (' . $item->hits .  ' Hits)</small>';
				}
				$htmlAuthor = $htmlAuthor . '</div>';
				if($showSection || $showCategory){
					$htmlAuthor.='<div class="as-category-name">';
				}
				if($showSection){
					$htmlAuthor = $htmlAuthor . $this->escape($item->section);
				}
				if($showSection && $showCategory && $item->section && $item->category){
					$htmlAuthor = $htmlAuthor . $this->escape(' > ');
				}
				if($showCategory){
					$htmlAuthor = $htmlAuthor . $this->escape($item->category);
				}
				if($showSection || $showCategory){
					$htmlAuthor.='</div>';
				}
				if($showIntro){
					$htmlAuthor = $htmlAuthor . '<div class="description">' . $this->escape($item->introtext).'</div>';
				}
				$htmlAuthor.='</div>';
				$i=1-$i;
			}
			$htmlAuthor.='</div>';
		}

		$htmlRelated='';
		/** Related Articles **/
		if($showRelatedArticles && $relatedArticles){
			$i=0;
			$htmlRelated = $htmlRelated . '<div class="asTitle">'.JText::_('TITLE_RELATED_ARTICLES').'</div><div class="as-wrapper">';
			foreach($relatedArticles as $item){
				$htmlRelated = $htmlRelated . (($i)?'<div class="as-content-odd">':'<div class="as-content-even">');
				$htmlRelated = $htmlRelated . '<div><a class="as-item-title" href="' . $item->href . '" title="' . $this->escape($item->title) .'">' . $this->escape($item->title) . '</a>';
				if($showHits){
					$htmlRelated.='<small style="color: #8C0A00;"> (' . $item->hits .  ' Hits)</small>';
				}
				$htmlRelated = $htmlRelated . '</div>';
				if($showAvtar != 'none'){
					$htmlRelated = $htmlRelated . '<div class="as-avatar">';
					$htmlRelated = $htmlRelated . $this->getAvatar($item->created_by, $showAvtar);
					$htmlRelated = $htmlRelated . '</div>';
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlRelated = $htmlRelated . '<div class="as-category-name">';
				}
				if($showSection){
					$htmlRelated.=$this->escape($item->section);
				}
				if($showSection && $showCategory && $item->section && $item->category){
					$htmlRelated.=  $this->escape(' > ');
				}
				if($showCategory){
					$htmlRelated.=$this->escape($item->category);
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlRelated = $htmlRelated . '</div>';
				}
				if($showIntro){
					$htmlRelated= $htmlRelated . '<div class="description">' . $this->escape($item->introtext).'</div>';
				}
				if($showAvtar != 'none'){
					$htmlRelated = $htmlRelated . '<div class="as-clear"></div>';
				}
				$htmlRelated.='</div>';
				$i=1-$i;
			}
			$htmlRelated.='</div>';
		}

		$htmlLatest='';
		/** Latest Articles **/
		if($showLatestArticles && $latestArticles){
			$htmlLatest.='<div class="asTitle">'.JText::_('TITLE_LATEST_ARTICLES').'</div><div class="as-wrapper">';
			$i=0;
			foreach($latestArticles as $item){
				$htmlLatest .= (($i)?'<div class="as-content-odd">':'<div class="as-content-even">');
				$htmlLatest = $htmlLatest . '<div><a class="as-item-title" href="' . $item->href . '" title="' . $item->title .'">' . $item->title . '</a>';
				if($showHits){
					$htmlLatest = $htmlLatest . '<small style="color: #8C0A00;"> (' . $item->hits .  ' Hits)</small>';
				}
				$htmlLatest = $htmlLatest . '</div>';
				if($showAvtar != 'none'){
					$htmlLatest = $htmlLatest . '<div class="as-avatar">';
					$htmlLatest = $htmlLatest . $this->getAvatar($item->created_by, $showAvtar);
					$htmlLatest = $htmlLatest . '</div>';
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlLatest = $htmlLatest . '<div class="as-category-name">';
				}
				if($showSection){
					$htmlLatest = $htmlLatest . $this->escape($item->section);
				}
				if($showSection && $showCategory && $item->section && $item->category){
					$htmlLatest = $htmlLatest . $this->escape(' > ') . $this->escape($item->category);
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlLatest = $htmlLatest . '</div>';
				}
				if($showIntro){
					$htmlLatest = $htmlLatest . '<div class="description">' . $this->escape($item->introtext).'</div>';
				}
				if($showAvtar != 'none'){
					$htmlLatest = $htmlLatest . '<div class="as-clear"></div>';
				}
				$htmlLatest = $htmlLatest . '</div>';
				$i=1-$i;
			}
			$htmlLatest = $htmlLatest . '</div>';
		}

		$htmlMostRead='';
		/** Most read Articles **/
		if($showMostReadArticles && $mostReadArticles){
			$htmlMostRead.='<div class="asTitle">'.JText::_('TITLE_MOST_READ_ARTICLES').'</div><div class="as-wrapper">';
			$i=0;
			foreach($mostReadArticles as $item){
				$htmlMostRead = $htmlMostRead . (($i)?'<div class="as-content-odd">':'<div class="as-content-even">');
				$htmlMostRead = $htmlMostRead . '<div><a class="as-item-title" href="' . $item->href . '" title="' . $this->escape($item->title) .'">' . $this->escape($item->title) . '</a>';
				if($showHits){
					$htmlMostRead = $htmlMostRead . '<small style="color: #8C0A00;"> (' . $item->hits .  ' Hits)</small>';
				}
				$htmlMostRead = $htmlMostRead . '</div>';
				if($showAvtar != 'none'){
					$htmlMostRead = $htmlMostRead . '<div class="as-avatar">';
					$htmlMostRead = $htmlMostRead . $this->getAvatar($item->created_by, $showAvtar);
					$htmlMostRead = $htmlMostRead . '</div>';
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlMostRead = $htmlMostRead . '<div class="as-category-name">';
				}
				if($showSection){
					$htmlMostRead = $htmlMostRead . $this->escape($item->section);
				}
				if($showSection && $showCategory && $item->section && $item->category){
					$htmlMostRead = $htmlMostRead . $this->escape(' > ') . $this->escape($item->category);
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlMostRead  = $htmlMostRead . '</div>';
				}
				if($showIntro){
					$htmlMostRead = $htmlMostRead . '<div class="description">' . $this->escape($item->introtext).'</div>';
				}
				if($showAvtar != 'none'){
					$htmlMostRead = $htmlMostRead . '<div class="as-clear"></div>';
				}
				$htmlMostRead = $htmlMostRead . '</div>';
				$i=1-$i;
			}
			$htmlMostRead = $htmlMostRead . '</div>';
		}

		$htmlCategoryArticles='';
		/** Category Articles **/
		if($showCategoryArticles && $categoryArticles){
			$htmlCategoryArticles.='<div class="asTitle">'.JText::_('TITLE_CATEGORY_ARTICLES').'</div><div class="as-wrapper">';
			$i=0;
			foreach($categoryArticles as $item){
				$htmlCategoryArticles = $htmlCategoryArticles . (($i)?'<div class="as-content-odd">':'<div class="as-content-even">');
				$htmlCategoryArticles = $htmlCategoryArticles . '<div><a class="as-item-title" href="' . $item->href . '" title="' . $this->escape($item->title) .'">' . $this->escape($item->title) . '</a>';
				if($showHits){
					$htmlCategoryArticles = $htmlCategoryArticles . '<small style="color: #8C0A00;"> (' . $item->hits .  ' Hits)</small>';
				}
				$htmlCategoryArticles = $htmlCategoryArticles . '</div>';
				if($showAvtar != 'none'){
					$htmlCategoryArticles = $htmlCategoryArticles . '<div class="as-avatar">';
					$htmlCategoryArticles = $htmlCategoryArticles . $this->getAvatar($item->created_by, $showAvtar);
					$htmlCategoryArticles = $htmlCategoryArticles . '</div>';
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlCategoryArticles = $htmlCategoryArticles . '<div class="as-category-name">';
				}
				if($showSection){
					$htmlCategoryArticles = $htmlCategoryArticles . $this->escape($item->section);
				}
				if($showSection && $showCategory && $item->section && $item->category){
					$htmlCategoryArticles = $htmlCategoryArticles . $this->escape(' > ') . $this->escape($item->category);
				}
				if($showSection || $showCategory && ($item->section || $item->category)){
					$htmlCategoryArticles  = $htmlCategoryArticles . '</div>';
				}
				if($showIntro){
					$htmlCategoryArticles = $htmlCategoryArticles . '<div class="description">' . $this->escape($item->introtext).'</div>';
				}
				if($showAvtar != 'none'){
					$htmlCategoryArticles = $htmlCategoryArticles . '<div class="as-clear"></div>';
				}
				$htmlCategoryArticles = $htmlCategoryArticles . '</div>';
				$i=1-$i;
			}
			$htmlCategoryArticles = $htmlCategoryArticles . '</div>';
		}
		
		$html = "";
		if($jquery_enabled){
			JPluginHelper::importPlugin( 'corejoomla' );
			$dispatcher =& JDispatcher::getInstance();
			$dispatcher->trigger('onCallIncludeJQuery', array(array("jquery","jqueryui")));
			
			$script = 'jQuery(document).ready(function($){jQuery("#plgsuggestions").tabs();})';
			$document->addScriptDeclaration( $script );
			
			$html_header =  '<ul>';
			$html_tabs = '';
			$lang = & JFactory::getLanguage();
			$lang->load('plg_content_articlesuggestions', JPATH_ADMINISTRATOR);
			
			foreach($tab_order as $order){
				switch ($order) {
					case 'A':
				    	if($showAuthorArticles && $authorArticles){
				    		$html_header = $html_header.'<li><a href="#plgastab-1">'.JText::_('LBL_AUTHOR_ARTICLES').'</a></li>';
				    		$html_tabs = $html_tabs . '<div id="plgastab-1">'.$htmlAuthor.'</div>';
				    	}
						break;
					case 'R':
				    	if($showRelatedArticles && $relatedArticles){
				    		$html_header = $html_header.'<li><a href="#plgastab-2">'.JText::_('LBL_RELATED_ARTICLES').'</a></li>';
				    		$html_tabs = $html_tabs . '<div id="plgastab-2">'.$htmlRelated.'</div>';
				    	}
						break;
					case 'L':
				    	if($showLatestArticles && $latestArticles){
				    		$html_header = $html_header.'<li><a href="#plgastab-3">'.JText::_('LBL_LATEST_ARTICLES').'</a></li>';
				    		$html_tabs = $html_tabs . '<div id="plgastab-3">'.$htmlLatest.'</div>';
				    	}
						break;
					case 'M':
		    			if($showMostReadArticles && $mostReadArticles){
				    		$html_header = $html_header.'<li><a href="#plgastab-4">'.JText::_('LBL_MOST_READ_ARTICLES').'</a></li>';
				    		$html_tabs = $html_tabs . '<div id="plgastab-4">'.$htmlMostRead.'</div>';
				    	}
						break;
					case 'C':
		    			if($showCategoryArticles && $categoryArticles){
				    		$html_header = $html_header.'<li><a href="#plgastab-5">'.JText::_('LBL_ARTICLES_IN_THIS_CATEGORY').'</a></li>';
				    		$html_tabs = $html_tabs . '<div id="plgastab-5">'.$htmlCategoryArticles.'</div>';
				    	}
						break;
				}
			}
		    $html_header = $html_header.'</ul>';
		    $html = '<div id="plgsuggestions">'.$html_header.$html_tabs.'</div>';
		}else{
			jimport('joomla.html.pane');
			$pane =& JPane::getInstance('tabs', array('startOffset'=>0));
			$html . "<div style=\"clear: both;\"></div>";
			$html .= $pane->startPane( 'pane' );
			
			foreach($tab_order as $order){
				switch ($order) {
					case 'A':
						if($showAuthorArticles && $authorArticles){
							$html .= $pane->startPanel( JText::_('LBL_AUTHOR_ARTICLES'), 'panel1' );
							$html .= $htmlAuthor;
							$html .= $pane->endPanel();
						}
						break;
					case 'R':
						if($showRelatedArticles && $relatedArticles){
							$html .= $pane->startPanel( JText::_('LBL_RELATED_ARTICLES'), 'panel2' );
							$html .= $htmlRelated;
							$html .= $pane->endPanel();
						}
						break;
					case 'L':
						if($showLatestArticles && $latestArticles){
							$html .= $pane->startPanel( JText::_('LBL_LATEST_ARTICLES'), 'panel3' );
							$html .= $htmlLatest;
							$html .= $pane->endPanel();
						}
						break;
					case 'M':
						if($showMostReadArticles && $mostReadArticles){
							$html .= $pane->startPanel( JText::_('LBL_MOST_READ_ARTICLES'), 'panel4' );
							$html .= $htmlMostRead;
							$html .= $pane->endPanel();
						}
						break;
					case 'C':
		    			if($showCategoryArticles && $categoryArticles){
							$html .= $pane->startPanel( JText::_('LBL_ARTICLES_IN_THIS_CATEGORY'), 'panel5' );
							$html .= $htmlCategoryArticles;
							$html .= $pane->endPanel();
				    	}
						break;
				}
			}
			$html .= $pane->endPane();
		}

		$article->text .= $html;
	}

	function getIntroArticle( $text, $length=150, $tags='' ) {
		return trim(substr(strip_tags($text), 0, 150)).'...';
	}

	function getAvatar( $userid, $useAvatarFrom, $height='48', $username='name' ){
		$db	   =& JFactory::getDBO();
		$avatar = '';
		switch ( $useAvatarFrom ){
			case 'jomsocial':
				$jspath = JPATH_BASE.DS.'components'.DS.'com_community';
				include_once($jspath.DS.'libraries'.DS.'core.php');

				// Get CUser object
				$jsuser =& CFactory::getUser($userid);
				$usrname = $jsuser->$username;
				$avatarLoc = $jsuser->getThumbAvatar();
				$link = CRoute::_('index.php? option=com_community&view=profile&userid='.$userid.'&Itemid='.JRequest::getInt('Itemid'));
				$avatar = '<a href="'.$link.'"><img class="hasTip" style="border: 1px solid #cccccc; height: '.$height.'px;" src="'.$avatarLoc.'" alt="'.$usrname.'"  title="'.$usrname.'"/></a>';
				break;
			case 'cb':
				$strSql = "SELECT `avatar`, firstname FROM #__comprofiler WHERE `user_id`='{$userid}' AND `avatarapproved`='1'";
				$db->setQuery($strSql);
				$result = $db->loadObject();
				$link = JRoute::_( 'index.php?option=com_comprofiler&amp;task=userProfile&amp;user=' . $userid);
				if($result && !empty($result->avatar)) {
					$avatarLoc = JURI::base(true)."/images/comprofiler/".$result->avatar;
				} else {
					$avatarLoc = JURI::base(true)."/components/com_comprofiler/plugin/templates/default/images/avatar/nophoto_n.png";
				}
				$avatar = '<a href="'.$link.'"><img src="'.$avatarLoc.'" class="hasTip" style="border: 1px solid #cccccc; height: '.$height.'px;" alt="'.$result->firstname.'" title="'.$result->firstname.'"/></a>';
				break;
			case 'touch':
				$avatarLoc = JURI::base(true) . '/index2.php?option=com_community&amp;controller=profile&amp;task=avatar&amp;width=' . $height . '&amp;height=' . $height . '&amp;user_id=' . $userid . '&amp;no_ajax=1';
				$avatar = '<img src="' . $avatarLoc . '" style="border: 1px solid #cccccc; height: ' . $height . 'px;" alt=""/>';
				$link = JRoute::_("index.php?option=com_community&view=profile&user_id={$userid}&Itemid=".JRequest::getInt('Itemid'));
				$avatar = '<a href="' . $link . '">' . $avatar . '</a>';
				break;
			case 'kunena':
				$query = "SELECT a.avatar, b." . $username . " FROM #__fb_users as a" .
                        " LEFT JOIN #__users as b on b.id=a.userid where a.userid=".$userid;
				$db->setQuery( $query );
				$kunenaUser = $db->loadObject();
				$kunena_avtar = @$kunenaUser->avatar;
				$kunena_avtars = JURI::base(true) . '/images/fbfiles';
				if ($kunena_avtar != '') {
					if(!file_exists( JPATH_ROOT .'/images/fbfiles/avatars/l_' . $kunena_avtar)) {
						$avatarLoc = $kunena_avtars . '/avatars/' . $kunena_avtar;
					}
					else {
						$avatarLoc = $kunena_avtars . '/avatars/l_' . $kunena_avtar;
					}
				}
				else $avatarLoc = $kunena_avtars . '/avatars/nophoto.jpg';
				//URL
				$usrname = ($kunenaUser->$username)?$kunenaUser->$username:JText::_('GUEST');
				$link = JRoute::_( 'index.php?option=com_kunena&amp;func=fbprofile&amp;userid=' . $userid);
				$avatar = '<a href="'.$link.'" title="'.$usrname.'"><img src="'.$avatarLoc.'" class="hasTip" style="border: 1px solid #cccccc; height: '.$height.'px;" alt="'.$usrname.'"/></a>';
				break;
			case 'aup':
				$api_AUP = JPATH_SITE.DS.'components'.DS.'com_alphauserpoints'.DS.'helper.php';
				if ( file_exists($api_AUP)) {
					require_once ($api_AUP);
					$avatar = AlphaUserPointsHelper::getAupAvatar($userid, 1, $height, $height);
				}
			case 'none':
			default:
				$avatar = '';
		}
		return $avatar;
	}

	/**
	 * Escapes a value for output in a view script.
	 *
	 * If escaping mechanism is one of htmlspecialchars or htmlentities, uses
	 * {@link $_encoding} setting.
	 *
	 * @param  mixed $var The output to escape.
	 * @return mixed The escaped value.
	 */
	function escape($var){
		if (in_array($this->_escape, array('htmlspecialchars', 'htmlentities'))) {
			return call_user_func('htmlspecialchars', $var, ENT_COMPAT, 'UTF-8');
		}
		return call_user_func('htmlspecialchars', $var);
	}
}
?>
