<?php
/**
 * @version             $Id: jquery.php revision date lasteditedby $
 * @package             Joomla
 * @subpackage  Content
 * @copyright   Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
 * @license             GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.
 */

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

/**
 * Example system plugin
 */
class plgCoreJoomlaJQuery extends JPlugin{
	/**
	 * Constructor
	 *
	 * For php4 compatibility we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	function plgCoreJoomlaJQuery( &$subject, $config ){
		parent::__construct( $subject, $config );
	}

	/**
	 * Do something onAfterInitialise 
	 */
	function onCallIncludeJQuery($params){
		static $init_cjquery_load = false;
		if($init_cjquery_load == true){
			return false;
		}
		$plugin =& JPluginHelper::getPlugin('corejoomla', 'jquery');
		$pluginParams = new JParameter( $plugin->params );
		$document = &JFactory::getDocument();
		$document->setGenerator($document->getGenerator().'; Joomla jQuery plugin by http://www.corejoomla.com');
		
		switch ($pluginParams->get('use_cdn')) {
			case '1':
				if(in_array('jquery', $params) || $pluginParams->get('jquery')){
					$document->addScript('http://ajax.googleapis.com/ajax/libs/jquery/1.4.2/jquery.min.js');
					$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery.noconflict.js');
					
					if(in_array('jqueryui', $params) || $pluginParams->get('jqueryui')){
						$theme = trim($pluginParams->get('jqueryui-theme'));
						$document->addScript('http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.4/jquery-ui.min.js');
						$document->addStyleSheet('http://ajax.googleapis.com/ajax/libs/jqueryui/1.8.4/themes/'.$theme.'/jquery-ui.css');
					}
					if(in_array('jqueryform', $params) || $pluginParams->get('jqueryform')){
						$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery.form.min.js');
					}
				}
				break;
			default:
				if(in_array('jquery', $params) || $pluginParams->get('jquery')){
					$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery-1.4.2.min.js');
					$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery.noconflict.js');
					
					if(in_array('jqueryui', $params) || $pluginParams->get('jqueryui')){
						$theme = trim($pluginParams->get('jqueryui-theme'));
						$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery-ui-1.8.4.custom.min.js');
						$document->addStyleSheet(JURI::root( true ).'/plugins/corejoomla/jquery/themes/'.$theme.'/jquery-ui-1.8.4.custom.css');
					}
					if(in_array('jqueryform', $params) || $pluginParams->get('jqueryform')){
						$document->addScript(JURI::root( true ).'/plugins/corejoomla/jquery/jquery.form.min.js');
					}
				}
				break;
		}
		$init_cjquery_load = true;
	}
}