<?php 
/* 
* @author CoreJoomla
* Email : support@corejoomla.com
* URL : http://www.corejoomla.com
* Description : CoreJoomla Related Articles plugin displays articles related to the currently loaded article based on the title instead of metadata.
**/
/// no direct access 
defined('_JEXEC') or die('Restricted access'); 

jimport( 'joomla.event.plugin' );

class plgContentRelatedArticles extends JPlugin{

	function plgContentRelatedArticles( &$subject, $params ){
        parent::__construct( $subject, $params );
    }
    
	function onPrepareContent( &$article, &$params ){
        if((JRequest::getVar('view')) != 'article'){
            return true;
        }
		//Get parameters 
		//Show or hide header
		$showheader = $this->params->get('showheader'); 
		//Show or hide leaderboard
		$showleaderboard = $this->params->get('showleaderboard'); 
		//Show or hide section
		$showsection = $this->params->get('showsection'); 
		//Show or hide category
		$showcategory = $this->params->get('showcategory'); 
		//Show or hide user name
		$showauthor = $this->params->get('showauthor'); 
		//Show username or name
		$username = $this->params->get('username'); 
		//List of keywords seperated by comma to be excluded from searching.
		$filterkeywords = $this->params->get('filterkeywords'); 
		
		$user = &JFactory::getUser();
		$db = &JFactory::getDBO();
		$date =& JFactory::getDate();
		$now=$date->toMySQL();
		$nullDate=$db->getNullDate();
		$htmlRelated='';
		
		$keys = explode(' ', $article->title);
		$count = "0";
		$keywords = "";
		foreach ($keys as $key){
			$key = trim($key);
			if(!stristr(','.$filterkeywords.',', ','.$key.',')){
				if (strlen($key)>=2) {
					if($count === "0"){
						$keywords = 'CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
					}else{
						$keywords .= ' OR CONCAT("^", REPLACE(a.title," ","^"),"^") LIKE "%^' . $db->getEscaped($key) . '^%"';
					}
					$count++;
				}
			}
		}
		if (strlen($keywords)>0 && $article->id){
			$relatedArticles = array();
			$query = 'SELECT a.id, a.alias, a.title, a.sectionid, a.hits,'.
					' s.title AS section, a.catid, cc.access AS cat_access, s.access AS sec_access, cc.published AS cat_state,'.
					' s.published AS sec_state, cc.title AS category, u.'.$username.' AS username, a.created_by,' .
					' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
					' CASE WHEN CHAR_LENGTH(cc.title) THEN CONCAT_WS(":", cc.id, cc.title) ELSE cc.id END as catslug'.
					' FROM #__content AS a' .
					' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
					' LEFT JOIN #__sections AS s ON s.id = a.sectionid' .
					' LEFT JOIN #__users AS u ON u.id = a.created_by' .
					' WHERE a.id != '.(int) $article->id .
					' AND a.state = 1'.
					' AND a.access <= ' .(int) $user->get('aid', 0) .
					' AND ( '.$keywords.' )' .
					' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )' .
					' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';
	
			$db->setQuery($query ,0 , $relatedCount);
			$temp = $db->loadObjectList();
			if (count($temp)){
				foreach ($temp as $row){
					if (($row->cat_state == 1 || $row->cat_state == '') &&
								($row->sec_state == 1 || $row->sec_state == '') &&
								($row->cat_access <= $user->get('aid', 0) || $row->cat_access == '') &&
								($row->sec_access <= $user->get('aid', 0) || $row->sec_access == '')){
						$row->href = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
						$relatedArticles[] = $row;
					}
				}
			}
			unset ($temp);
			
			/** Related Articles **/
			$htmlRelated.='';
			if(!empty($relatedArticles)){
				$htmlRelated.='<table width="100%" border="0" cellpadding="5px">';
				$i=1;
				foreach($relatedArticles as $item){
					$htmlRelated .= "<tr>";
					if($showleaderboard){
						$htmlRelated=$htmlRelated.'<td width="25px">'.$i.'</td>';
					}
					$htmlRelated = $htmlRelated.'<td><a href="'.$item->href.'" title="'.$this->escape($item->title).'">'.$this->escape($item->title).'</a></td>';
					if($showsection){
						$htmlRelated=$htmlRelated.'<td>'.$this->escape($item->section).'</td>';
					}
					if($showcategory){
						$htmlRelated=$htmlRelated.'<td>'.$this->escape($item->category).'</td>';
					}
					if($showauthor){
						$htmlRelated=$htmlRelated.'<td>'.$this->escape($item->username).'</td>';
					}
					$htmlRelated.='</tr>';
					$i++;
				}
				$htmlRelated.='</table>';
			}
			$article->text .= $htmlRelated;
		}
	} 
	
    function escape($var){
        if (in_array($this->_escape, array('htmlspecialchars', 'htmlentities'))) {
            return call_user_func('htmlspecialchars', $var, ENT_COMPAT, 'UTF-8');
        }

        return call_user_func('htmlspecialchars', $var);
    }
} 
?>