<?php
/**
 * @version $Id: plgCommunityJomSocialPolls.php 1.5
 * @copyright CoreJoomla
 * @license GNU/GPLv2,
 * @author CoreJoomla - http://www.corejoomla.com
 */
 
defined('_JEXEC') or die('Restricted access');
require_once( JPATH_ROOT.DS.'components'.DS.'com_community'.DS.'libraries'.DS.'core.php');
require_once JPATH_ADMINISTRATOR.DS.'components'.DS.'com_communitypolls'.DS.'helpers'.DS.'constants.php';
require_once JPATH_ROOT.DS.'components'.DS.'com_communitypolls'.DS.'helpers'.DS.'helper.php';
require_once JPATH_ROOT.DS.'components'.DS.'com_communitypolls'.DS.'helpers'.DS.'cpauthorization.php';
 
class plgCommunityPolls extends CApplications{
 
	function plgCommunityPolls(& $subject, $config){
		parent::__construct($subject, $config);
	}
	
	function onProfileDisplay(){
		$config	=& CFactory::getConfig();
		$this->loadUserParams();
 
		$uri		= JURI::base();
		$my			=& JFactory::getUser();
		$user		=& CFactory::getActiveProfile();
		
		$chartType = intval($this->userparams->get('charttype'));
		$chartHeight = intval($this->userparams->get('chartheight'));
		$custompolls = trim($this->userparams->get('custompolls'));
		
		plgCommunityPolls::populateJcpConfig(false);
		
		$temp = str_replace(',','',$custompolls);
		if((!empty($custompolls) && !is_numeric($temp)) || !is_numeric($chartHeight) || (((int)$chartHeight) > 250)){
			$content="Invalid values in configuration. Please check application settings.";
		}else{
			$poll = &plgCommunityPolls::getPoll($user);
			if($poll){
				if(!CPAuthorization::authorize('com_communitypolls','manage','polls','all')) {
					//do nothing
				}else if(!isset($poll) || $poll->id <= 0) {
					JError::raiseError( 403, JText::_('Access Forbidden') );
					return;
				}else if($user->guest || $poll->created_by != $user->id) {
        	if($poll->published != 1) {
          	JError::raiseError( 403, JText::_('Access Forbidden') );
          	return;
					}
				}
				$document	= & JFactory::getDocument();
				$document->addStyleSheet(JURI::base(true).'/plugins/community/polls/js_styles.css');
				$document->addScript( JURI::base(true) . '/plugins/community/polls/js_scripts.js' );
				$content=plgCommunityPolls::getContentText($poll,$chartType,$chartHeight);
			}else{
				$content='No polls found';
			}
		}
		return $content; 
	}
	
	function getContentText($poll,$chartType,$chartHeight){
		global $jcp_config;
		$content = '<div id="jsCpMainWrapper">';
		$content .= '<div class="jsCpTitle">'.plgCommunityPolls::escape($poll->title);
		$content .= '<div class="jsCpDescription">'.$poll->description.'</div></div>';
		
		$content.=plgCommunityPolls::getJavaScriptContent($poll,$chartType);
		$content.='<div id="jsCpForm">';
		foreach($poll->options as $cpoption){
			$content.='<div class="jsCpOption"'.((!$poll->eligible)?' style="display:none;"':'').'>';
			$content.='<label><input type="'.$poll->type.'" name="jsCpOption[]" value="'.$cpoption->id.'">'.plgCommunityPolls::escape($cpoption->title).'</label>';
			$content.='</div>';
		}
		if($poll->eligible){
			$content.='<div class="jsCpNavigation">';
			$content.='<a href="#" onclick="javascript: jsCpAjxCastVote(); return false;">'.JText::_('Vote').'</a>';
			if($jcp_config[ALLOW_PREVIEW] == '1'){
				$content.='<a href="#" onclick="javascript: jsCpAjxCastVote(); return false;">'.JText::_('Preview').'</a>';
			}
			$content.='<img src="'.JURI::base(true) . '/plugins/community/polls/spinner.gif" alt="Loading..." id="jsCpLoading" style="visibility: hidden;">';
			$content.='</div>';
		}
		$content.='</div>';
		
		$content.='<div id="jsCpContent"'.(($poll->eligible)?' style="display:none;"':'').'>';
		$content.=plgCommunityPolls::getCharts($poll,$chartType,$chartHeight);
		$content.='</div>';
		
		$content.='</div>';
		return $content;
	}
	
	function getJavaScriptContent($poll,$chartType){
		$content='
		<script type="text/javascript">
			function jsCpAjxCastVote(){
			    optionid = jsGetSelectedValue();
			    if(optionid == null){
			        alert("Please select your choice.");
			        return;
			    }
			    document.getElementById(\'jsCpLoading\').style.display = \'\';
			
			    var ajaxObj = new Ajax ("'.JURI::base().'index.php?option=com_communitypolls&controller=polls&task=ajxvote&id='.$poll->id.'&option_id=" + optionid, {
			        method: "GET"
			    });
			
			    ajaxObj.addEvent(\'onComplete\', function (data) {
			        try //Internet Explorer
			        {
			            xmlDoc=new ActiveXObject("Microsoft.XMLDOM");
			            xmlDoc.async="false";
			            xmlDoc.loadXML(data);
			        }
			        catch(e)
			        {
			            try //Firefox, Mozilla, Opera, etc.
			            {
			                parser=new DOMParser();
			                xmlDoc=parser.parseFromString(data,"text/xml");
			            }
			            catch(e) {alert(e.message)}
			        }
			        var cp_options =xmlDoc.getElementsByTagName(\'options\').item(0);
			        if(cp_options == null){
			            cp_options = xmlDoc.getElementsByTagName(\'errormsg\').item(0);
			            var cp_error = cp_options.childNodes[0].nodeValue;
			            document.getElementById(\'jsCpLoading\').style.display = \'none\';
			            alert(cp_error);
			            return;
			        }';
	        if($chartType == '0'){
	            $content.='jsUpdateBarChart(cp_options, \'Votes\');';
	        }else if($chartType == '1'){
	            $content.='jsUpdatePieChart(cp_options,\'Loading result. Please wait...\');';
	        }
			    $content.='    
			        jsUpdateWrapper();
			    });
			
			    // this initiates the call
			    ajaxObj.request();
			}
		</script>';
		return $content;
	}
	
	function getCharts($poll,$chartType,$chartHeight){
		global $jcp_config;
		$colors = 'B2DBF9|F7C01B|90BD0C|D45049|089191|FFEBCC|5FD8A5|E72D29|0957B7|FEFECC';
    $content='';
		if($jcp_config[CHART_COLORS]){
		    $colors = $jcp_config[CHART_COLORS];
		}
		if($chartType == '0'){
	    $i = 1;
	    $id = 1;
	    $colorsArray = explode('|', $colors);
	    foreach($poll->options as $cp_coption){
		    $color = $colorsArray[($id-1)%count($colorsArray)];
		    $content.=
		    '<div style="width: 99%">
		        <div class="optiontitle">
		            <span>'.plgCommunityPolls::escape($cp_coption->title).'</span>
		            <span id="jsCpVote'.$id.'" style="font-weight: bold;">(' . $cp_coption->votes . ' ' . JText::_('votes') . ')</span>
		        </div>
		        <div class="poll_option'.$i.'">
		            <span style="float: right;" id="percent'.$id.'">'.$cp_coption->percent.'%</span>
		            <div id="jsCpOption'.$id.'" style="width:'.$cp_coption->percent.'%; background-color:#'.$color.';"></div>
		        </div>
		        <div style="clear: both;"></div>
		    </div>';
		    $i = $i%5 + 1;
		    $id = $id + 1;
	    }
		}else if($chartType == '1'){
	    $data = '';
	    $labels = '';
	    $height = 150;
	    if($chartHeight){
	        $height = $chartHeight;
	    }
	    $width=$height * 3;
	    $dimentions = $width . 'x' . $height;
	
	    $colorsArray = explode('|', $colors);
	    $i=0;
	    $colors = '';
	    foreach($poll->options as $cp_coption){
	        $percent = round($cp_coption->percent);
	        $data .= $percent . ',';
	        $labels .= $percent . '%|';
	        $colors .= $colorsArray[$i%count($colorsArray)] . ',';
	        $i++;
	    }
	    $data = substr($data, 0, strlen($data) - 1);
	    $labels = substr($labels, 0, strlen($labels) - 1);
	    $colors = substr($colors, 0, strlen($colors) - 1);
	    $content.='
	    <div style="text-align: center" id="jsCpPieWrapper">
	        <img 
	        	id="jsCpPie" 
	        	src="http://chart.apis.google.com/chart?chs='.$dimentions.'&amp;chd=t:'.$data.'&amp;cht=p3&amp;chl='.$labels.'&amp;chco='.$colors.'"
	            alt="'.$poll->title.'" />
	    </div>
	    <table class="resulttable" width="100%">
	        <thead>
	            <tr>
	                <td class="leftarc"></td>
	                <td width="40%">'.JText::_('Option').'</td>
	                <td width="50px">'.JText::_('Votes').'</td>
	                <td width="50px">'.JText::_('Percent').'</td>
	                <td width="40%" class="rightarc"></td>
	            </tr>
	        </thead>
	        <tbody>';
	    $i=0;
	    foreach($poll->options as $cp_coption){
	    	$content.='
	        <tr>
	            <td><div class="roundedbox" style="background-color:#'.$colorsArray[$i%count($colorsArray)].'"></div></td>
	            <td>'.plgCommunityPolls::escape($cp_coption->title).'</td>
	            <td id="jsCpVotes'.$i.'" align="center">'.plgCommunityPolls::escape($cp_coption->votes).'</td>
	            <td id="jsCpPercent'.$i.'" align="center">'.plgCommunityPolls::escape($cp_coption->percent) . '%"</td>
	            <td><div class="bar-wrapper"><div id="jsCpBar'.$i.'" class="bar" style="width:'.plgCommunityPolls::escape($cp_coption->percent).'%;">&nbsp;</div></div></td>
	        </tr>';
				$i++;
	    }
    	$content.='
	        </tbody>
	    </table>';
		}
		return $content;
	}
	
	function &getPoll($user){
		global $jcp_config;
		$date				= &JFactory::getDate();
		$now				= $date->toMySQL();
		$randnum		= '';
		$db					= &JFactory::getDBO();
			
		$where[] = 'p.published = 1';
		if($custompolls){
			$where[] = 'p.id IN (' . $custompolls . ')';
			$randnum = plgCommunityPolls::getRandomNumber($db,$custompolls);
		}else{
			$randnum = plgCommunityPolls::getRandomNumber($db,null);
		}
		$where[] = 'p.created_by='.$user->id;
		$where = ( count( $where ) ?  ' AND ' . implode( ' AND ', $where ) : '' );
		
		$queryStub = 'SELECT p.id, p.title, p.votes, p.published,p.close_date,p.description,p.type,' .
			' CASE WHEN CHAR_LENGTH(p.alias) THEN CONCAT_WS(":", p.id, p.alias) ELSE p.id END as slug,' .
			' c.title AS category, u.' . $jcp_config[USER_NAME] . ' AS username FROM ' . TABLE_JCP_POLLS .
			' p LEFT JOIN ' . TABLE_JCP_CATEGORIES . ' c ON p.category = c.id ' . 
			' LEFT JOIN #__users u ON p.created_by = u.id WHERE p.id';
		if($custompolls){
			$query = $queryStub  . '=' .$randnum . $where . ' LIMIT 1';
		}else{
			$query = $queryStub  . '>' .$randnum . $where . ' LIMIT 1';
		}
		$db->setQuery($query);
		$poll = $db->loadObject();
		
		if(!$poll){
			if($custompolls){
				$query = $queryStub  . '!=' .$randnum . $where . ' LIMIT 1';
			}else{
				$query = $queryStub  . '<=' .$randnum . $where . ' LIMIT 1';
			}
		  $db->setQuery($query);
			$poll = $db->loadObject();
		}
		if($poll){
			$query = 'SELECT id,title,votes FROM ' . TABLE_JCP_OPTIONS . ' WHERE poll_id=' . $poll->id;
			$db->setQuery($query);
			$options = $db->loadObjectList();
			$poll->options = $options;
			$poll->eligible = plgCommunityPolls::traceEligibility($poll,false, $jcp_config);
      $total_votes= $poll->votes;
      for ($i = 0; $i < count( $poll->options ); $i++) {
          $vote =& $poll->options[$i];
          if ($total_votes > 0) {
              $vote->percent  = round( 100 * $vote->votes / $total_votes, 1 );
          }else {
              $vote->percent	= 0;
          }
      }
			return $poll;
		}else{
			return null;
		}
	}
	
	function getRandomNumber(&$db, $custom){
		if($custom){
			$nums = explode(',',$custom);
			return array_rand($nums);
		}else{
			$query = "SELECT max(id) AS max_id FROM ". TABLE_JCP_POLLS;
			$db->setQuery($query);
			$maxid = $db->loadResult();
			$random_number = mt_rand(1, $maxid);
			return $random_number;
		}
	}
	
  function traceEligibility($poll, $skipDB=true) {
  	global $jcp_config;
    $app = &JFactory::getApplication();
    $user =& JFactory::getUser();
    $db =& JFactory::getDBO();
    if(!$poll->id) {
        return false;
    }

    // Check if the poll is closed for voting.
    if($poll->close_date) {
        $todays_date = date("Y-m-d");
        $today = strtotime($todays_date);
        $close_date = strtotime($poll->close_date);
        if($close_date < $today) {
            return false;
        }
    }

    if($user->guest){
        if($jcp_config[VOTE_RESTRICTION_METHOD] == 'cookie' || $jcp_config[VOTE_RESTRICTION_METHOD] == 'both') {
            $cookieName	= JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll->id );
            if(isset($_COOKIE[$cookieName])) {
                return false;
            }
        }

        if(!$skipDB){
            if($jcp_config[VOTE_RESTRICTION_METHOD] == 'ip' || $jcp_config[VOTE_RESTRICTION_METHOD] == 'both') {
                $query = "SELECT COUNT(*) FROM " . TABLE_JCP_GUEST_VOTES . " WHERE poll_id=" .
                        $poll->id . " AND ip_address=" . $db->Quote(PollsHelper::getUserIP());
                $db->setQuery($query);
                $count = $db->loadResult();
                if($count > 0) {
                    return false;
                }
            }
        }
    }else{
        if($jcp_config[VOTE_RESTRICTION_METHOD] == 'cookie' || $jcp_config[VOTE_RESTRICTION_METHOD] == 'both') {
            $cookieName	= JUtility::getHash( $app->getName() . COOKIE_PREFIX . $poll->id );
            if(isset($_COOKIE[$cookieName])) {
                return false;
            }
        }
        if(!$skipDB){
            $query = 'SELECT COUNT(*) FROM ' . TABLE_JCP_VOTES . ' WHERE poll_id=' .
                    $poll->id . ' AND voter_id=' . $user->id;
            $db->setQuery($query);
            $count = $db->loadResult();
            if($count > 0) {
                return false;
            }
        }
    }

    return true;
  }
  
  function escape($var){
  	return htmlentities($var, ENT_COMPAT, 'UTF-8');
  }

  function populateJcpConfig($skip=true) {
    global $jcp_config;
    $app = &JFactory::getApplication();
    $jcp_config = $app->getUserState( SESSION_JCP_CONFIG );

    if(!isset($jcp_config) || $skip) {
        $db =& JFactory::getDBO();
        $query = 'SELECT config_name, config_value FROM '. TABLE_JCP_CONFIG;
        $db->setQuery($query);
        $configt = $db->loadObjectList();

        foreach($configt as $ct) {
            $jcp_config[$ct->config_name] = $ct->config_value;
        }
        $app->setUserState( SESSION_JCP_CONFIG, $jcp_config );
    }
  }
}
?>